package COM.ibm.corba.tutorial1.example1;


public class AccountsTest
{
    public static void
    main(String args[])
    {
	if (args.length != 3) {
	    System.err.println("Usage: AccountsTest initialCheckingBalance " +
			       "initialSavingsBalance changeAmount");
	    System.exit(1);
	}

	// Use the command line to create initial balances and change amount.
	float initialCheckingBalance = Float.valueOf(args[0]).floatValue();
	float initialSavingsBalance = Float.valueOf(args[1]).floatValue();
	float changeAmount = Float.valueOf(args[2]).floatValue();

	// Activate the accounts using "new"
	Account checkingAccount = new AccountImpl(initialCheckingBalance);
	Account savingsAccount = new AccountImpl(initialSavingsBalance);

	// Test account methods.
	showAccount(checkingAccount);
	checkingAccount.deposit(changeAmount);
	showAccount(checkingAccount);
	checkingAccount.withdrawal(changeAmount);
	showAccount(checkingAccount);

	showAccount(savingsAccount);
	savingsAccount.deposit(changeAmount);
	showAccount(savingsAccount);
	savingsAccount.withdrawal(changeAmount);
	showAccount(savingsAccount);
    }


    public static void
    showAccount(Account account)
    {
	System.out.println();
	System.out.println("Account: " + account);
	System.out.println("Balance: " + account.getBalance());
    }
}
