package COM.ibm.corba.tutorial1.example2;

import java.io.*;
import java.lang.*;
import java.net.*;
import java.util.*;

import COM.ibm.corba.*;
import COM.ibm.corba.IIOP.*;

public class Transfer
{
    public static String serverName = null;
    public static String serverPort = null;

    public static void main(String args[])
    {
        switch (args.length) {

        case 4:
            serverName = args[0];
            serverPort = args[1];
            String account = args[2];
	        float amount = Float.valueOf(args[3]).floatValue();

            transferFunds(account, amount);
            break;

        default:
            System.err.println("Usage: DoTransfer serverName " +
                   "serverPort accountNameTo transferAmount");
        }
    }

    public static void transferFunds(String account, float amount)
    {
        String hostURL = new String("IIOP://"+serverName+":"+serverPort);
        Account checking = null;
        Account savings = null;

        ORB client = CORBA.ORB_init(null);
        checking = (Account)client.URLToObject(hostURL+
            ";/Checking" + 
            "?COM.ibm.corba.tutorial1.example2.Account" );
        savings = (Account)client.URLToObject(hostURL+
            ";/Savings" + 
            "?COM.ibm.corba.tutorial1.example2.Account" );
        System.out.println("Current checking balance " + checking.getBalance());
        System.out.println("Current savings  balance " + savings.getBalance());
        System.out.print("Transfering " + amount );
        if (account.equals("checking")) {
        	System.out.println(" from savings to checking");
        	savings.withdrawal(amount);
        	checking.deposit(amount);
        } else {
        	System.out.println(" from checking to savings");
        	checking.withdrawal(amount);
            savings.deposit(amount);
        }
        System.out.println("New checking balance " + checking.getBalance());
        System.out.println("New savings  balance " + savings.getBalance());
        client.close();
    }
}




