package COM.ibm.jaws.app.trs.trswin2;
import java.awt.*;
import java.util.*;
import java.applet.*;
import com.roguewave.widgets.*;
// zpb_begin UserImports
// zpb_end

/**
 * Class Calendar.
 *
 *
 * @author    Bryce Curtis
 * @version   2.0 11/21/96 8:49:23am
 * @copyright IBM
 */
public
class Calendar extends Dialog {

	private static Applet applet;
	Label pMonth, pStatic7, pStatic6, pStatic5, pStatic4, pStatic3, pStatic2,
pStatic1;
	Button pPrevMonth, pNextMonth;

	// Initial size in logical units
	Dimension initialSize = new Dimension(190, 140);
	Point initialLocation;
	// zpb_begin CalendarUserVars

    String monthStr[] = {
        new String("Jan"),
        new String("Feb"),
        new String("Mar"),
        new String("Apr"),
        new String("May"),
        new String("Jun"),
        new String("Jul"),
        new String("Aug"),
        new String("Sep"),
        new String("Oct"),
        new String("Nov"),
        new String("Dec")
    };

    int numDays = 30;               // number of days in month
    int startDay = 1;               //(0=sun, 6=sat)

    Date finalDate = new Date();    // date selected by user
    Date orgDate;                   // original date
    Button dateButton;              // button text to be changed

	// zpb_end

	// zpb_begin CalendarJavadocConstructor
    /**
     * Creates a specialized Panel with the specified app and frame.
     */
	 // zpb_end
	Calendar(Applet app, Frame parent, String title, boolean modal) {
		super(parent, title, modal);
		applet = app;
		setResizable(false);

		// zpb_begin CalendarConstructor_1

        //System.out.println("Entering Calendar()...");
        initialSize = new Dimension(190, 140);

		// zpb_end

		setFont(new Font("Helvetica", Font.PLAIN, 11));
		LogFontLayout lfLayout = new LogFontLayout(this);
		setLayout(lfLayout);

		pPrevMonth = new Button("<");
		add("40 5 10 10", pPrevMonth);
		pMonth = new Label("Sep 1996");
		pMonth.setAlignment(Label.CENTER);
		add("55 5 69 12", pMonth);
		pMonth.setFont(new Font("Helvetica", Font.BOLD, 15));
		pNextMonth = new Button(">");
		add("130 5 10 10", pNextMonth);
		pStatic7 = new Label("Sat");
		pStatic7.setAlignment(Label.CENTER);
		add("155 25 25 12", pStatic7);
		pStatic6 = new Label("Fri");
		pStatic6.setAlignment(Label.CENTER);
		add("130 25 25 12", pStatic6);
		pStatic5 = new Label("Thur");
		pStatic5.setAlignment(Label.CENTER);
		add("105 25 25 12", pStatic5);
		pStatic4 = new Label("Wed");
		pStatic4.setAlignment(Label.CENTER);
		add("80 25 25 12", pStatic4);
		pStatic3 = new Label("Tue");
		pStatic3.setAlignment(Label.CENTER);
		add("55 25 25 12", pStatic3);
		pStatic2 = new Label("Mon");
		pStatic2.setAlignment(Label.CENTER);
		add("30 25 25 12", pStatic2);
		pStatic1 = new Label("Sun");
		pStatic1.setAlignment(Label.CENTER);
		add("5 25 25 12", pStatic1);
		// zpb_begin CalendarConstructor_2
		// zpb_end

		// Size and Position in logical units
		initialLocation = lfLayout.du(15, 28);

		pack();
		move(initialLocation.x, initialLocation.y);

		// zpb_begin CalendarConstructor_3
        //System.out.println("Exiting Calendar()");
		// zpb_end
	}

	// zpb_begin CalendarJavadocMinimumSize
    /**
     * @return  Returns a Dimension with the minimum width and height
     *          of this container.
     */
	 // zpb_end
	public Dimension minimumSize() {
		// zpb_begin CalendarMinimumSize
		// zpb_end

		LayoutManager layoutMgr = getLayout();
		if (layoutMgr instanceof LogFontLayout) {
			// Convert from logical units to absolute coordinates
			int w = initialSize.width;
			int h = initialSize.height;
			LogFontLayout layout = (LogFontLayout)layoutMgr;
			return new Dimension(layout.duX(w), layout.duY(h));
		}
		return new Dimension(initialSize);
	}

	// zpb_begin CalendarJavadocHandleEvent
    /**
     * Handle events that occur with components in this container.
     *
     * @return  Returns a boolean which specifies whether the event
     *          handler should stop at this level or continue up the
     *          parent hierarchy.
     */
	// zpb_end
	public boolean handleEvent(Event e) {
		if (e.id == Event.WINDOW_DESTROY) {
			// zpb_begin CalendarDestroy
			// zpb_end
			dispose();
			return true;
		}

		// zpb_begin CalendarHandleEvent
		// zpb_end

		return super.handleEvent(e);
	}

	// zpb_begin CalendarJavadocAction
    /**
     * Action handling routine.
     *
     * @return  Returns a boolean specifying whether the event should be handled
     *          furthur up the parent hierarchy.
     */
	// zpb_end
	public boolean action(Event evt, Object obj) {

		if (evt.target == pPrevMonth) {
			// zpb_begin CalendarPrevMonthClicked
            System.out.println("Calendar: < Clicked");
            prevMonth();
			// zpb_end
		}
		else if (evt.target == pNextMonth) {
			// zpb_begin CalendarNextMonthClicked
            System.out.println("Calendar: > Clicked");
            nextMonth();
			// zpb_end
		}

		// zpb_begin CalendarAction

		// zpb_end

		return false;
	}


	// zpb_begin CalendarUserMethods

    // Tell calendar what date to show first
    public void setDate(Date d) {
        finalDate.setYear( d.getYear() );
        finalDate.setMonth( d.getMonth() );
        finalDate.setDate( d.getDate() );
        orgDate = d;
        setLabel();
    }

    // Tell calendar what button from calling frame to put date on
    public void setButton(Button l) {
        dateButton = l;
    }

    // Draw month and year at top of calendar
    public void setLabel() {
        pMonth.setText(monthStr[finalDate.getMonth()] + "  " + Integer.toString(finalDate.getYear()+1900));
    }

    // Go to the next month
    public void nextMonth() {
        if (finalDate.getMonth() == 11) {
            finalDate.setMonth( 0 );
            finalDate.setYear( finalDate.getYear() + 1);
        }
        else
            finalDate.setMonth( finalDate.getMonth() + 1);
        setLabel();
        repaint();
    }

    // Go to the previous month
    public void prevMonth() {
        if (finalDate.getMonth() == 0) {
            finalDate.setMonth( 11 );
            finalDate.setYear( finalDate.getYear() - 1);
        }
        else
            finalDate.setMonth( finalDate.getMonth() - 1);
        setLabel();
        repaint();
    }

    // Draw dates of calendar
    public void paint(Graphics g) {
        Dimension d = size();
        g.setColor(Color.white);
        g.fillRect(10,70,d.width-20,d.height-100); // border
        g.setColor(Color.black);

        //System.out.println("Calendar: Entering paint()");
        int month = finalDate.getMonth();
        int year = finalDate.getYear();
        int orgyear = orgDate.getYear();
        int orgmonth = orgDate.getMonth();
        int orgday = orgDate.getDate();
        Date date = new Date(year, month, 1);
        if ((month == 0) || (month == 2) || (month == 4) ||
           (month == 6) || (month == 7) || (month == 9))
          numDays = 31;
        else if (month == 1) {
          if ((year % 4) == 0)
            numDays = 29;
          else
            numDays = 28;
        }
        else
          numDays = 30;

        startDay = date.getDay();
        int x, y, dayOfWeek;
        for (int i=1; i<=numDays; i++) {
           dayOfWeek = (i-1 + startDay) % 7;
           x = 20+ 10 + dayOfWeek * (35+2);
           y = 65+ 25 + ((i-1+startDay) / 7) * (25-2);
           if ((dayOfWeek == 0) || (dayOfWeek == 6))
              g.setColor(Color.red);
           else
              g.setColor(Color.black);
           //System.out.println("cur="+month+" "+i+" "+year);
           if ((orgday == i) && (orgmonth == month) && (orgyear == year)) {
              g.setColor(Color.blue);
              g.fillRect(x-5,y-25+10,25,20);
              g.setColor(Color.white);
           }
           g.drawString(Integer.toString(i), x, y);
        }
        //System.out.println("Org Date= " + orgDate);
        //System.out.println("Calendar: Exiting paint()");
    }

    // If mouse pressed on calendar somewhere
    public boolean mouseDown( Event e, int mx, int my) {
        //System.out.println("Calendar: Pressed "+ "(x="+e.x+"y="+e.y+")");
        int x, y;
        x = (e.x - 5-20) / (35+2);
        y = (e.y - 5-65)/ (25-2);
        int day = y * 7 + x - startDay + 1;
        if ((day > 0) && (day <= numDays)) {
            System.out.println("Calendar: Valid Date =" + day);
            finalDate.setDate( day );
            orgDate.setDate( day );
            orgDate.setYear( finalDate.getYear() );
            orgDate.setMonth( finalDate.getMonth() );
            dateButton.setLabel( getDateString(orgDate) );

// IF DATE OUTSIDE OF DATABASE FOR DEMO, TELL USER
if ((orgDate.after(new Date(97,0,7))) || (orgDate.before(new Date(97,0,1)))) {
    RCommon.showDateMsg();
}

            dispose();
            //return false;
        }
        return true;
    }

    // Convert date to a string of mmm dd, yyyy
    public String getDateString(Date d) {
        //System.out.println("getDateString = " + d);
        String ds = "";
        if (d.getMonth() == 0)
            ds = "Jan";
        else if (d.getMonth() == 1)
            ds = "Feb";
        else if (d.getMonth() == 2)
            ds = "Mar";
        else if (d.getMonth() == 3)
            ds = "Apr";
        else if (d.getMonth() == 4)
            ds = "May";
        else if (d.getMonth() == 5)
            ds = "Jun";
        else if (d.getMonth() == 6)
            ds = "Jul";
        else if (d.getMonth() == 7)
            ds = "Aug";
        else if (d.getMonth() == 8)
            ds = "Sep";
        else if (d.getMonth() == 9)
            ds = "Oct";
        else if (d.getMonth() == 10)
            ds = "Nov";
        else if (d.getMonth() == 11)
            ds = "Dec";
        ds = ds + " " + Integer.toString(d.getDate());
        ds = ds + ",  " + Integer.toString(d.getYear()+1900);
        return (ds);
    }
	// zpb_end
}
