package COM.ibm.jaws.app.trs.trswin2;
import java.awt.*;
import java.util.*;
import java.applet.*;
import com.roguewave.widgets.*;
// zpb_begin UserImports
// zpb_end

/**
 * Class DateMsg.
 *
 *
 * @author    Bryce Curtis
 * @version   2.0 11/21/96 8:48:57am
 * @copyright IBM
 */
public
class DateMsg extends Frame {

	private static Applet applet;
	Label pStatic1, pStatic2;
	Button pButton1;

	// Initial size in logical units
	Dimension initialSize = new Dimension(300, 95);
	Point initialLocation;
    /**
     * Creates a specialized window with the specified app and title.
     */
	 // zpb_end
	DateMsg(Applet app, String title) {
		super(title);
		applet = app;

		//RCommon.windowList.addElement(this);

		setBackground(Color.lightGray);
		setFont(new Font("Helvetica", Font.PLAIN, 12));
		LogFontLayout lfLayout = new LogFontLayout(this);
		setLayout(lfLayout);

		pStatic1 = new Label("No Data for Date Selected");
		add("10 10 145 12", pStatic1);
		pStatic1.setFont(new Font("Helvetica", Font.BOLD, 15));
		pStatic1.setForeground(Color.blue);
		pStatic2 = new Label("There is only trip data entered from 1/1/97 to 1/7/97 for this demo.");
		add("25 35 153 12", pStatic2);
		pStatic2.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pButton1 = new Button("OK");
		add("140 70 32 15", pButton1);

		// Size and Position in logical units
		initialLocation = lfLayout.du(15, 28);

		pack();
		move(initialLocation.x, initialLocation.y);

	}

    /**
     * @return  Returns a Dimension with the minimum width and height
     *          of this container.
     */
	 // zpb_end
	public Dimension minimumSize() {
		LayoutManager layoutMgr = getLayout();
		if (layoutMgr instanceof LogFontLayout) {
			// Convert from logical units to absolute coordinates
			int w = initialSize.width;
			int h = initialSize.height;
			LogFontLayout layout = (LogFontLayout)layoutMgr;
			return new Dimension(layout.duX(w), layout.duY(h));
		}
		return new Dimension(initialSize);
	}

    /**
     * Handle events that occur with components in this container.
     *
     * @return  Returns a boolean which specifies whether the event
     *          handler should stop at this level or continue up the
     *          parent hierarchy.
     */
	public boolean handleEvent(Event e) {
		if (e.id == Event.WINDOW_DESTROY) {
			// zpb_begin PleaseWaitDestroy
			//RCommon.windowList.removeElement(this);
			// zpb_end
			dispose();
			return true;
		}
		return super.handleEvent(e);
	}

    /**
     * Action handling routine.
     *
     * @return  Returns a boolean specifying whether the event should be handled
     *          furthur up the parent hierarchy.
     */
	public boolean action(Event evt, Object obj) {

		if (evt.target == pButton1) {
			dispose();
			return false;
		}
		return false;
	}

}
