package COM.ibm.jaws.app.trs.trswin2;
import java.awt.*;
import java.util.*;
import java.applet.*;
import com.roguewave.widgets.*;
// zpb_begin UserImports

import mlsoft.mct.*;
import COM.ibm.jaws.models.trs.*;
import java.net.*;
/**
* To use this routine:
* 	new up a trip object
*	new up EditTrip (this runs the constructor)
*	call EditTrip.setTrip(trip object)
*	call EditTrip.show()
*/

// zpb_end

/**
 * Class EditTrip.
 *
 *
 * @author    Bryce Curtis
 * @version   2.0 11/21/96 1:28:47pm
 * @copyright IBM
 */
public
class EditTrip extends Frame {

	private static Applet applet;
	Hashtable menuitems = new Hashtable();

	// Initial size in logical units
	Dimension initialSize = new Dimension(350, 245);
	Point initialLocation;
	// zpb_begin EditTripUserVars

    	MlTabPanel tabPanel;                			// Tab panel
       	EditTripGeneralPanel wGeneralPage = null;		// General panel
       	EditTripOriginationPanel wOriginationPage = null;	// Orig Flight panel
       	EditTripDestinationPanel wDestinationPage = null;	// Dest Flight panel
       	EditTripCarPanel wCarPage = null;			// Car Rental panel
       	EditTripHotelPanel wHotelPage = null;			// Hotel panel
       	EditTripSummaryPanel wSummaryPage = null;		// Summary panel
       	ProfileCardPanel wProfilePage = null;			// Preferences panel
	String currentPage = "General";				// Panel that is currently showing
	String currentProfilePage = "General";			// Panel that is currently showing in profile

    	boolean sReturn = false;				// true=select seat for destination flight
    	boolean sLeave = false;					// true=select seat for origination flight

	Trip trip = null;					// reference to remote trip object

	boolean refreshOriginationPage = false;			// indicates which panel needs
	boolean refreshDestinationPage = false;			//   to be refreshed due to a
	boolean refreshCarPage = false;				//   changed in the trip (modified
	boolean refreshHotelPage = false;			//   by the General panel)
	boolean refreshSummaryPage = false;
	boolean refreshProfilePage = false;

	boolean makeReservation = false;			// should reservation be made?
        boolean skipSummary = false;
	boolean enableProfile = true;

        boolean tripModified = false;

	// zpb_end

	// zpb_begin EditTripJavadocConstructor
	/**
	 * Creates a specialized window with the specified app and title.
	 */
	 // zpb_end
	EditTrip(Applet app, String title) {
		super(title);
		applet = app;

		// zpb_begin EditTripConstructor_1
		//setCursor(Frame.WAIT_CURSOR);
		RCommon.windowList.addElement(this);
		if (RCommon.userId.equals("Unknown")) {
		    enableProfile = false;
		}
		// zpb_end

		setBackground(Color.lightGray);
		setFont(new Font("Helvetica", Font.PLAIN, 12));
		LogFontLayout lfLayout = new LogFontLayout(this);
		setLayout(lfLayout);


		// Add the MenuBar, Menus, and Menuitems
		MenuBar mbMenu1 = new MenuBar();
		MenuItem mi;
		Menu mFile = new Menu("File");
		menuitems.put("File", mFile);
                mi=new MenuItem("Close");
		mFile.add(mi);
                menuitems.put("FileClose",mi);
		mbMenu1.add(mFile);
		Menu mView = new Menu("View");
		menuitems.put("View", mView);
		mi=new MenuItem("Origination City Info");
		mView.add(mi);
		menuitems.put("ViewOriginationCityInfo",mi);
		mi=new MenuItem("Origination Weather");
		mView.add(mi);
		menuitems.put("ViewOriginationWeather",mi);
		mi=new MenuItem("Origination Airport");
		mView.add(mi);
		menuitems.put("ViewOriginationAirport",mi);
		mView.add(new MenuItem("-"));
		mi=new MenuItem("Destination City Info");
		mView.add(mi);
		menuitems.put("ViewDestinationCityInfo",mi);
		mi=new MenuItem("Destination Weather");
		mView.add(mi);
		menuitems.put("ViewDestinationWeather",mi);
                mi=new MenuItem("Destination Airport");
		mView.add(mi);
                menuitems.put("ViewDestinationAirport",mi);
		mbMenu1.add(mView);
		Menu mHelp = new Menu("Help");
		menuitems.put("Help", mHelp);
		mi=new MenuItem("Contents");
		mHelp.add(mi);
		menuitems.put("HelpContents",mi);
		mi=new MenuItem("Search...");
		mHelp.add(mi);
		menuitems.put("HelpSearch",mi);
		mHelp.add(new MenuItem("-"));
		mi=new MenuItem("About...");
		mHelp.add(mi);
		menuitems.put("HelpAbout",mi);
		mbMenu1.add(mHelp);
		this.setMenuBar(mbMenu1);
		// zpb_begin EditTripConstructor_2

		// Create new panels
        	wGeneralPage = new EditTripGeneralPanel(applet, this);
        	wGeneralPage.setFont(new Font("Helvetica", Font.PLAIN, 12));
        	wOriginationPage = new EditTripOriginationPanel(applet, this);
        	wOriginationPage.setFont(new Font("Helvetica", Font.PLAIN, 12));
        	wDestinationPage = new EditTripDestinationPanel(applet, this);
        	wDestinationPage.setFont(new Font("Helvetica", Font.PLAIN, 12));
        	wCarPage = new EditTripCarPanel(applet, this);
        	wCarPage.setFont(new Font("Helvetica", Font.PLAIN, 12));
        	wHotelPage = new EditTripHotelPanel(applet, this);
        	wHotelPage.setFont(new Font("Helvetica", Font.PLAIN, 12));
        	wSummaryPage = new EditTripSummaryPanel(applet, this);
        	wSummaryPage.setFont(new Font("Helvetica", Font.PLAIN, 12));
		if (enableProfile) {
        	    wProfilePage = new ProfileCardPanel(applet, this);
        	    wProfilePage.setFont(new Font("Helvetica", Font.PLAIN, 12));
		}

        	tabPanel = new MlTabPanel();
        	tabPanel.setValue("marginWidth", 5);

	        tabPanel.add("General", wGeneralPage);
        	tabPanel.add("Orig Flight", wOriginationPage);
        	tabPanel.add("Dest Flight", wDestinationPage);
        	tabPanel.add("Car Rental", wCarPage);
        	tabPanel.add("Hotel", wHotelPage);
        	tabPanel.add("Summary", wSummaryPage);
		if (enableProfile) {
        	    tabPanel.add("Preferences", wProfilePage);
		}
        	add("5 25 335 180", tabPanel);

		// zpb_end

		// Size and Position in logical units
		initialLocation = lfLayout.du(1, 1);

		pack();
		move(initialLocation.x, initialLocation.y);

		// zpb_begin EditTripConstructor_3

		// zpb_end
	}

	// zpb_begin EditTripJavadocMinimumSize
	/**
	 * @return  Returns a Dimension with the minimum width and height
	 *          of this container.
	 */
	 // zpb_end
	public Dimension minimumSize() {
		// zpb_begin EditTripMinimumSize
		// zpb_end

		LayoutManager layoutMgr = getLayout();
		if (layoutMgr instanceof LogFontLayout) {
			// Convert from logical units to absolute coordinates
			int w = initialSize.width;
			int h = initialSize.height;
			LogFontLayout layout = (LogFontLayout)layoutMgr;
			return new Dimension(layout.duX(w), layout.duY(h));
		}
		return new Dimension(initialSize);
	}

	// zpb_begin EditTripJavadocHandleEvent
	/**
	 * Handle events that occur with components in this container.
	 *
	 * @return  Returns a boolean which specifies whether the event
	 *          handler should stop at this level or continue up the
	 *          parent hierarchy.
	 */
	// zpb_end
	public boolean handleEvent(Event e) {
		if (e.id == Event.WINDOW_DESTROY) {
			// zpb_begin EditTripDestroy

                        // If "Unknown" user, then don't save anything
                        //   Delete old one (really just cancel reservations -
                        //   still assigned to "Unknown" user
                        if (RCommon.userId.equals("Unknown")) {
                            trip.cancel();
                            //trip.cancelDepartureFlightReservation();
                            //trip.cancelReturnFlightReservation();
                            //trip.cancelHotelReservation();
                            //trip.cancelCarReservation();
                            //trip.setStatus("Cancelled");
                        }

                        else {
                            // Save data to server
                            System.out.println("EditTrip: Logged on - saving data");
                            saveData();

                            if (makeReservation) {
                		// send reservation request to server
/*
				int origAirRow = wOriginationPage.selectedRow;
				String origAirSeat = wOriginationPage.seat.getText();
				int destAirRow  = wDestinationPage.selectedRow;
	            		String destAirSeat = wDestinationPage.seat.getText();
	    			int carRow = wCarPage.selectedRow;
				int hotelRow = wHotelPage.selectedRow;
				float origPrice = 0;
				float destPrice = 0;
				float carPrice = 0;
				float hotelPrice = 0;
				String s;

				if (origAirRow > -1) {
				    s = (String)wOriginationPage.grid.getCellValue(origAirRow, 5, "cellString");
            	    		    origPrice = Float.valueOf(s.substring(1)).floatValue();
				}
				if (destAirRow > -1) {
				    s = (String)wDestinationPage.grid.getCellValue(destAirRow, 5, "cellString");
            	    		    destPrice = Float.valueOf(s.substring(1)).floatValue();
				}
				if (carRow > -1) {
				    s = (String)wCarPage.grid.getCellValue(carRow, 3, "cellString");
            	    		    carPrice = Float.valueOf(s.substring(1)).floatValue();
				}
				if (hotelRow > -1) {
				    s = (String)wHotelPage.grid.getCellValue(hotelRow, 4, "cellString");
            	    		    hotelPrice = Float.valueOf(s.substring(1)).floatValue();
				}
*/
				PayForIt pay = new PayForIt(applet, this, "Select Payment for Trip '" + trip.getName() + "'", false);
    				pay.setInfo(trip);
				pay.show();
				pay.toFront();
				return false;
                            }
                        }

			RCommon.windowList.removeElement(this);

			// If list of trips is up, then update screen
			if (RCommon.wTripList != null) {
			    RCommon.wTripList.getData();
			}

			// zpb_end
			dispose();
			return true;
		}

		// zpb_begin EditTripHandleEvent

        	// Message sent from logon dialog when successfully logged on
        	else if (e.id == RCommon.loginOk) {
            		System.out.println("EditTrip: loginOk event received in handleEvent()!");
			makeReservation = true;

                        // Change owner of trip

                        // Copy trip to new one
                        Trip newTrip = RCommon.user.addTrip(
                                trip.getName(),
                                trip.getDepartureCity().getName(),
                                trip.getDestinationCity().getName(),
                                trip.getDepartureDate(),
                                trip.getReturnDate());

                        FlightReservation departFlightRes = trip.getDepartureFlightReservation();
                        FlightReservation returnFlightRes = trip.getReturnFlightReservation();
                        HotelReservation hotelRes = trip.getHotelReservation();
                        CarReservation carRes = trip.getCarReservation();

                        CarFleet carFleet = null;
                        if (carRes != null) {
                            carFleet = carRes.getCarFleet();
                        }
                        RoomGroup roomGroup = null;
                        if (hotelRes != null) {
                            roomGroup = hotelRes.getRoomGroup();
                        }
                        Flight departFlight = null;
                        String departSeat = "";
                        if (departFlightRes != null) {
                            departFlight = departFlightRes.getFlight();
                            departSeat = departFlightRes.getSeat();
                        }
                        Flight returnFlight = null;
                        String returnSeat = "";
                        if (returnFlightRes != null) {
                            returnFlight = returnFlightRes.getFlight();
                            returnSeat = returnFlightRes.getSeat();
                        }

                        // Delete old one (really just cancel reservations - still assigned
                        // to "Unknown" user
                        trip.cancel();
                        //trip.cancelDepartureFlightReservation();
                        //trip.cancelReturnFlightReservation();
                        //trip.cancelHotelReservation();
                        //trip.cancelCarReservation();
                        //trip.setStatus("Cancelled");

                        // Point to new trip and add reservations
                        trip = newTrip;
                        if (carFleet != null) {
                            trip.reserveCar(carFleet, 1);
                        }
                        if (roomGroup != null) {
                            trip.reserveHotel(roomGroup, 1);
                        }
                        if (departFlight != null) {
                            trip.reserveDepartureFlight(departFlight, 1, departSeat);
                        }
                        if (returnFlight != null) {
                            trip.reserveReturnFlight(returnFlight, 1, returnSeat);
                        }

            		Event re = new Event(this, 0, Event.WINDOW_DESTROY, 0, 0, 0, 0);
            		handleEvent(re);
        	}

        	else if (e.id == RCommon.reservationOk) {
            		System.out.println("EditTrip: reservationOk event received in handleEvent()!");
			RCommon.windowList.removeElement(this);

			// If list of trips is up, then update screen
			if (RCommon.wTripList != null) {
			    RCommon.wTripList.getData();
			}

			dispose();
			return true;
        	}

		// zpb_end

		return super.handleEvent(e);
	}

	// zpb_begin EditTripJavadocAction
	/**
	 * Action handling routine.
	 *
	 * @return  Returns a boolean specifying whether the event should be handled
	 *          furthur up the parent hierarchy.
	 */
	// zpb_end
	public boolean action(Event evt, Object obj) {
		if (evt.target instanceof MenuItem) {
                        if (menuitems.get("FileClose") == evt.target) {
				// zpb_begin EditTripFileCancelSelection
                                Event e = new Event(this, 0, Event.WINDOW_DESTROY, 0, 0, 0, 0);
                                handleEvent(e);
				if (1==1) return false;
				// zpb_end
				System.exit(0);
			}
			else if (menuitems.get("ViewOriginationCityInfo") == evt.target) {
				// zpb_begin EditTripViewOriginationCityInfoSelection
                                URL nURL = trip.getDepartureCity().getURL();
                                System.out.println("URL = " + nURL);
	    			if (!RCommon.appl)
                                    applet.getAppletContext().showDocument(nURL, "_TOP");
				// zpb_end
			}
			else if (menuitems.get("ViewOriginationWeather") == evt.target) {
				// zpb_begin EditTripViewOriginationWeatherSelection
                                URL nURL = trip.getDepartureCity().getWeatherURL();
                                System.out.println("URL = " + nURL);
	    			if (!RCommon.appl)
                                    applet.getAppletContext().showDocument(nURL, "_TOP");
				// zpb_end
			}
			else if (menuitems.get("ViewOriginationAirport") == evt.target) {
				// zpb_begin EditTripViewOriginationAirportSelection
                                FlightReservation departFlight = trip.getDepartureFlightReservation();
                                if (departFlight != null) {
                                    URL nURL = departFlight.getFlight().getFlightPlan().getDepartureAirport().getURL();
                                    System.out.println("URL = " + nURL);
                                    if (!RCommon.appl) {
                        	    	applet.getAppletContext().showDocument(nURL, "_TOP");
				    }
				}
				// zpb_end
			}
			else if (menuitems.get("ViewDestinationCityInfo") == evt.target) {
				// zpb_begin EditTripViewDestinationCityInfoSelection
                                URL nURL = trip.getDestinationCity().getURL();
                                System.out.println("URL = " + nURL);
	    			if (!RCommon.appl)
                                    applet.getAppletContext().showDocument(nURL, "_TOP");
				// zpb_end
			}
			else if (menuitems.get("ViewDestinationWeather") == evt.target) {
				// zpb_begin EditTripViewDestinationWeatherSelection
                                URL nURL = trip.getDestinationCity().getWeatherURL();
                                System.out.println("URL = " + nURL);
	    			if (!RCommon.appl)
                                    applet.getAppletContext().showDocument(nURL, "_TOP");
				// zpb_end
			}
                        else if (menuitems.get("ViewDestinationAirport") == evt.target) {
                                // zpb_begin EditTripViewDestinationAirportSelection
                                FlightReservation returnFlight = trip.getReturnFlightReservation();
                                if (returnFlight != null) {
                                    URL nURL = returnFlight.getFlight().getFlightPlan().getDepartureAirport().getURL();
                                    System.out.println("URL = " + nURL);
                                    if (!RCommon.appl) {
                        	    	applet.getAppletContext().showDocument(nURL, "_TOP");
				    }
				}
				// zpb_end
			}
			else if (menuitems.get("HelpContents") == evt.target) {
				// zpb_begin EditTripHelpContentsSelection
                		RCommon.help(applet, "EditTrip");
				// zpb_end
			}
			else if (menuitems.get("HelpSearch") == evt.target) {
				// zpb_begin EditTripHelpSearchSelection
                		RCommon.notImplemented(applet);
				// zpb_end
			}
			else if (menuitems.get("HelpAbout") == evt.target) {
				// zpb_begin EditTripHelpAboutSelectionCreate
                		RCommon.helpAbout(applet);
				// zpb_end
				// zpb_begin EditTripHelpAboutSelection
				// zpb_end
			}

			return false;
		}



		// zpb_begin EditTripAction
        	else if (evt.target == tabPanel) {
		        String oldPage = currentPage;
			System.out.println("TripList: tabPanel " + obj);
			currentPage = (String)obj;
			System.out.println("New page = " + currentPage);
			RCommon.waitCursor();
			// Save data of page being left
			if (oldPage.equals("General")) {
			    System.out.println("old page = General");
			    wGeneralPage.saveData();
			    setTitle("Editing Trip '" + trip.getName() + "'");
			}
			else if (oldPage.equals("Orig Flight")) {
			    wOriginationPage.saveData();
			}
			else if (oldPage.equals("Dest Flight")) {
			    wDestinationPage.saveData();
			}
			else if (oldPage.equals("Car Rental")) {
			    wCarPage.saveData();
			}
			else if (oldPage.equals("Hotel")) {
			    wHotelPage.saveData();
			}
			else if (oldPage.equals("Preferences")) {
			    wProfilePage.saveData();
			}

			// Get data for new page
			if (currentPage.equals("Orig Flight")) {
			    if (refreshOriginationPage)
				wOriginationPage.getData();
			}
			else if (currentPage.equals("Dest Flight")) {
			    if (refreshDestinationPage)
				wDestinationPage.getData();
			}
			else if (currentPage.equals("Car Rental")) {
			    if (refreshCarPage)
				wCarPage.getData();
			}
			else if (currentPage.equals("Hotel")) {
			    if (refreshHotelPage)
				wHotelPage.getData();
			}
			else if (currentPage.equals("Summary")) {
			    if (refreshSummaryPage)
				wSummaryPage.getData();
			}
			else if (currentPage.equals("Preferences")) {
			    if (refreshProfilePage)
				wProfilePage.getData();
			}
			RCommon.defaultCursor();
		}


		if (evt.target == wSummaryPage.pDoIt) {
            		// User must logon to make reservation
			RCommon.waitCursor();
            		if (RCommon.userId.equals("Unknown")) {
                		System.out.println("ReserveList: Not logged on");
                		RCommon.wLogin= new Login(applet, this, "User Login", true);
                		RCommon.wLogin.show();
                                RCommon.defaultCursor();
                		return false;
            		}
			makeReservation = true;
            		Event e = new Event(this, 0, Event.WINDOW_DESTROY, 0, 0, 0, 0);
            		handleEvent(e);
            		return false;
		}

		// zpb_end

		return false;
	}


	// zpb_begin EditTripUserMethods
    	/**
    	*******************************************************
    	* Override the show() method to only show if a trip is defined
    	*******************************************************
    	*/
	public void show() {
	    System.out.println("Show");
	    if (trip == null) {
            	Event re = new Event(this, 0, Event.WINDOW_DESTROY, 0, 0, 0, 0);
            	handleEvent(re);
	    }
	    else
		super.show();
	}
    	/**
    	*******************************************************
    	* Set trip to be edited
    	*******************************************************
    	*/
	public void setTrip(Trip t) {
	    // If trip is not valid, then close window
	    if (t == null) {
       	    	RCommon.destroyPleaseWait();
		System.out.println("Could not set trip");
		return;
	    }
	    trip = t;
	    wGeneralPage.getData();			// Get data for 1st panel
	    setTitle("Editing Trip '" + trip.getName() + "'");
       	    RCommon.destroyPleaseWait();		// remove wait dialog

	    // Set flags to refresh all pages
	    refreshOriginationPage = true;
	    refreshDestinationPage = true;
	    refreshCarPage = true;
	    refreshHotelPage = true;
	    refreshSummaryPage = true;
	    refreshProfilePage = true;
	}

	/**
    	*******************************************************
    	* Get data from server
    	*******************************************************
    	*/
    	public void getData() {
	    // call getData functions of all embedded cards
	    wGeneralPage.getData();
	    wOriginationPage.getData();
	    wDestinationPage.getData();
	    wCarPage.getData();
	    wHotelPage.getData();
	    if (enableProfile)
	        wProfilePage.getData();
    	}

    	/**
    	*******************************************************
    	* Save data to server
    	*******************************************************
    	*/
    	public void saveData() {
	    // call saveData functions of all embedded cards
            if (tripModified) {
System.out.println("saveData:: tripModified");
                wGeneralPage.saveData();
                wOriginationPage.saveData();
                wDestinationPage.saveData();
                wCarPage.saveData();
                wHotelPage.saveData();
                if (enableProfile)
                    wProfilePage.saveData();
                if (trip.getStatus().equals("Confirmed")) {
                    RCommon.reservationsCancelled();
System.out.println("  reservation cancelled");
                }
                trip.setStatus("Pending");
            }
    	}



/*
NOTE:  If the user has a reservation, and the trip is modified, then
it needs to be put into the pending state again.
*/
	// zpb_end
}
