package COM.ibm.jaws.app.trs.trswin2;
import java.awt.*;
import java.util.*;
import java.applet.*;
import com.roguewave.widgets.*;
// zpb_begin UserImports
import mlsoft.mct.*;
import java.net.*;
import COM.ibm.jaws.models.trs.*;
import COM.ibm.jaws.mofw.*;
// zpb_end

/**
 * Class EditTripCarPanel.
 *
 *
 * @author    Bryce Curtis
 * @version   2.0 11/21/96 1:28:54pm
 * @copyright IBM
 */
public
class EditTripCarPanel extends Panel {
	Label pStatic1;
	Choice pTypeOfCar;
	Button pLeft, pRight;
	private Applet applet = null;
	private Frame  frame  = null;

	// Initial size in logical units
	Dimension initialSize = new Dimension(335, 165);
	Point initialLocation;
	// zpb_begin EditTripCarPanelUserVars
    	MlGrid grid = null;
	int selectedRow = -1;
	EditTrip parent = null;
  	Iterator cars = null;
	// zpb_end

	// zpb_begin EditTripCarPanelJavadocConstructor
	/**
	 * Creates a specialized Panel with the specified app and frame.
	 */
	 // zpb_end
	EditTripCarPanel(Applet app, Frame frame) {
		applet = app;
		this.frame = frame;
		// zpb_begin EditTripCarPanelConstructor_1
		parent = (EditTrip)frame;
		// zpb_end

		setFont(new Font("Helvetica", Font.PLAIN, 12));
		LogFontLayout lfLayout = new LogFontLayout(this);
		setLayout(lfLayout);

		pStatic1 = new Label("Type of Car:");
		add("15 140 55 12", pStatic1);
		pStatic1.setFont(new Font("Helvetica", Font.BOLD, 15));
		pTypeOfCar = new Choice();
		add("75 140 105 49", pTypeOfCar);
		pTypeOfCar.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pTypeOfCar.setBackground(Color.white);
		pTypeOfCar.addItem("All Types");
		pTypeOfCar.addItem("Compact");
		pTypeOfCar.addItem("Mid-Size");
		pTypeOfCar.addItem("Full-Size");
		pTypeOfCar.addItem("Mini-Van");
		add("75 140 105 49", pTypeOfCar);
		pLeft = new Button("<");
		add("300 150 15 12", pLeft);
		pRight = new Button(">");
		add("315 150 15 12", pRight);
		// zpb_begin EditTripCarPanelConstructor_2
		// zpb_end

		// Size and Position in logical units
		initialLocation = lfLayout.du(5, 5);
		move(initialLocation.x, initialLocation.y);

		// zpb_begin EditTripCarPanelConstructor_3
		// zpb_end
	}

	// zpb_begin EditTripCarPanelRightJavadocPaint
	/**
	 * Paints the Panel.  Add specialized functionality for this Panel
	 * between the paint protect block.
	 */
	// zpb_end
	public void paint(Graphics g) {
		Dimension d = size();
		g.drawRect(0,0,d.width-1,d.height-1); // border
		// zpb_begin EditTripCarPanelPaint
		// zpb_end
	}


	// zpb_begin EditTripCarPanelJavadocHandleEvent
	/**
	 * Handle events that occur with components in this container.
	 *
	 * @return  Returns a boolean which specifies whether the event
	 *          handler should stop at this level or continue up the
	 *          parent hierarchy.
	 */
	// zpb_end
	public boolean handleEvent(Event e) {

		// zpb_begin EditTripCarPanelHandleEvent
		// zpb_end

		return super.handleEvent(e);
	}

	// zpb_begin EditTripCarPanelJavadocAction
	/**
	 * Action handling routine.
	 *
	 * @return  Returns a boolean specifying whether the event should be handled
	 *          furthur up the parent hierarchy.
	 */
	// zpb_end
	public boolean action(Event evt, Object obj) {
		if (evt.target == pLeft) {
			// zpb_begin PanelLeftClicked
			((EditTrip)frame).tabPanel.showPage("Dest Flight");
			// zpb_end
			return false;
		}
		else if (evt.target == pRight) {
			// zpb_begin PanelRightClicked
			((EditTrip)frame).tabPanel.showPage("Hotel");
			// zpb_end
			return false;
		}

		// zpb_begin EditTripCarPanelAction
		else if (evt.target == pTypeOfCar) {
			getData();			// Get new search
			return false;
		}

        	else if (evt.target == grid) {
            		disable();
            		MlGridEvent e = (MlGridEvent) evt;
            		System.out.println("GRID EVENT (" + e.row +","+ e.column +")");
                   	grid.selectRow(e.row, true);

               		// if clicked on select
               		if (e.column == 0) {
            			String s = (String)grid.getCellValue(e.row, 0, "cellString");

				// Deselect current row
				if (s.equals("X")) {
            				grid.setStrings(e.row, " ");
					selectedRow = -1;

					// delete reservation
				}

				// Select current row
				else {
					// Deselect previously selected row
					if (selectedRow != -1)
						grid.setStrings(selectedRow, " ");

                                	// Select new row
					selectedRow = e.row;
            				grid.setStrings(e.row, "X");

					// create reservation
				}
			}

                	// if clicked on company name
                	else if (e.column == 1) {

			        // Find car that corresponds to selected row
		    		cars.reset();
				CarFleet car = null;
				for (int i=0; i<=e.row; i++)
		    		    car = (CarFleet) cars.getNext();

				// Load web page
	    			if (!RCommon.appl) {
                        	    URL nURL = car.getCarRentalCompany().getContact().getURL();
                        	    applet.getAppletContext().showDocument(nURL, "_TOP");
				}
                	}

                	// if clicked on car
                	else if (e.column == 2) {

			        // Find car that corresponds to selected row
		    		cars.reset();
				CarFleet car = null;
				for (int i=0; i<=e.row; i++)
		    		    car = (CarFleet) cars.getNext();

				// Show image
	                   	Picture wPicture= new Picture(applet, frame, "Picture of " + car.getCar().getName(), true);
                    		wPicture.pTitle.setText(car.getCar().getName());
                    		wPicture.getImage(car.getCar().getImage());
                    		wPicture.show();
                	}
            	}
		enable();
		// zpb_end

		return false;
	}


	// zpb_begin EditTripCarPanelUserMethods

	/**
    	*******************************************************
    	* Get data from server
    	*******************************************************
    	*/
	public void getData() {
		System.out.println("EditTripCarPanel::getData()");
	        RCommon.waitCursor();
		boolean exists = false;
	        if (grid != null) {
		    remove(grid);
		    exists = true;
		}

        	MlResources res;
        	res = new MlResources();
        	grid = new MlGrid();
        	grid.setValue("layoutFrozen", true);

        	res.add("allowColumnResize", true);
        	res.add("selectionPolicy", "SELECT_SINGLE_ROW");
        	//res.add("horizontalSizePolicy", "SIZE_TO_FIT");
        	//res.add("hsbDisplayPolicy", "DISPLAY_ALWAYS");
        	res.add("headingRows", 1);
        	res.add("columns", 5);
        	res.add("simpleWidths", "25p 240p 120p 60p 200p");
        	res.add("rightFixedCount", 0);
        	res.add("leftFixedCount", 0);
        	res.add("simpleHeadings", "Sel|Company|Type of Car|Price|Comments");
        	grid.setValues(res);

        	// set defaults for content cells
        	res.clear();
        	res.add("cellDefaults", true);
        	res.add("cellBackground", "#ffffff");
        	res.add("cellLeftBorderType", "BORDER_NONE");
        	res.add("cellRightBorderType", "BORDER_NONE");
        	res.add("cellTopBorderType", "BORDER_NONE");
        	res.add("cellBottomBorderType", "BORDER_NONE");
        	grid.setValues(res);

        	res.clear();
        	res.add("cellDefaults", true);
        	res.add("cellAlignment", "ALIGNMENT_LEFT");
        	grid.setValues(res);

        	res.clear();
        	res.add("cellDefaults", true);
        	res.add("column", 0);
        	res.add("cellAlignment", "ALIGNMENT_CENTER");
        	grid.setValues(res);
        	res.clear();
        	res.add("column", 3);
        	res.add("cellDefaults", true);
        	res.add("cellAlignment", "ALIGNMENT_CENTER");
        	grid.setValues(res);

		// Get data from server
   		PopupOk dServerMsgBox = new PopupOk(applet, frame, "Please Wait...", false);
		dServerMsgBox.title("Getting car rental data...");
		dServerMsgBox.move(100,100);

    		MlProgress prog;
    		prog = new MlProgress();
    		prog.reshape(0, 0, 280, 16); // 300, 20);
    		prog.setValue("showTime", true);
    		dServerMsgBox.add("20 35 140 8", prog);
    		prog.setValue("completeValue", 10);

		Label pStatus = new Label("Querying server...");
		dServerMsgBox.add("20 20 60 15", pStatus);
		pStatus.setFont(new Font("Helvetica", Font.PLAIN, 15));

		dServerMsgBox.noButton();
        	dServerMsgBox.show();
		dServerMsgBox.toFront();
		RCommon.waitCursor();

    		prog.setValue(0);
    		prog.updateDisplay();

  		cars = parent.trip.getCarFleets("ALL");  //Economy");
		int rows = 0;
		int carReservationRow = -1;
		CarFleet carReservation = null;
		if (parent.trip.getCarReservation() != null)
		    carReservation = parent.trip.getCarReservation().getCarFleet();
//		System.out.println("  Reserved Car = " + carReservation);
		if (cars != null) {

		    // Find out how many cars there are
		    CarFleet car = null;
		    while ((car = (CarFleet) cars.getNext()) != null) {
			rows++;
		    }
		    int total = rows;
    		    prog.setValue("completeValue", total);
		    System.out.println("  Number of rows = " + rows);
        	    grid.addRows(rows);

		    // Add data to grid
		    rows = 0;
		    String r;
		    cars.reset();
		    while ((car = (CarFleet) cars.getNext()) != null) {
			pStatus.setText("Adding " + (rows+1) + " of " + total + "...");
        		prog.setValue(rows);
        		prog.updateDisplay();
//		    	System.out.println(car);
			if (RCommon.isIdentical(carReservation, car) == true)
			//if (carReservation.isIdentical(car))
			    carReservationRow = rows;

			// Set Company info
			r = " |" + car.getCarRentalCompany().getName() + "|";

			// Set Type of Car
			r = r + car.getCar().getName() + "|";

			// Set Price
                	long days = (parent.trip.getReturnDate().getTime() - parent.trip.getDepartureDate().getTime() + 10000000) / 86399560;
                	if (days < 1) days = 1;
			r = r +	"$" + Float.toString(car.getPrice() * days) + "|";

			// Set Comments
			r = r + " ";
		    	System.out.println("  Added row:" + r);

			// Add row to grid
		    	grid.setStrings(rows, r);
			rows++;
		    }
        	    prog.setValue(total);
        	    prog.updateDisplay();
		}
		else {
		    System.out.println("There are no cars that match criteria.");
		}

        	grid.setValue("layoutFrozen", false);
        	add("10 20 315 115", grid);

		// If there is a reservation, put X in 1st column
		if (carReservationRow > -1) {
            	    grid.setStrings(carReservationRow, "X");

		    // Select row
        	    grid.selectRow(carReservationRow, true);
		    selectedRow = carReservationRow;
	        }

        	// select 1st item in list and show info below box
		else {
        	    grid.selectRow(0, true);
		    selectedRow = -1;
		    if (carReservation != null) {
   			PopupOk dMsgBox = new PopupOk(applet, RCommon.wEmptyFrame, "Reservation Not in List", false);
    			dMsgBox.title("Car Reservation:");
			dMsgBox.println("Car reservation is not in new search list.");
        		dMsgBox.show();
		    	dMsgBox.toFront();
		    }
		}

		// Required to force the tab Panel to show new grid results (bug?)
                parent.pack();
		parent.refreshCarPage = false;
//                if (exists == true) {
                    parent.skipSummary = true;
                    ((EditTrip)frame).tabPanel.showPage("Summary");
                    ((EditTrip)frame).tabPanel.showPage("Car Rental");
                    parent.skipSummary = false;
//                }
        	dServerMsgBox.hide();
                dServerMsgBox.dispose();
		dServerMsgBox = null;
		RCommon.defaultCursor();
	}

    	/**
    	*******************************************************
    	* Save data to server
    	*******************************************************
    	*/
	public void saveData() {
	    System.out.println("EditTripCarPanel::saveData()");
            RCommon.waitCursor();

	    // Make new reservation when leaving page

	    // If no iterator, then this panel was never shown, so don't save anything???
	    if (cars == null)
	        return;

	    CarFleet car = null;
	    cars.reset();
	    for (int i=0; i<=selectedRow; i++)
	        car = (CarFleet) cars.getNext();
	    System.out.println("  New car = <<" + car + ">>");

	    // If reservation existed, but no reservation selected, then delete it
	    CarReservation carReservation = parent.trip.getCarReservation();
	    if ((carReservation != null) && (selectedRow == -1)) {
	        System.out.println("  No new car - Canceling old car = <<" + carReservation.getCarFleet() + ">>");
	        parent.trip.cancelCarReservation();
                parent.refreshSummaryPage = true;
                parent.tripModified = true;
		return;
	    }

	    // If reservation existed, but a new reservation was selected
	    if (carReservation != null) {

		// If different reservation was selected
		if (RCommon.isIdentical(carReservation.getCarFleet(), car) == false) { //||
		    System.out.println("  New car different from old one: delete existing one, add new one");

		    // Delete existing one
		    parent.trip.cancelCarReservation();
	    	    System.out.println("  Existing car = <<" + carReservation.getCarFleet() + ">>");

		    // Add new one
    		    carReservation = parent.trip.reserveCar(car, 1);
                    parent.refreshSummaryPage = true;
                    parent.tripModified = true;
		}

		// If same reservation selected
		else {
		    System.out.println("  Same car");
		}

	    }

	    // If no reservation existed, but a new one was selected, then add a new one
	    else if (selectedRow > -1) {
		System.out.println("  No old reservation, just adding a new one");
    		carReservation = parent.trip.reserveCar(car, 1);
                parent.refreshSummaryPage = true;
                parent.tripModified = true;
	    }
	    RCommon.session.listReservations();
	    RCommon.defaultCursor();
	}

	// zpb_end
}
