package COM.ibm.jaws.app.trs.trswin2;
import java.awt.*;
import java.util.*;
import java.applet.*;
import com.roguewave.widgets.*;
// zpb_begin UserImports
import COM.ibm.jaws.models.trs.*;
// zpb_end

/**
 * Class EditTripGeneralPanel.
 *
 *
 * @author    Bryce Curtis
 * @version   2.0 11/21/96 1:28:50pm
 * @copyright IBM
 */
public
class EditTripGeneralPanel extends Panel {
	TextField pTripName;
	Label pStatic1, pStatic3, pStatic2, pStatic5, pStatic4, pStatic6, pStatic7;
	Choice pOrigCity, pDestCity;
	Button pLeaveDate, pReturnDate, pRight;
	private Applet applet = null;
	private Frame  frame  = null;

	// Initial size in logical units
	Dimension initialSize = new Dimension(335, 165);
	Point initialLocation;
	// zpb_begin EditTripGeneralPanelUserVars
	EditTrip parent = null;
	Date leaveDate = new Date();
	Date returnDate = new Date();
	// zpb_end

	// zpb_begin EditTripGeneralPanelJavadocConstructor
	/**
	 * Creates a specialized Panel with the specified app and frame.
	 */
	 // zpb_end
	EditTripGeneralPanel(Applet app, Frame frame) {
		applet = app;
		this.frame = frame;
		// zpb_begin EditTripGeneralPanelConstructor_1
		parent = (EditTrip)frame;
		// zpb_end

		setFont(new Font("Helvetica", Font.PLAIN, 12));
		LogFontLayout lfLayout = new LogFontLayout(this);
		setLayout(lfLayout);

		pStatic1 = new Label("Trip Name:");
		add("10 15 54 12", pStatic1);
		pStatic1.setFont(new Font("Helvetica", Font.BOLD, 15));
		pStatic3 = new Label("Origination:");
		pStatic3.setAlignment(Label.RIGHT);
		add("10 110 55 12", pStatic3);
		pStatic3.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pStatic2 = new Label("Dates of Trip:");
		add("10 45 57 12", pStatic2);
		pStatic2.setFont(new Font("Helvetica", Font.BOLD, 15));
		pStatic5 = new Label("Trip Cities:");
		add("10 90 49 12", pStatic5);
		pStatic5.setFont(new Font("Helvetica", Font.BOLD, 15));
		pStatic4 = new Label("Destination:");
		pStatic4.setAlignment(Label.RIGHT);
		add("175 110 55 12", pStatic4);
		pStatic4.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pTripName = new TextField("");
		add("75 15 247 12", pTripName);
		pTripName.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pTripName.setBackground(Color.white);
		pLeaveDate = new Button("Aug 15, 1996");
		add("75 65 80 12", pLeaveDate);
		pLeaveDate.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pOrigCity = new Choice();
		add("75 110 82 70", pOrigCity);
		pOrigCity.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pOrigCity.setBackground(Color.white);
		pReturnDate = new Button("Aug 15, 1996");
		add("240 65 80 12", pReturnDate);
		pReturnDate.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pDestCity = new Choice();
		add("240 110 82 70", pDestCity);
		pDestCity.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pDestCity.setBackground(Color.white);
		pRight = new Button(">");
		add("315 150 15 12", pRight);
		pStatic6 = new Label("Leave:");
		pStatic6.setAlignment(Label.RIGHT);
		add("10 65 55 12", pStatic6);
		pStatic6.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pStatic7 = new Label("Return:");
		pStatic7.setAlignment(Label.RIGHT);
		add("175 65 55 12", pStatic7);
		pStatic7.setFont(new Font("Helvetica", Font.PLAIN, 15));
		// zpb_begin EditTripGeneralPanelConstructor_2
		// zpb_end

		// Size and Position in logical units
		initialLocation = lfLayout.du(5, 5);
		move(initialLocation.x, initialLocation.y);

		// zpb_begin EditTripGeneralPanelConstructor_3
		RCommon.getCities(pOrigCity, pDestCity);
		System.out.println("EditTripGeneralPanel: Exiting init()");
		// zpb_end
	}

	// zpb_begin EditTripGeneralPanelStatic7JavadocPaint
	/**
	 * Paints the Panel.  Add specialized functionality for this Panel
	 * between the paint protect block.
	 */
	// zpb_end
	public void paint(Graphics g) {
		Dimension d = size();
		g.drawRect(0,0,d.width-1,d.height-1); // border
		// zpb_begin EditTripGeneralPanelPaint
		// zpb_end
	}


	// zpb_begin EditTripGeneralPanelJavadocHandleEvent
	/**
	 * Handle events that occur with components in this container.
	 *
	 * @return  Returns a boolean which specifies whether the event
	 *          handler should stop at this level or continue up the
	 *          parent hierarchy.
	 */
	// zpb_end
	public boolean handleEvent(Event e) {

		// zpb_begin EditTripGeneralPanelHandleEvent
	        // If key was pressed
		if (e.id == Event.KEY_PRESS) {

                    // If Tab key pressed - handle tab order
		    if ((e.key == 9) || (e.key == 10)) {
                       	if (e.target == pTripName) {
                            pLeaveDate.requestFocus();
			}
                        if (e.target == pLeaveDate) {
                            pReturnDate.requestFocus();
			}
                        if (e.target == pReturnDate) {
                            pOrigCity.requestFocus();
			}
                        if (e.target == pOrigCity) {
                            pDestCity.requestFocus();
			}
                        if (e.target == pDestCity) {
                            pTripName.requestFocus();
                            pTripName.selectAll();
			}
			return true;
		    }
 		}
		// zpb_end

		return super.handleEvent(e);
	}

	// zpb_begin EditTripGeneralPanelJavadocAction
	/**
	 * Action handling routine.
	 *
	 * @return  Returns a boolean specifying whether the event should be handled
	 *          furthur up the parent hierarchy.
	 */
	// zpb_end
	public boolean action(Event evt, Object obj) {
		if (evt.target == pLeaveDate) {
			// zpb_begin PanelLeaveDateClickedCreate
			// zpb_end
			// zpb_begin PanelLeaveDateClicked
			Calendar dCalendar= new Calendar(applet, frame, "Calendar", true);
            		dCalendar.setButton(pLeaveDate);
            		dCalendar.setDate(leaveDate);
			dCalendar.show();
			// zpb_end
			return false;
		}
		else if (evt.target == pReturnDate) {
			// zpb_begin PanelReturnDateClickedCreate
			// zpb_end
			// zpb_begin PanelReturnDateClicked
			Calendar dCalendar= new Calendar(applet, frame, "Calendar", true);
            		dCalendar.setButton(pReturnDate);
            		dCalendar.setDate(returnDate);
			dCalendar.show();
			// zpb_end
			return false;
		}
		else if (evt.target == pRight) {
			// zpb_begin PanelRightClicked
			((EditTrip)frame).tabPanel.showPage("Orig Flight");
			// zpb_end
			return false;
		}

		// zpb_begin EditTripGeneralPanelAction
		// zpb_end

		return false;
	}


	// zpb_begin EditTripGeneralPanelUserMethods

	/**
    	*******************************************************
    	* Get data from server
    	*******************************************************
    	*/
	public void getData() {
		Airport airport;
		City city;
		System.out.println("GeneralPanel: getData()");
		RCommon.waitCursor();

		Trip t = parent.trip;
		System.out.println("  trip = "+t);
		String s = t.getName();
		System.out.println("  tripName = "+s);
		pTripName.setText(s); //t.name() );

		System.out.println("  Getting leave date");
		Date lDate = t.getDepartureDate();
                if (lDate != null)
                    leaveDate = new Date(lDate.getYear(), lDate.getMonth(), lDate.getDate());
                else {
                    leaveDate = new Date();
                    System.out.println("getDataGeneralPanel ERROR in leave date: " + t.getDepartureDate());
                }
		pLeaveDate.setLabel( RCommon.getDateString(leaveDate) );

		System.out.println("  Getting return date");
		Date rDate = t.getReturnDate();
                if (rDate != null)
                    returnDate = new Date(rDate.getYear(), rDate.getMonth(), rDate.getDate());
                else {
                    returnDate = new Date();
                    System.out.println("getDataGeneralPanel ERROR in return date: " + t.getReturnDate());
                }
		pReturnDate.setLabel( RCommon.getDateString(returnDate) );

		System.out.println("  Getting orig city");
		t.changeDepartureCity("Austin");
		city = t.getDepartureCity();
		if (city != null) {
		    System.out.println("    orig city="+city.getCityState());
       		    pOrigCity.select( city.getCityState() );
		}
		else
		    System.out.println("    NO DEPARTURE CITY");

		System.out.println("  Getting dest city");
		t.changeDestinationCity("Atlanta");
		city = t.getDestinationCity();
		if (city != null) {
       		    pDestCity.select( city.getCityState() );
		    System.out.println("    dest city="+city.getCityState());
		}
		else
		    System.out.println("    NO DESTINATION CITY");

		RCommon.defaultCursor();
	}

	/**
    	*******************************************************
    	* Save data to server
    	*******************************************************
    	*/
	public void saveData() {
		System.out.println("GeneralPanel: saveData()");
		RCommon.waitCursor();

		Trip t = parent.trip;
		String s;
		boolean changedName = true;
		boolean changedDepartureDate = true;
		boolean changedReturnDate = true;
		boolean changedDepartureCity = true;
		boolean changedDestinationCity = true;

		System.out.println("Saving trip name");
		if (t.getName().equals(pTripName.getText()))
		    changedName = false;
		else {
		    t.changeName( pTripName.getText() );
		    System.out.println("  changed");
                    parent.tripModified = true;
		}

		System.out.println("Saving leave date " + leaveDate);
		if (RCommon.getDate(t.getDepartureDate()).equals(RCommon.getDate(leaveDate)))
		    changedDepartureDate = false;
		else {
		    t.changeDepartureDate( leaveDate );
		    System.out.println("  changed");
                    parent.tripModified = true;
	        }

		System.out.println("Saving return date " + returnDate);
		if (RCommon.getDate(t.getReturnDate()).equals(RCommon.getDate(returnDate)))
		    changedReturnDate = false;
		else {
		    t.changeReturnDate( returnDate );
		    System.out.println("  changed");
                    parent.tripModified = true;
	        }

		System.out.println("Saving orig city");
		s = pOrigCity.getSelectedItem();
		String r = s.substring(0, s.indexOf(','));
		System.out.println("  city = " + r);
		if (t.getDepartureCity().getName().equals(r))
		    changedDepartureCity = false;
		else {
		    t.changeDepartureCity(r);
		    System.out.println("  changed");
                    parent.tripModified = true;
		}

		System.out.println("Saving dest city");
		s = pDestCity.getSelectedItem();
		r = s.substring(0, s.indexOf(','));
		System.out.println("  city = " + r);
		if (t.getDestinationCity().getName().equals(r))
		    changedDestinationCity = false;
		else {
		    t.changeDestinationCity(r);
		    System.out.println("  changed");
                    parent.tripModified = true;
		}

		// Indicate which pages need to be refreshed when visited again
		parent.refreshOriginationPage = parent.refreshOriginationPage ||
		    	changedDepartureCity || changedDestinationCity ||
		    	changedDepartureDate;
		parent.refreshDestinationPage = parent.refreshDestinationPage ||
		    	changedDepartureCity || changedDestinationCity ||
		    	changedReturnDate;
		parent.refreshCarPage = parent.refreshCarPage ||
		    	changedDestinationCity ||
		    	changedDepartureDate || changedReturnDate;
		parent.refreshHotelPage = parent.refreshHotelPage ||
		    	changedDestinationCity ||
		    	changedDepartureDate || changedReturnDate;
		parent.refreshSummaryPage = parent.refreshSummaryPage ||
			changedName ||
		    	changedDepartureCity || changedDestinationCity ||
		    	changedDepartureDate || changedReturnDate;

		RCommon.defaultCursor();
	}
	// zpb_end
}
