package COM.ibm.jaws.app.trs.trswin2;
import java.awt.*;
import java.util.*;
import java.applet.*;
import com.roguewave.widgets.*;
// zpb_begin UserImports
import mlsoft.mct.*;
import java.net.*;
import COM.ibm.jaws.models.trs.*;
import COM.ibm.jaws.mofw.*;
// zpb_end

/**
 * Class EditTripHotelPanel.
 *
 *
 * @author    Bryce Curtis
 * @version   2.0 11/21/96 1:28:56pm
 * @copyright IBM
 */
public
class EditTripHotelPanel extends Panel {
	Label pStatic7, pStatic8, pStatic9;
	Choice pRates;
	Button pLeft, pRight;
	Checkbox pLateCheckin;
	private Applet applet = null;
	private Frame  frame  = null;

	// Initial size in logical units
	Dimension initialSize = new Dimension(335, 165);
	Point initialLocation;
	// zpb_begin EditTripHotelPanelUserVars
    	MlGrid grid = null;
	int selectedRow = -1;
	EditTrip parent = null;
	Label pAddress, pInfo;
  	Iterator rooms = null;
	// zpb_end

	// zpb_begin EditTripHotelPanelJavadocConstructor
	/**
	 * Creates a specialized Panel with the specified app and frame.
	 */
	 // zpb_end
	EditTripHotelPanel(Applet app, Frame frame) {
		applet = app;
		this.frame = frame;
		// zpb_begin EditTripHotelPanelConstructor_1
		parent = (EditTrip)frame;
		// zpb_end

		setFont(new Font("Helvetica", Font.PLAIN, 12));
		LogFontLayout lfLayout = new LogFontLayout(this);
		setLayout(lfLayout);

		pLateCheckin = new Checkbox("Late Check-in");
		add("215 140 80 14", pLateCheckin);
		pLateCheckin.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pStatic7 = new Label("Room Rate:");
		add("15 140 53 12", pStatic7);
		pStatic7.setFont(new Font("Helvetica", Font.BOLD, 15));
		pRates = new Choice();
		add("70 140 105 49", pRates);
		pRates.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pRates.setBackground(Color.white);
		pRates.addItem("< $100");
		pRates.addItem("< $200");
		pRates.addItem("< $300");
		pRates.addItem("ALL");
		add("70 140 105 49", pRates);
		pStatic8 = new Label("Address:");
		add("15 100 42 12", pStatic8);
		pStatic8.setFont(new Font("Helvetica", Font.BOLD, 15));
		pStatic9 = new Label("Info:");
		add("15 115 24 12", pStatic9);
		pStatic9.setFont(new Font("Helvetica", Font.BOLD, 15));
		pLeft = new Button("<");
		add("300 150 15 12", pLeft);
		pRight = new Button(">");
		add("315 150 15 12", pRight);
		// zpb_begin EditTripHotelPanelConstructor_2
		pAddress = new Label("");
		pInfo = new Label("");
		// zpb_end

		// Size and Position in logical units
		initialLocation = lfLayout.du(5, 5);
		move(initialLocation.x, initialLocation.y);

		// zpb_begin EditTripHotelPanelConstructor_3
		// zpb_end
	}

	// zpb_begin EditTripHotelPanelRightJavadocPaint
	/**
	 * Paints the Panel.  Add specialized functionality for this Panel
	 * between the paint protect block.
	 */
	// zpb_end
	public void paint(Graphics g) {
		Dimension d = size();
		g.drawRect(0,0,d.width-1,d.height-1); // border
		// zpb_begin EditTripHotelPanelPaint
		g.setFont(new Font("Helvetica", Font.PLAIN, 15));
		if (selectedRow > -1) {
		    g.drawString(pAddress.getText(), 130, 206);
		    g.drawString(pInfo.getText(), 130, 236);
		}
		// zpb_end
	}


	// zpb_begin EditTripHotelPanelJavadocHandleEvent
	/**
	 * Handle events that occur with components in this container.
	 *
	 * @return  Returns a boolean which specifies whether the event
	 *          handler should stop at this level or continue up the
	 *          parent hierarchy.
	 */
	// zpb_end
	public boolean handleEvent(Event e) {

		// zpb_begin EditTripHotelPanelHandleEvent
		// zpb_end

		return super.handleEvent(e);
	}

	// zpb_begin EditTripHotelPanelJavadocAction
	/**
	 * Action handling routine.
	 *
	 * @return  Returns a boolean specifying whether the event should be handled
	 *          furthur up the parent hierarchy.
	 */
	// zpb_end
	public boolean action(Event evt, Object obj) {
		if (evt.target == pLeft) {
			// zpb_begin PanelLeftClicked
			((EditTrip)frame).tabPanel.showPage("Car Rental");
			// zpb_end
			return false;
		}
		else if (evt.target == pRight) {
			// zpb_begin PanelRightClicked
			((EditTrip)frame).tabPanel.showPage("Summary");
			// zpb_end
			return false;
		}

		// zpb_begin EditTripHotelPanelAction
		else if (evt.target == pRates) {
			getData();			// Get new search
			return false;
		}

        	else if (evt.target == grid) {
			disable();
            		MlGridEvent e = (MlGridEvent) evt;
            		System.out.println("GRID EVENT (" + e.row +","+ e.column +")");
                    	grid.selectRow(e.row, true);

                	// if clicked on select
                	if (e.column == 0) {
            			String s = (String)grid.getCellValue(e.row, 0, "cellString");

				// Deselect current row
				if (s.equals("X")) {
            				grid.setStrings(e.row, " ");
					selectedRow = -1;
				}

				// Select current row
				else {
					// Deselect previously selected row
					if (selectedRow != -1)
						grid.setStrings(selectedRow, " ");

					// Select new row
					selectedRow = e.row;
            				grid.setStrings(e.row, "X");

					// Get address and info from grid
            				s = (String)grid.getCellValue(e.row, 2, "cellString");
					if (s == null)
					    s = "";
					pAddress = new Label(s);
            				s = (String)grid.getCellValue(e.row, 6, "cellString");
					if (s == null)
					    s = "";
					pInfo = new Label(s);
					repaint();
				}
			}

                	// if clicked on company name
                	else if (e.column == 1) {

			        // Find room that corresponds to selected row
		    		rooms.reset();
				RoomGroup room = null;
				for (int i=0; i<=e.row; i++)
		    		    room = (RoomGroup) rooms.getNext();

				// Load web page
	    			if (!RCommon.appl) {
                        	    URL nURL = room.getHotelCompany().getContact().getURL();
                        	    applet.getAppletContext().showDocument(nURL, "_TOP");
				}
                	}

                	// if clicked on room
                	else if (e.column == 3) {
// Need to add RoomBase.java as object
/*
			        // Find room that corresponds to selected row
		    		rooms.reset();
				RoomGroup room = null;
				for (int i=0; i<=e.row; i++)
		    		    room = (RoomGroup) rooms.getNext();

				// Show image
	                   	Picture wPicture= new Picture(applet, frame, "Picture of " + room.getRoom().getName(), true);
                    		wPicture.pTitle.setText(room.getRoom().getName());
                    		wPicture.getImage(room.getRoom().getImage());
                    		wPicture.show();
*/
                	}

			enable();
        	}
		// zpb_end

		return false;
	}


	// zpb_begin EditTripHotelPanelUserMethods

	/**
    	*******************************************************
    	* Get data from server
    	*******************************************************
    	*/
	public void getData() {
		System.out.println("EditTripHotelPanel::getData()");
	        RCommon.waitCursor();

		boolean exists = false;
	        if (grid != null) {
		    remove(grid);
		    exists = true;
		}

        	MlResources res;
        	res = new MlResources();
        	grid = new MlGrid();
        	grid.setValue("layoutFrozen", true);

        	res.add("allowColumnResize", true);
        	res.add("selectionPolicy", "SELECT_SINGLE_ROW");
        	//res.add("horizontalSizePolicy", "SIZE_TO_FIT");
        	//res.add("hsbDisplayPolicy", "DISPLAY_ALWAYS");
        	res.add("headingRows", 1);
        	res.add("columns", 6);
        	res.add("simpleWidths", "25p 150p 150p 100p 60p 300p");
        	res.add("rightFixedCount", 0);
        	res.add("leftFixedCount", 0);
        	res.add("simpleHeadings", "Sel|Hotel|Address|Room Type|Price|Info/Features");
        	grid.setValues(res);

        	// set defaults for content cells
        	res.clear();
        	res.add("cellDefaults", true);
        	res.add("cellBackground", "#ffffff");
        	res.add("cellLeftBorderType", "BORDER_NONE");
        	res.add("cellRightBorderType", "BORDER_NONE");
        	res.add("cellTopBorderType", "BORDER_NONE");
        	res.add("cellBottomBorderType", "BORDER_NONE");
        	grid.setValues(res);

        	res.clear();
        	res.add("cellDefaults", true);
        	res.add("cellAlignment", "ALIGNMENT_CENTER");
        	grid.setValues(res);

		// Get data from server
   		PopupOk dServerMsgBox = new PopupOk(applet, frame, "Please Wait...", false);
		dServerMsgBox.title("Getting hotel data...");
		dServerMsgBox.move(100,100);

    		MlProgress prog;
    		prog = new MlProgress();
    		prog.reshape(0, 0, 280, 16); // 300, 20);
    		prog.setValue("showTime", true);
    		dServerMsgBox.add("20 35 140 8", prog);
    		prog.setValue("completeValue", 10);

		Label pStatus = new Label("Querying server...");
		dServerMsgBox.add("20 20 60 15", pStatus);
		pStatus.setFont(new Font("Helvetica", Font.PLAIN, 15));

		dServerMsgBox.noButton();
        	dServerMsgBox.show();
		dServerMsgBox.toFront();
		RCommon.waitCursor();

    		prog.setValue(0);
    		prog.updateDisplay();

  		rooms = parent.trip.getRoomGroups(500);
		int rows = 0;
		int hotelReservationRow = -1;
		RoomGroup hotelReservation = null;
		if (parent.trip.getHotelReservation() != null)
		    hotelReservation = parent.trip.getHotelReservation().getRoomGroup();
//		System.out.println("  Reserved Hotel = " + hotelReservation);
		if (rooms != null) {

		    // Find out how many cars there are
		    RoomGroup room = null;
		    while ((room = (RoomGroup) rooms.getNext()) != null) {
			rows++;
		    }
		    int total = rows;
    		    prog.setValue("completeValue", total);
		    System.out.println("  Number of rows = " + rows);
        	    grid.addRows(rows);

		    // Add data to grid
		    rows = 0;
		    String r;
		    rooms.reset();
		    while ((room = (RoomGroup) rooms.getNext()) != null) {
//		    	System.out.println(room);
			pStatus.setText("Adding " + (rows+1) + " of " + total + "...");
        		prog.setValue(rows);
        		prog.updateDisplay();
			if (RCommon.isIdentical(hotelReservation, room) == true)
			//if (hotelReservation.isIdentical(room))
			    hotelReservationRow = rows;

			// Set Hotel Name
			r = " |" + room.getHotelCompany().getName() + "|";

			// Set Address
			Contact contact = room.getContact();
			r = r + contact.getAddress1() + " ";
			if (contact.getAddress2() != null)
			    r = r + contact.getAddress2();
			r = r + ", " +
			    contact.getCity().getName() + "  " +
			    "(" + contact.getPhoneAreaCode() + ") " + contact.getPhoneNumber() + "|";

			// Set Room Type
			r = r + room.getName() + "|";

			// Set Price
                	long days = (parent.trip.getReturnDate().getTime() - parent.trip.getDepartureDate().getTime() + 10000000) / 86399560;
                	if (days < 1) days = 1;
			r = r +	"$" + Float.toString(room.getPrice() * days) + "|";

			// Set Info
			r = r + " ";
			System.out.println("  Added row:" + r);

			// Add row to grid
		    	grid.setStrings(rows, r);
			rows++;
		    }
        	    prog.setValue(total);
        	    prog.updateDisplay();
		}
		else {
		    System.out.println("There are no cars that match criteria.");
		}

        	grid.setValue("layoutFrozen", false);
        	add("15 15 305 80", grid);

		// If there is a reservation, put X in 1st column
		if (hotelReservationRow > -1) {
            	    grid.setStrings(hotelReservationRow, "X");

		    // Select row
        	    grid.selectRow(hotelReservationRow, true);
		    selectedRow = hotelReservationRow;

		    // Get address and info from grid
            	    String s = (String)grid.getCellValue(selectedRow, 2, "cellString");
		    if (s == null)  s = "";
            	    pAddress = new Label(s);
            	    s = (String)grid.getCellValue(selectedRow, 6, "cellString");
		    if (s == null)  s = "";
            	    pInfo = new Label(s);
	        }

        	// select 1st item in list and show info below box
		else {
        	    grid.selectRow(0, true);
		    selectedRow = -1;
		    if (hotelReservation != null) {
   			PopupOk dMsgBox = new PopupOk(applet, RCommon.wEmptyFrame, "Reservation Not in List", false);
    			dMsgBox.title("Hotel Reservation:");
			dMsgBox.println("Hotel reservation is not in new search list.");
        		dMsgBox.show();
		    	dMsgBox.toFront();
		    }
		}

		// Required to force the tab Panel to show new grid results (bug?)
                parent.pack();
		parent.refreshHotelPage = false;
//                if (exists == true) {
                    parent.skipSummary = true;
                    ((EditTrip)frame).tabPanel.showPage("Summary");
                    ((EditTrip)frame).tabPanel.showPage("Hotel");
                    parent.skipSummary = false;
//                }
        	dServerMsgBox.hide();
                dServerMsgBox.dispose();
		dServerMsgBox = null;
		RCommon.defaultCursor();
	}

    	/**
    	*******************************************************
    	* Save data to server
    	*******************************************************
    	*/
	public void saveData() {
	    System.out.println("EditTripHotelPanel::saveData()");
	    RCommon.waitCursor();

	    // Make new reservation when leaving page

	    // If no iterator, then this panel was never shown, so don't save anything???
	    if (rooms == null)
	        return;

	    RoomGroup room = null;
	    rooms.reset();
	    for (int i=0; i<=selectedRow; i++)
	        room = (RoomGroup) rooms.getNext();
	    System.out.println("  New room = <<" + room + ">>");

	    // If reservation existed, but no reservation selected, then delete it
	    HotelReservation hotelReservation = parent.trip.getHotelReservation();
	    if ((hotelReservation != null) && (selectedRow == -1)) {
	        System.out.println("  No new hotel - Canceling old hotel = <<" + hotelReservation.getRoomGroup() + ">>");
	        parent.trip.cancelHotelReservation();
                parent.refreshSummaryPage = true;
                parent.tripModified = true;
		return;
	    }

	    // If reservation existed, but a new reservation was selected
	    if (hotelReservation != null) {

		// If different reservation was selected
		if (RCommon.isIdentical(hotelReservation.getRoomGroup(), room) == false) {
		    System.out.println("  New hotel different from old one: delete existing one, add new one");

		    // Delete existing one
		    parent.trip.cancelHotelReservation();
	    	    System.out.println("  Existing hotel = <<" + hotelReservation.getRoomGroup() + ">>");

		    // Add new one
    		    hotelReservation = parent.trip.reserveHotel(room, 1);
                    parent.refreshSummaryPage = true;
                    parent.tripModified = true;
		}

		// If same reservation selected
		else {
		    System.out.println("  Same hotel");
		}

	    }

	    // If no reservation existed, but a new one was selected, then add a new one
	    else if (selectedRow > -1) {
		System.out.println("  No old reservation, just adding a new one");
    		hotelReservation = parent.trip.reserveHotel(room, 1);
                parent.refreshSummaryPage = true;
                parent.tripModified = true;
	    }

	    RCommon.defaultCursor();
	}

	// zpb_end
}
