package COM.ibm.jaws.app.trs.trswin2;
import java.awt.*;
import java.util.*;
import java.applet.*;
import com.roguewave.widgets.*;
// zpb_begin UserImports
import mlsoft.mct.*;
import java.net.*;
import COM.ibm.jaws.models.trs.*;
import COM.ibm.jaws.mofw.*;
// zpb_end

/**
 * Class EditTripOriginationPanel.
 *
 *
 * @author    Bryce Curtis
 * @version   2.0 11/21/96 1:28:59pm
 * @copyright IBM
 */
public
class EditTripOriginationPanel extends Panel {
	Label pTitle, pSeatNum, pTextClass, pFair;
	Choice pAirClass;
	Button pSelectSeat, pLeft, pRight;
	private Applet applet = null;
	private Frame  frame  = null;

	// Initial size in logical units
	Dimension initialSize = new Dimension(335, 165);
	Point initialLocation;
	// zpb_begin EditTripOriginationPanelUserVars

    	MlGrid grid = null;
    	Label seat = new Label("");
	int selectedRow = -1;
	EditTrip parent = null;
  	Iterator flights = null;

	// zpb_end

	// zpb_begin EditTripOriginationPanelJavadocConstructor
	/**
	 * Creates a specialized Panel with the specified app and frame.
	 */
	 // zpb_end
	EditTripOriginationPanel(Applet app, Frame frame) {
		applet = app;
		this.frame = frame;
		// zpb_begin EditTripOriginationPanelConstructor_1
		parent = (EditTrip)frame;
		// zpb_end

		setFont(new Font("Helvetica", Font.PLAIN, 12));
		LogFontLayout lfLayout = new LogFontLayout(this);
		setLayout(lfLayout);

		pTitle = new Label("From Austin, TX to Atlanta, GA on Jul 23, 1996");
		pTitle.setAlignment(Label.CENTER);
		add("5 5 320 12", pTitle);
		pTitle.setFont(new Font("Helvetica", Font.BOLD, 15));
		pSelectSeat = new Button("Select Seat");
		add("10 145 55 14", pSelectSeat);
		pSelectSeat.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pSeatNum = new Label("Seat:     ");
		add("75 145 50 12", pSeatNum);
		pSeatNum.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pTextClass = new Label("Class:");
		add("135 145 31 12", pTextClass);
		pTextClass.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pAirClass = new Choice();
		add("170 145 48 80", pAirClass);
		pAirClass.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pAirClass.setBackground(Color.white);
		pAirClass.addItem("All");
		pAirClass.addItem("Business");
		pAirClass.addItem("Coach");
		pAirClass.addItem("First");
		add("170 145 48 80", pAirClass);
		pFair = new Label("Fair: $600.00");
		add("230 145 55 12", pFair);
		pFair.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pLeft = new Button("<");
		add("300 150 15 12", pLeft);
		pRight = new Button(">");
		add("315 150 15 12", pRight);
		// zpb_begin EditTripOriginationPanelConstructor_2

        	// Create grid for displaying departure flight information
		pFair.hide();
        	//Float f = Float.valueOf(s.substring(1));
        	//RCommon.originationPrice = f.floatValue();

		// zpb_end

		// Size and Position in logical units
		initialLocation = lfLayout.du(5, 5);
		move(initialLocation.x, initialLocation.y);

		// zpb_begin EditTripOriginationPanelConstructor_3
		// zpb_end
	}

	// zpb_begin EditTripOriginationPanelRightJavadocPaint
	/**
	 * Paints the Panel.  Add specialized functionality for this Panel
	 * between the paint protect block.
	 */
	// zpb_end
	public void paint(Graphics g) {
		Dimension d = size();
		g.drawRect(0,0,d.width-1,d.height-1); // border
		// zpb_begin EditTripOriginationPanelPaint
		// zpb_end
	}


	// zpb_begin EditTripOriginationPanelJavadocHandleEvent
	/**
	 * Handle events that occur with components in this container.
	 *
	 * @return  Returns a boolean which specifies whether the event
	 *          handler should stop at this level or continue up the
	 *          parent hierarchy.
	 */
	// zpb_end
	public boolean handleEvent(Event e) {

		// zpb_begin EditTripOriginationPanelHandleEvent
		// zpb_end

		return super.handleEvent(e);
	}

	// zpb_begin EditTripOriginationPanelJavadocAction
	/**
	 * Action handling routine.
	 *
	 * @return  Returns a boolean specifying whether the event should be handled
	 *          furthur up the parent hierarchy.
	 */
	// zpb_end
	public boolean action(Event evt, Object obj) {
		if (evt.target == pSelectSeat) {
			// zpb_begin PanelSelectSeatClicked
            		((EditTrip)frame).sLeave = true;
            		SelectSeat dSelectSeat= new SelectSeat(applet, frame, "Select Seat for Departure Flight", true);
            		dSelectSeat.show();
			// zpb_end
			return false;
		}
		else if (evt.target == pAirClass) {
			// zpb_begin PanelAirClassClicked
			getData();			// Get new search
			// zpb_end
			return false;
		}
		else if (evt.target == pLeft) {
			// zpb_begin PanelLeftClicked
			((EditTrip)frame).tabPanel.showPage("General");
			// zpb_end
			return false;
		}
		else if (evt.target == pRight) {
			// zpb_begin PanelRightClicked
			((EditTrip)frame).tabPanel.showPage("Dest Flight");
			// zpb_end
			return false;
		}

		// zpb_begin EditTripOriginationPanelAction

        	else if (evt.target == grid) {
            		disable();
            		MlGridEvent e = (MlGridEvent) evt;
            		System.out.println("GRID EVENT (" + e.row +","+ e.column +")");

                	// if clicked on select
                    	grid.selectRow(e.row, true);
                	if (e.column == 0) {
            			String s = (String)grid.getCellValue(e.row, 0, "cellString");

				// Deselect current row
				if (s.equals("X")) {
            				grid.setStrings(e.row, " ");
					selectedRow = -1;
				}

				// Select current row
				else {
					// Deselect previously selected row
					if (selectedRow != -1)
						grid.setStrings(selectedRow, " ");

					// Select new row
					selectedRow = e.row;
            				grid.setStrings(e.row, "X");
				}
			}
                	// if clicked depart airport
                	else if (e.column == 1) {

			        // Find flight that corresponds to selected row
		    		flights.reset();
				Flight flight = null;
				for (int i=0; i<=e.row; i++)
		    		    flight = (Flight) flights.getNext();

				// Load web page
				System.out.println("Airport = " + flight.getFlightPlan().getDepartureAirport() );
				System.out.println("Airport URL = " + flight.getFlightPlan().getDepartureAirport().getURL() );
	    			if (!RCommon.appl) {
                        	    URL nURL = flight.getFlightPlan().getDepartureAirport().getURL();
                        	    applet.getAppletContext().showDocument(nURL, "_TOP");
				}
                	}
                	// if clicked on arrive airport
                	else if (e.column == 2) {

			        // Find flight that corresponds to selected row
		    		flights.reset();
				Flight flight = null;
				for (int i=0; i<=e.row; i++)
		    		    flight = (Flight) flights.getNext();

				// Load web page
	    			if (!RCommon.appl) {
                        	    URL nURL = flight.getFlightPlan().getDestinationAirport().getURL();
                        	    applet.getAppletContext().showDocument(nURL, "_TOP");
				}
                	}
                	// if clicked on airline name
                	else if (e.column == 3) {

			        // Find flight that corresponds to selected row
		    		flights.reset();
				Flight flight = null;
				for (int i=0; i<=e.row; i++)
		    		    flight = (Flight) flights.getNext();

				// Load web page
	    			if (!RCommon.appl) {
                        	    URL nURL = flight.getFlightPlan().getAirlineCompany().getContact().getURL();
                        	    applet.getAppletContext().showDocument(nURL, "_TOP");
				}
                	}
                	else if (e.column == 6) {

			        // Find flight that corresponds to selected row
		    		flights.reset();
				Flight flight = null;
				for (int i=0; i<=e.row; i++)
		    		    flight = (Flight) flights.getNext();

				// Show image
                    		Picture wPlanePict= new Picture(applet, this.frame, "Picture of " + flight.getPlane().getName(), true);
                    		wPlanePict.pTitle.setText(flight.getPlane().getName());
                    		wPlanePict.getImage(flight.getPlane().getPlaneImage());
                    		wPlanePict.show();
                	}
            		enable();
        	}
		// zpb_end

		return false;
	}


	// zpb_begin EditTripOriginationPanelUserMethods

	/**
    	*******************************************************
    	* Get data from server
    	*******************************************************
    	*/
	public void getData() {
		System.out.println("EditTripOriginationPanel::getData()");
	        RCommon.waitCursor();

		boolean exists = false;
	        if (grid != null) {
		    remove(grid);
		    exists = true;
		}

		// Add title
		remove(pTitle);
		Trip t = parent.trip;
		String l = "From " + t.getDepartureCity().getCityState() + " to " +
				t.getDestinationCity().getCityState() + " on " +
				RCommon.getDateString(t.getDepartureDate());
		System.out.println("Title = " + l);
		pTitle = new Label(l);
		pTitle.setAlignment(Label.CENTER);
		pTitle.setFont(new Font("Helvetica", Font.BOLD, 15));
		add("5 5 320 12", pTitle);

        	// Create grid for displaying departure flight information
        	MlResources res;
        	res = new MlResources();
        	grid = new MlGrid();
        	grid.setValue("layoutFrozen", true);

        	res.add("allowColumnResize", true);
        	res.add("selectionPolicy", "SELECT_SINGLE_ROW");
        	res.add("headingRows", 1);
        	res.add("columns", 9);
        	res.add("simpleWidths", "3c 15c 15c 15c 10c 10c 10c 5c 20c");
        	res.add("rightFixedCount", 0);
        	res.add("leftFixedCount", 0);
        	res.add("simpleHeadings", "Sel|Depart|Arrive|Airline|Flight|Price|Plane|Conn|Cities");
        	grid.setValues(res);

        	// set defaults for content cells
        	res.clear();
        	res.add("cellDefaults", true);
        	res.add("cellBackground", "#ffffff");
        	res.add("cellLeftBorderType", "BORDER_NONE");
        	res.add("cellRightBorderType", "BORDER_NONE");
        	res.add("cellTopBorderType", "BORDER_NONE");
        	res.add("cellBottomBorderType", "BORDER_NONE");
        	grid.setValues(res);

        	res.clear();
        	res.add("cellDefaults", true);
        	res.add("cellAlignment", "ALIGNMENT_CENTER");
        	grid.setValues(res);

		// Get data from server
   		PopupOk dServerMsgBox = new PopupOk(applet, frame, "Please Wait...", false);
		dServerMsgBox.title("Getting origination flight data...");
		dServerMsgBox.move(100,100);

    		MlProgress prog;
    		prog = new MlProgress();
    		prog.reshape(0, 0, 280, 16); // 300, 20);
    		prog.setValue("showTime", true);
    		dServerMsgBox.add("20 35 140 8", prog);
    		prog.setValue("completeValue", 10);

		Label pStatus = new Label("Querying server...");
		dServerMsgBox.add("20 20 60 15", pStatus);
		pStatus.setFont(new Font("Helvetica", Font.PLAIN, 15));

		dServerMsgBox.noButton();
        	dServerMsgBox.show();
		dServerMsgBox.toFront();
		RCommon.waitCursor();

    		prog.setValue(0);
    		prog.updateDisplay();

  		flights = t.getDepartureFlights("ALL");
		int rows = 0;
		int flightReservationRow = -1;
		Flight flightReservation = null;
		if (t.getDepartureFlightReservation() != null)
		    flightReservation = t.getDepartureFlightReservation().getFlight();
//		System.out.println("  Reserved Flight = " + flightReservation);
		if (flights != null) {

		    // Find out how many flights there are
		    Flight flight = null;
		    while ((flight = (Flight) flights.getNext()) != null) {
			rows++;
			pStatus.setText("Found " + rows + " matches...");
		    }
		    int total = rows;
    		    prog.setValue("completeValue", total);
		    System.out.println("  Number of rows = " + rows);
        	    grid.addRows(rows);

		    // Add data to grid
		    FlightPlan flightPlan = null;
		    AirlineCompany airline = null;
		    Plane plane = null;
		    flight = null;
		    rows = 0;
		    String r;
		    flights.reset();
		    while ((flight = (Flight) flights.getNext()) != null) {
//		    	System.out.println(flight);
			pStatus.setText("Adding " + (rows+1) + " of " + total + "...");
        		prog.setValue(rows);
        		prog.updateDisplay();
			if (RCommon.isIdentical(flightReservation, flight) == true)
			    flightReservationRow = rows;

			flightPlan = flight.getFlightPlan();		// get flight plan info

			// Set Depart info
			r = " |" + RCommon.getTime(flight.getDepartureDateTime()) + " - " +
				flightPlan.getDepartureAirport().getCode() + "|";

			// Set Arrive info
			r = r + RCommon.getTime(flight.getArrivalDateTime()) + " - " +
				flightPlan.getDestinationAirport().getCode() + "|";

			// Set Airline
			airline = flightPlan.getAirlineCompany();
			r = r + airline.getName() + "|";

			// Set Flight
			r = r + flightPlan.getFlightNumber() + "|";

			// Set Price
			r = r +	"$" + Float.toString(flightPlan.getPrice()) + "|";

			// Set Plane
			plane = flight.getPlane();
			r = r + plane.getName() + "|";

			// Set Conn
			//flight.getConnections();
			r = r + "0| ";
		    	System.out.println("  Added row:" + r);

			// Add row to grid
		    	grid.setStrings(rows, r);
			rows++;
		    }
        	    prog.setValue(total);
        	    prog.updateDisplay();
		}
		else {
		    System.out.println("There are no flights that match criteria.");
		}

	        grid.setValue("layoutFrozen", false);
        	add("10 20 315 115", grid);
                grid.show();

		// If there is a reservation, put X in 1st column
		if (flightReservationRow > -1) {
            	    grid.setStrings(flightReservationRow, "X");

		    // Set seat
                    seat.setText(t.getDepartureFlightReservation().getSeat());
                    pSeatNum.setText("Seat: " + seat.getText());

		    // Select row
        	    grid.selectRow(flightReservationRow, true);
		    selectedRow = flightReservationRow;
	        }

        	// select 1st item in list and show info below box
		else {
		    selectedRow = -1;
        	    grid.selectRow(0, true);
		    if (flightReservation != null) {
   			PopupOk dMsgBox = new PopupOk(applet, RCommon.wEmptyFrame, "Reservation Not in List", false);
    			dMsgBox.title("Flight Reservation:");
			dMsgBox.println("Origination flight reservation is not in new search list.");
        		dMsgBox.show();
		    	dMsgBox.toFront();
		    }
		}

		// Required to force the tab Panel to show new grid results (bug?)
                parent.pack();
		parent.refreshOriginationPage = false;
//                if (exists == true) {
                    parent.skipSummary = true;
                    ((EditTrip)frame).tabPanel.showPage("Summary");
                    ((EditTrip)frame).tabPanel.showPage("Orig Flight");
                    parent.skipSummary = false;
//                }

        	dServerMsgBox.hide();
                dServerMsgBox.dispose();
		dServerMsgBox = null;
		RCommon.defaultCursor();
	}

    	/**
    	*******************************************************
    	* Save data to server
    	*******************************************************
    	*/
	public void saveData() {
	    System.out.println("EditTripOriginationPanel::saveData()");
	    RCommon.waitCursor();

	    // Make new reservation when leaving page

	    // If no iterator, then this panel was never shown, so don't save anything???
	    if (flights == null)
	        return;

	    Flight flight = null;
	    flights.reset();
	    for (int i=0; i<=selectedRow; i++)
	        flight = (Flight) flights.getNext();
	    System.out.println("  New flight = <<" + flight + ">>");

	    // If reservation existed, but no reservation selected, then delete it
	    FlightReservation flightReservation = parent.trip.getDepartureFlightReservation();
	    if ((flightReservation != null) && (selectedRow == -1)) {
	        System.out.println("  No new flight - Canceling old flight = <<" + flightReservation.getFlight() + ">>");
	        parent.trip.cancelDepartureFlightReservation();
                parent.refreshSummaryPage = true;
                parent.tripModified = true;
		return;
	    }

	    // If reservation existed, but a new reservation was selected
	    if (flightReservation != null) {

		// If different reservation was selected
		if (RCommon.isIdentical(flightReservation.getFlight(), flight) == false) { //||
		    System.out.println("  New flight different from old one: delete existing one, add new one");

		    // Delete existing one
		    parent.trip.cancelDepartureFlightReservation();
	    	    System.out.println("  Existing flight = <<" + flightReservation.getFlight() + ">>");

		    // Add new one
    		    flightReservation = parent.trip.reserveDepartureFlight(flight, 1, seat.getText());
                    parent.refreshSummaryPage = true;
                    parent.tripModified = true;
		}

		// If same reservation selected, then set seat
		else {
		    System.out.println("  Same flight, just possibly different seat");
                    if (flightReservation.getSeat().equals(seat.getText()))
                        return;
                    System.out.println("  Different seat");
                    flightReservation.setSeat(seat.getText());
                    parent.refreshSummaryPage = true;
                    parent.tripModified = true;
		}

	    }

	    // If no reservation existed, but a new one was selected, then add a new one
	    else if (selectedRow > -1) {
		System.out.println("  No old reservation, just adding a new one");
    		flightReservation = parent.trip.reserveDepartureFlight(flight, 1, seat.getText());
                parent.refreshSummaryPage = true;
                parent.tripModified = true;
	    }

 	    RCommon.defaultCursor();
	}

	// zpb_end
}
