package COM.ibm.jaws.app.trs.trswin2;
import java.awt.*;
import java.util.*;
import java.applet.*;
import com.roguewave.widgets.*;
// zpb_begin UserImports 
// zpb_end 

/**
 * Class InitObjects.
 *
 *
 * @author    Bryce Curtis
 * @version   2.0 11/21/96 8:49:13am
 * @copyright IBM
 */
public
class InitObjects extends Frame {

	private static Applet applet;
	Label pStatic1, pStatic2;

	// Initial size in logical units
	Dimension initialSize = new Dimension(185, 85);
	Point initialLocation;
	// zpb_begin InitObjectsUserVars 
	// zpb_end 

	// zpb_begin InitObjectsJavadocConstructor 
    /**
     * Creates a specialized window with the specified app and title.
     */
	 // zpb_end 
	InitObjects(Applet app, String title) {
		super(title);
		applet = app;

		// zpb_begin InitObjectsConstructor_1 
		// zpb_end 

		setBackground(Color.lightGray);
		setFont(new Font("Helvetica", Font.PLAIN, 12));
		LogFontLayout lfLayout = new LogFontLayout(this);
		setLayout(lfLayout);

		pStatic1 = new Label("Please wait ...");
		add("10 10 145 12", pStatic1);
		pStatic1.setFont(new Font("Helvetica", Font.BOLD, 15));
		pStatic1.setForeground(Color.blue);
		pStatic2 = new Label("Initializing remote objects on server.");
		add("25 35 134 12", pStatic2);
		pStatic2.setFont(new Font("Helvetica", Font.PLAIN, 15));
		// zpb_begin InitObjectsConstructor_2 
		// zpb_end 

		// Size and Position in logical units
		initialLocation = lfLayout.du(15, 28);
		
		pack();
		move(initialLocation.x, initialLocation.y);

		// zpb_begin InitObjectsConstructor_3 
		// zpb_end 
	}

	// zpb_begin InitObjectsJavadocMinimumSize 
    /**
     * @return  Returns a Dimension with the minimum width and height
     *          of this container.
     */
	 // zpb_end 
	public Dimension minimumSize() {
		// zpb_begin InitObjectsMinimumSize 
		// zpb_end 
			
		LayoutManager layoutMgr = getLayout();
		if (layoutMgr instanceof LogFontLayout) {
			// Convert from logical units to absolute coordinates
			int w = initialSize.width;
			int h = initialSize.height;
			LogFontLayout layout = (LogFontLayout)layoutMgr;
			return new Dimension(layout.duX(w), layout.duY(h));
		}
		return new Dimension(initialSize);
	}

	// zpb_begin InitObjectsJavadocHandleEvent 
    /**
     * Handle events that occur with components in this container.
     *
     * @return  Returns a boolean which specifies whether the event
     *          handler should stop at this level or continue up the
     *          parent hierarchy.
     */
	// zpb_end 
	public boolean handleEvent(Event e) {
		if (e.id == Event.WINDOW_DESTROY) {
			// zpb_begin InitObjectsDestroy 
			// zpb_end 
			dispose();
			return true;
		}

		// zpb_begin InitObjectsHandleEvent 
		// zpb_end 

		return super.handleEvent(e);
	}


	// zpb_begin InitObjectsUserMethods 
	// zpb_end 
}
