package COM.ibm.jaws.app.trs.trswin2;
import java.awt.*;
import java.util.*;
import java.applet.*;
import com.roguewave.widgets.*;
// zpb_begin UserImports

import java.io.*;
import COM.ibm.jaws.util.*;
import COM.ibm.jaws.models.trs.*;

// zpb_end

/**
 * Class Login.
 *
 *
 * @author    Bryce Curtis
 * @version   2.0 11/21/96 8:49:27am
 * @copyright IBM
 */
public
class Login extends Dialog {

	private static Applet applet;
	TextField pUserName, pPassword, pStatus;
	Label pStatic1, pStatic2, pStatic3;
	Button pLogin, pCancel;

	// Initial size in logical units
	Dimension initialSize = new Dimension(236, 145);
	Point initialLocation;
	// zpb_begin LoginUserVars
    	public String nextScreen = "";
    	public Frame fParent = null;
	// zpb_end

	// zpb_begin LoginJavadocConstructor
    /**
     * Creates a specialized window with the specified app and title.
     */
	 // zpb_end
	Login(Applet app, Frame parent, String title, boolean modal) {
		super(parent, title, modal);
		applet = app;
		setResizable(false);

		// zpb_begin LoginConstructor_1
        	fParent = parent;
		// zpb_end

		setFont(new Font("Helvetica", Font.PLAIN, 12));
		LogFontLayout lfLayout = new LogFontLayout(this);
		setLayout(lfLayout);

		pLogin = new Button("Log In");
		add("66 80 40 15", pLogin);
		pLogin.setFont(new Font("Helvetica", Font.BOLD, 15));
		pCancel = new Button("Cancel");
		add("121 80 40 15", pCancel);
		pCancel.setFont(new Font("Helvetica", Font.BOLD, 15));
		pStatic1 = new Label("Please Log In");
		pStatic1.setAlignment(Label.CENTER);
		add("69 5 91 12", pStatic1);
		pStatic1.setFont(new Font("Helvetica", Font.BOLD, 16));
		pStatic2 = new Label("Enter User Name:");
		add("10 30 75 12", pStatic2);
		pStatic2.setFont(new Font("Helvetica", Font.BOLD, 15));
		pUserName = new TextField("");
		add("110 25 94 14", pUserName);
		pUserName.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pPassword = new TextField("");
		add("110 50 94 14", pPassword);
		pPassword.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pStatic3 = new Label("Enter Password:");
		add("10 55 75 12", pStatic3);
		pStatic3.setFont(new Font("Helvetica", Font.BOLD, 15));
		pStatus = new TextField("");
		add("5 110 220 10", pStatus);
		pStatus.setFont(new Font("Helvetica", Font.PLAIN, 11));
		pStatus.setBackground(Color.lightGray);
		pStatus.setEditable(false);
		// zpb_begin LoginConstructor_2
                pPassword.setEchoCharacter('*');
		// zpb_end

		// Size and Position in logical units
		initialLocation = lfLayout.du(15, 28);

		pack();
		move(initialLocation.x, initialLocation.y);

		// zpb_begin LoginConstructor_3
pStatus.setText("Try User Name='bcurtis' Password='bcurtis' or Name='shane' Password='shane'");
                pUserName.requestFocus();
		// zpb_end
	}

	// zpb_begin LoginJavadocMinimumSize
    /**
     * @return  Returns a Dimension with the minimum width and height
     *          of this container.
     */
	 // zpb_end
	public Dimension minimumSize() {
		// zpb_begin LoginMinimumSize
		// zpb_end

		LayoutManager layoutMgr = getLayout();
		if (layoutMgr instanceof LogFontLayout) {
			// Convert from logical units to absolute coordinates
			int w = initialSize.width;
			int h = initialSize.height;
			LogFontLayout layout = (LogFontLayout)layoutMgr;
			return new Dimension(layout.duX(w), layout.duY(h));
		}
		return new Dimension(initialSize);
	}

	// zpb_begin LoginJavadocHandleEvent
    /**
     * Handle events that occur with components in this container.
     *
     * @return  Returns a boolean which specifies whether the event
     *          handler should stop at this level or continue up the
     *          parent hierarchy.
     */
	// zpb_end
	public boolean handleEvent(Event e) {
		if (e.id == Event.WINDOW_DESTROY) {
			// zpb_begin LoginDestroy
            		RCommon.wLogin = null;
			// zpb_end
			dispose();
			return true;
		}

		// zpb_begin LoginHandleEvent
	        // If key was pressed
		if (e.id == Event.KEY_PRESS) {

                    // If Tab key pressed - handle tab order
		    if ((e.key == 9) || (e.key == 10)) {
                       	if (e.target == pUserName) {
                            System.out.println("target=Password");
                            pPassword.requestFocus();
                            pPassword.selectAll();
			}
                        if (e.target == pPassword) {
                            System.out.println("target=Login");
                            pLogin.requestFocus();
			}
                        if (e.target == pLogin) {
                            System.out.println("target=Cancel");
                            pCancel.requestFocus();
			}
                        if (e.target == pCancel) {
                            System.out.println("target=UserName");
                            pUserName.requestFocus();
                            pUserName.selectAll();
			}
			return true;
		    }
 		}
		// zpb_end

		return super.handleEvent(e);
	}

	// zpb_begin LoginJavadocAction
    /**
     * Action handling routine.
     *
     * @return  Returns a boolean specifying whether the event should be handled
     *          furthur up the parent hierarchy.
     */
	// zpb_end
	public boolean action(Event evt, Object obj) {

		if (evt.target == pLogin) {
			// zpb_begin LoginLoginClicked

                        // Don't process if no name
                        String userName = pUserName.getText().trim();
                        String password = pPassword.getText().trim();
                        if (userName.length() == 0) {
                            return false;
                        }

            		// Send login request to host
            		String status = "OK";
			try {
                            System.out.println("Calling login()...");
                            pStatus.setText("Logging In - Please Wait...");
                            RCommon.user = RCommon.session.login(userName, password);
		    	} catch (RuntimeException ex){
			    status = ex.getMessage();
			}
            		pStatus.setText(status);
            		System.out.println("...Done with login()");

            		// If successful
            		if (status.equals("OK")) {
                		pStatus.setText("You are logged on");
                		System.out.println("You are logged on");

                		// Save userId
                		RCommon.userId = pUserName.getText();
				RCommon.userName = RCommon.user.getName();

                		// Send successful event to parent
                		if ((fParent != null) && (fParent != RCommon.wEmptyFrame)) {
                    			System.out.println("Login: Sending event");
                    			Event re = new Event(fParent, 0, RCommon.loginOk, 0, 0, 0, 0);
                    			fParent.handleEvent(re);
                		}

                		// Or show next window
                		else {
                    			if (nextScreen.equals("View")) {
                        			RCommon.showTripList(applet);
                    			}
                    			else if (nextScreen.equals("Profile")) {
                        			//RCommon.showProfile(applet);
                    			}
                		}
            		}

            		// If not successful, then give them another chance
            		else {
                		return false;
            		}

            		RCommon.wLogin = null;
			// zpb_end
			dispose();
			return false;
		}
		else if (evt.target == pCancel) {
			// zpb_begin LoginCancelClicked
            		if (nextScreen.equals("Make")) {
                		RCommon.wReserveList.show();
                		RCommon.wReserveList.toFront();
            		}
			RCommon.user = RCommon.session.login("Unknown", "Unknown");
                	RCommon.userId = "Unknown";
			RCommon.userName = RCommon.user.getName();
            		RCommon.wLogin = null;
                        RCommon.defaultCursor();
			// zpb_end
			dispose();
			return false;
		}

		// zpb_begin LoginAction
		// zpb_end

		return false;
	}


	// zpb_begin LoginUserMethods

        public void paint(Graphics g) {
            update(g);
        }

        public void update(Graphics g) {
       	    Dimension s = size();
       	    Dimension ps = pStatus.size();
	    pStatus.reshape(2, s.height-ps.height-2-20, s.width-4, ps.height);
        }

	// zpb_end
}
