package COM.ibm.jaws.app.trs.trswin2;
import java.awt.*;
import java.util.*;
import java.applet.*;
import com.roguewave.widgets.*;
// zpb_begin UserImports
import COM.ibm.jaws.models.trs.*;
import COM.ibm.jaws.mofw.*;
// zpb_end

/**
 * Class PayForIt.
 *
 *
 * @author    Bryce Curtis
 * @version   2.0 11/21/96 1:29:10pm
 * @copyright IBM
 */
public
class PayForIt extends Dialog {

	private static Applet applet;
	Label pStatic4, pStatic5, pStatic3, pStatic2, pStatic1;
	Choice pHotelCreditCard, pCarCreditCard, pAirlineCreditCard;
	Button pCancel, pOK;

	// Initial size in logical units
	Dimension initialSize = new Dimension(332, 170);
	Point initialLocation;
	// zpb_begin PayForItUserVars
	EditTrip parent = null;
	Trip trip;

	float departurePrice = 0;
	float returnPrice = 0;
	float carPrice = 0;
	float hotelPrice = 0;

	FlightReservation departureRes = null;
	FlightReservation returnRes = null;
	CarReservation carRes = null;
	HotelReservation hotelRes = null;
	long days = 1;

	Label pPrice1, pPrice2, pPrice3;

	// zpb_end

	// zpb_begin PayForItJavadocConstructor
	/**
	 * Creates a specialized window with the specified app and title.
	 */
	 // zpb_end
	PayForIt(Applet app, Frame parent, String title, boolean modal) {
		super(parent, title, modal);
		applet = app;
		setResizable(false);

		// zpb_begin PayForItConstructor_1
		this.parent = (EditTrip)parent;
		// zpb_end

		setFont(new Font("Helvetica", Font.PLAIN, 12));
		LogFontLayout lfLayout = new LogFontLayout(this);
		setLayout(lfLayout);

		pStatic4 = new Label("Price");
		add("105 15 27 12", pStatic4);
		pStatic4.setFont(new Font("Helvetica", Font.BOLD, 15));
		pStatic5 = new Label("Credit Card");
		add("215 15 53 12", pStatic5);
		pStatic5.setFont(new Font("Helvetica", Font.BOLD, 15));
		pCancel = new Button("Cancel");
		add("180 130 40 16", pCancel);
		pCancel.setFont(new Font("Helvetica", Font.BOLD, 15));
		pOK = new Button("OK");
		add("115 130 40 16", pOK);
		pOK.setFont(new Font("Helvetica", Font.BOLD, 15));
		pHotelCreditCard = new Choice();
		add("165 95 155 60", pHotelCreditCard);
		pHotelCreditCard.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pHotelCreditCard.setBackground(Color.white);
		pCarCreditCard = new Choice();
		add("165 60 155 60", pCarCreditCard);
		pCarCreditCard.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pCarCreditCard.setBackground(Color.white);
		pAirlineCreditCard = new Choice();
		add("165 30 155 60", pAirlineCreditCard);
		pAirlineCreditCard.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pAirlineCreditCard.setBackground(Color.white);
		pStatic3 = new Label("Hotel:");
		add("15 95 30 12", pStatic3);
		pStatic3.setFont(new Font("Helvetica", Font.BOLD, 15));
		pStatic2 = new Label("Car Rental:");
		add("15 65 51 12", pStatic2);
		pStatic2.setFont(new Font("Helvetica", Font.BOLD, 15));
		pStatic1 = new Label("Airline:");
		add("15 35 34 12", pStatic1);
		pStatic1.setFont(new Font("Helvetica", Font.BOLD, 15));
		// zpb_begin PayForItConstructor_2
		// zpb_end

		// Size and Position in logical units
		initialLocation = lfLayout.du(15, 28);

		pack();
		move(initialLocation.x, initialLocation.y);

		// zpb_begin PayForItConstructor_3
		// zpb_end
	}

	// zpb_begin PayForItJavadocMinimumSize
	/**
	 * @return  Returns a Dimension with the minimum width and height
	 *          of this container.
	 */
	 // zpb_end
	public Dimension minimumSize() {
		// zpb_begin PayForItMinimumSize
		// zpb_end

		LayoutManager layoutMgr = getLayout();
		if (layoutMgr instanceof LogFontLayout) {
			// Convert from logical units to absolute coordinates
			int w = initialSize.width;
			int h = initialSize.height;
			LogFontLayout layout = (LogFontLayout)layoutMgr;
			return new Dimension(layout.duX(w), layout.duY(h));
		}
		return new Dimension(initialSize);
	}

	// zpb_begin PayForItJavadocHandleEvent
	/**
	 * Handle events that occur with components in this container.
	 *
	 * @return  Returns a boolean which specifies whether the event
	 *          handler should stop at this level or continue up the
	 *          parent hierarchy.
	 */
	// zpb_end
	public boolean handleEvent(Event e) {
		if (e.id == Event.WINDOW_DESTROY) {
			// zpb_begin PayForItDestroy
			// zpb_end
			dispose();
			return true;
		}

		// zpb_begin PayForItHandleEvent
		// zpb_end

		return super.handleEvent(e);
	}

	// zpb_begin PayForItJavadocAction
	/**
	 * Action handling routine.
	 *
	 * @return  Returns a boolean specifying whether the event should be handled
	 *          furthur up the parent hierarchy.
	 */
	// zpb_end
	public boolean action(Event evt, Object obj) {

		if (evt.target == pCancel) {
			// zpb_begin PayForItCancelClicked
			dispose();
            		//Event e = new Event(this, 0, Event.WINDOW_DESTROY, 0, 0, 0, 0);
            		//handleEvent(e);
			return false;
			// zpb_end
		}
		else if (evt.target == pOK) {
			// zpb_begin PayForItOKClicked

			RCommon.waitCursor();
   			PopupOk dMsgBox = new PopupOk(applet, RCommon.wEmptyFrame, "Confirmations for Trip '" + trip.getName() + "'", false);
    			dMsgBox.title("Confirmations:");
			trip.confirm(null);

// No check for failed reservations!
			// Tell trip to close window
                	Event re = new Event(parent, 0, RCommon.reservationOk, 0, 0, 0, 0);
                    	parent.handleEvent(re);

			String s;
			if (departureRes != null) {
        		    dMsgBox.println("Origination Flight:");
			    //trip.getDepartureFlightReservation().confirm(null);
    		    	    s = Integer.toString(departureRes.getConfirmationNumber());
			    dMsgBox.println("  " + s );
			}
			if (returnRes != null) {
        		    dMsgBox.println("Destination Flight:");
			    //trip.getReturnFlightReservation().confirm(null);
    		    	    s = Integer.toString(returnRes.getConfirmationNumber());
			    dMsgBox.println("  "+s );
			}
			if (carRes != null) {
        		    dMsgBox.println("Car Rental:");
			    //trip.getCarReservation().confirm(null);
    		    	    s = Integer.toString(carRes.getConfirmationNumber());
			    dMsgBox.println("  "+s );
			}
			if (hotelRes != null) {
        		    dMsgBox.println("Hotel:");
			    //trip.getHotelReservation().confirm(null);
    		    	    s = Integer.toString(hotelRes.getConfirmationNumber());
			    dMsgBox.println("  "+s );
			}
        		dMsgBox.show();
		    	dMsgBox.toFront();
			RCommon.defaultCursor();

			// zpb_end
		}

		// zpb_begin PayForItAction
		// zpb_end

		return false;
	}


	// zpb_begin PayForItUserMethods

	public void paint(Graphics g) {
		RCommon.waitCursor();
		g.setFont(new Font("Helvetica", Font.PLAIN, 15));
		g.drawString("$" + Float.toString(departurePrice + returnPrice), 190, 70+6);
		g.drawString("$" + Float.toString(carPrice), 190, 130+6);
		g.drawString("$" + Float.toString(hotelPrice), 190, 190+6);
		RCommon.defaultCursor();
    	}

	/**
    	*******************************************************
	* Set info needed for this object
    	*******************************************************
	*/
	public void setInfo(Trip trip) {
		this.trip = trip;
		RCommon.waitCursor();

		// Get credit cards for user
		TravelProfile tprofile = RCommon.user.getTravelProfile();
	    	Iterator cards = null;
		if (tprofile != null)
		    cards = tprofile.getCreditCards();
	    	if (cards == null) {
		    PopupOk dMsgBox = new PopupOk(applet, RCommon.wEmptyFrame, "No Credit Cards", false);
		    dMsgBox.title("No Credit Cards:");
		    dMsgBox.println("You do not have any credit cards entered in TRS.");
		    dMsgBox.println("They may be entered under the Preferences tab when editing a trip.");
		    dMsgBox.show();
		    dMsgBox.toFront();
		    return;
		}
	    	CreditCard card = null;
		String cardType = "";
                while ((card = (CreditCard) cards.getNext()) != null) {
		    cardType = card.getType();
		    pAirlineCreditCard.addItem(cardType);
		    pCarCreditCard.addItem(cardType);
		    pHotelCreditCard.addItem(cardType);
		}

                days = (trip.getReturnDate().getTime() - trip.getDepartureDate().getTime() + 10000000) / 86399560;
                if (days < 1) days = 1;

		departureRes = trip.getDepartureFlightReservation();
		returnRes = trip.getReturnFlightReservation();
		if ((departureRes != null) || (returnRes != null)) {
		    pAirlineCreditCard.enable();
		}
		else {
		    pAirlineCreditCard.disable();
		}

		carRes = trip.getCarReservation();
		if (carRes != null) {
		    pCarCreditCard.enable();
		    carPrice = carRes.getCarFleet().getPrice() * days;
		    System.out.println("Car Price = " + carPrice);
		}
		else {
		    pCarCreditCard.disable();
		}

		hotelRes = trip.getHotelReservation();
		if (hotelRes != null) {
		    pHotelCreditCard.enable();
		    hotelPrice = hotelRes.getRoomGroup().getPrice() * days;
		    System.out.println("Hotel Price = " + hotelPrice);
		}
		else {
		    pHotelCreditCard.disable();
		}

		if (departureRes != null)
		    departurePrice = departureRes.getFlight().getFlightPlan().getPrice();
		if (returnRes != null)
		    returnPrice = returnRes.getFlight().getFlightPlan().getPrice();
		System.out.println("Air Depart Price = " + departurePrice);
		System.out.println("Air Return Price = " + returnPrice);
		repaint();

		RCommon.defaultCursor();

    	}
	// zpb_end
}
