package COM.ibm.jaws.app.trs.trswin2;
import java.awt.*;
import java.util.*;
import java.applet.*;
import com.roguewave.widgets.*;
// zpb_begin UserImports 
// zpb_end 

/**
 * Class Picture.
 *
 *
 * @author    Bryce Curtis
 * @version   2.0 11/21/96 8:49:26am
 * @copyright IBM
 */
public
class Picture extends Dialog {

	private static Applet applet;
	Label pTitle;
	Button pOK;

	// Initial size in logical units
	Dimension initialSize = new Dimension(249, 151);
	Point initialLocation;
	// zpb_begin PictureUserVars 

    Image img;

	// zpb_end 

	// zpb_begin PictureJavadocConstructor 
    /**
     * Creates a specialized dialog with the specified app, parent, title and
     * modality.
     */
	 // zpb_end 
	Picture(Applet app, Frame parent, String title, boolean modal) {
		super(parent, title, modal);
		applet = app;
		setResizable(false);

		// zpb_begin PictureConstructor_1 
		// zpb_end 

		setFont(new Font("Helvetica", Font.PLAIN, 12));
		LogFontLayout lfLayout = new LogFontLayout(this);
		setLayout(lfLayout);

		pOK = new Button("OK");
		add("107 110 32 15", pOK);
		pTitle = new Label("Title:");
		add("5 5 235 12", pTitle);
		pTitle.setFont(new Font("Helvetica", Font.BOLD, 15));
		// zpb_begin PictureConstructor_2 


		// zpb_end 

		// Size and Position in logical units
		initialLocation = lfLayout.du(15, 28);
		
		pack();
		move(initialLocation.x, initialLocation.y);

		// zpb_begin PictureConstructor_3 
		// zpb_end 
	}

	// zpb_begin PictureJavadocMinimumSize 
    /**
     * @return  Returns a Dimension with the minimum width and height
     *          of this container.
     */
	 // zpb_end 
	public Dimension minimumSize() {
		// zpb_begin PictureMinimumSize 
		// zpb_end 
			
		LayoutManager layoutMgr = getLayout();
		if (layoutMgr instanceof LogFontLayout) {
			// Convert from logical units to absolute coordinates
			int w = initialSize.width;
			int h = initialSize.height;
			LogFontLayout layout = (LogFontLayout)layoutMgr;
			return new Dimension(layout.duX(w), layout.duY(h));
		}
		return new Dimension(initialSize);
	}

	// zpb_begin PictureJavadocHandleEvent 
    /**
     * Handle events that occur with components in this container.
     *
     * @return  Returns a boolean which specifies whether the event
     *          handler should stop at this level or continue up the
     *          parent hierarchy.
     */
	// zpb_end 
	public boolean handleEvent(Event e) {
		if (e.id == Event.WINDOW_DESTROY) {
			// zpb_begin PictureDestroy 
			// zpb_end 
			dispose();
			return true;
		}

		// zpb_begin PictureHandleEvent 
		// zpb_end 

		return super.handleEvent(e);
	}

	// zpb_begin PictureJavadocAction 
    /**
     * Action handling routine.
     *
     * @return  Returns a boolean specifying whether the event should be handled
     *          furthur up the parent hierarchy.
     */
	// zpb_end 
	public boolean action(Event evt, Object obj) {

		if (evt.target == pOK) {
			// zpb_begin PictureOKClicked 
			// zpb_end 
			dispose();
			return false;
		}

		// zpb_begin PictureAction 
		// zpb_end 

		return false;
	}


	// zpb_begin PictureUserMethods 

    public boolean imageUpdate(Image theimg, int infoflags,
                                   int x, int y, int w, int h) {
        boolean done = ((infoflags & (ERROR | FRAMEBITS | ALLBITS)) != 0);
        repaint(done ? 0 : 1000);
        return !done;
    }

    public void paint(Graphics g) {
        update(g);
    }

    public void update(Graphics g) {
        System.out.print("Picture: Enter update()...");
        g.drawImage(img, 18, 30, this);
        System.out.println("Picture: ...Exit update()");
    }

    public void getImage(String imageFile) {
        img = applet.getImage(applet.getDocumentBase(), imageFile);
    }


	// zpb_end 
}
