package COM.ibm.jaws.app.trs.trswin2;
import java.awt.*;
import java.util.*;
import java.applet.*;
import com.roguewave.widgets.*;
// zpb_begin UserImports
// zpb_end

/**
 * Class PopupOk.
 *
 *
 * @author    Bryce Curtis
 * @version   2.0 11/21/96 8:49:22am
 * @copyright IBM
 */
public
class PopupOk extends Dialog {

	private static Applet applet;
	Label pTitle;
	Button pButton1;

	// Initial size in logical units
	Dimension initialSize = new Dimension(195, 109);
	Point initialLocation;
	// zpb_begin PopupOkUserVars
	String mes = "";
	boolean showButton = true;
	// zpb_end

	// zpb_begin PopupOkJavadocConstructor
    /**
     * Creates a specialized dialog with the specified app, parent, title and
     * modality.
     */
	 // zpb_end
	PopupOk(Applet app, Frame parent, String title, boolean modal) {
		super(parent, title, modal);
		applet = app;
		setResizable(false);

		// zpb_begin PopupOkConstructor_1
		//Thread.currentThread().setPriority(Thread.MAX_PRIORITY);
		// zpb_end

		setFont(new Font("Helvetica", Font.PLAIN, 12));
		LogFontLayout lfLayout = new LogFontLayout(this);
		setLayout(lfLayout);

		pButton1 = new Button("OK");
		add("80 70 32 15", pButton1);
		pTitle = new Label("This is the title:");
		add("5 5 185 12", pTitle);
		pTitle.setFont(new Font("Helvetica", Font.BOLD, 16));
		// zpb_begin PopupOkConstructor_2
		// zpb_end

		// Size and Position in logical units
		initialLocation = lfLayout.du(15, 28);

		pack();
		move(initialLocation.x, initialLocation.y);

		// zpb_begin PopupOkConstructor_3
		pButton1.hide();
		// zpb_end
	}

	// zpb_begin PopupOkJavadocMinimumSize
    /**
     * @return  Returns a Dimension with the minimum width and height
     *          of this container.
     */
	 // zpb_end
	public Dimension minimumSize() {
		// zpb_begin PopupOkMinimumSize
		// zpb_end

		LayoutManager layoutMgr = getLayout();
		if (layoutMgr instanceof LogFontLayout) {
			// Convert from logical units to absolute coordinates
			int w = initialSize.width;
			int h = initialSize.height;
			LogFontLayout layout = (LogFontLayout)layoutMgr;
			return new Dimension(layout.duX(w), layout.duY(h));
		}
		return new Dimension(initialSize);
	}

	// zpb_begin PopupOkJavadocHandleEvent
    /**
     * Handle events that occur with components in this container.
     *
     * @return  Returns a boolean which specifies whether the event
     *          handler should stop at this level or continue up the
     *          parent hierarchy.
     */
	// zpb_end
	public boolean handleEvent(Event e) {
		if (e.id == Event.WINDOW_DESTROY) {
			// zpb_begin PopupOkDestroy
			// zpb_end
			dispose();
			return true;
		}

		// zpb_begin PopupOkHandleEvent
		// zpb_end

		return super.handleEvent(e);
	}

	// zpb_begin PopupOkJavadocAction
    /**
     * Action handling routine.
     *
     * @return  Returns a boolean specifying whether the event should be handled
     *          furthur up the parent hierarchy.
     */
	// zpb_end
	public boolean action(Event evt, Object obj) {

		if (evt.target == pButton1) {
			// zpb_begin PopupOkButton1Clicked
			// zpb_end
			dispose();
			return false;
		}

		// zpb_begin PopupOkAction
		// zpb_end

		return false;
	}


	// zpb_begin PopupOkUserMethods
	public void print(String s) {
		mes = mes + s;
	}

	public void println(String s) {
		mes = mes + s + " /n ";
	}

	public void title(String s) {
		remove(pTitle);
		pTitle = new Label(s);
		add("5 5 185 12", pTitle);
		pTitle.setFont(new Font("Helvetica", Font.BOLD, 16));
	}

	public void noButton() {
	        showButton = false;
	}

        public void paint(Graphics g) {
		//System.out.println("PopupOK::paint()");

		Dimension s = size();
		g.setFont(new Font("Helvetica", Font.PLAIN, 15));
		int x = 20;
		int y = 50;
		int tw;
		int maxWidth = s.width - x - 20;
		String word = "";
		String line = "";
		int beg = 0;
		int blank = 0;
		int numLines = 0;
		int len = mes.length();
		while (beg < len) {
			blank = mes.indexOf(' ', beg);
			if (blank < 0)
				blank = len;
			word = mes.substring(beg, blank);
			tw = g.getFontMetrics().stringWidth( line + word + " " );
			if (word.equals("/n")) {
				g.drawString(line, x, y);
				y = y + g.getFontMetrics().getHeight();
				line = "";
			}
			else if (tw < maxWidth) {
				line = line + word + " ";
			} else {
				g.drawString(line, x, y);
				y = y + g.getFontMetrics().getHeight();
				line = word + " ";
			}
			beg = blank+1;
		}
		if (line.length() > 0) {
			g.drawString(line, x, y);
			y = y + g.getFontMetrics().getHeight();
		}
		if (showButton) {
		    	pButton1.move( (s.width-pButton1.size().width)/2, y + 20);
			pButton1.show();
		}
		//System.out.println("PopupOK::paint() EXIT");
	}

        public void show() {
		//System.out.println("PopupOK::show()");
		Dimension s = size();
		Font f = new Font("Helvetica", Font.PLAIN, 15);
		int x = 20;
		int y = 50;
		int tw;
		int maxWidth = s.width - x - 20;
		String word = "";
		String line = "";
		int beg = 0;
		int blank = 0;
		int numLines = 0;
		int len = mes.length();
		while (beg < len) {
			blank = mes.indexOf(' ', beg);
			if (blank < 0)
				blank = len;
			word = mes.substring(beg, blank);
			tw = getFontMetrics(f).stringWidth( line + word + " " );
			if (word.equals("/n")) {
				y = y + getFontMetrics(f).getHeight();
				line = "";
			}
			else if (tw < maxWidth) {
				line = line + word + " ";
			} else {
				y = y + getFontMetrics(f).getHeight();
				line = word + " ";
			}
			beg = blank+1;
		}
		if (line.length() > 0) {
			y = y + getFontMetrics(f).getHeight();
		}

		// resize window
		resize( s.width, y + pButton1.size().height + 60); // 40);
		if (showButton)
			pButton1.move( (s.width-pButton1.size().width)/2, y + 20);
		super.show();
		//Graphics g = getGraphics();
		//System.out.println("graphics = " + g);
		//if (g != null) paint(g);
		//System.out.println("PopupOK::show() EXIT");
	}

	// zpb_end
}
