package COM.ibm.jaws.app.trs.trswin2;
import java.awt.*;
import java.util.*;
import java.applet.*;
import com.roguewave.widgets.*;
// zpb_begin UserImports
// zpb_end

/**
 * Class PopupOkCancel.
 *
 *
 * @author    Bryce Curtis
 * @version   2.0 11/21/96 8:49:20am
 * @copyright IBM
 */
public
class PopupOkCancel extends Dialog {

	private static Applet applet;
	Label pTitle;
	Button pButton1, pButton2;

	// Initial size in logical units
	Dimension initialSize = new Dimension(195, 110);
	Point initialLocation;
	// zpb_begin PopupOkCancelUserVars
	String mes = "";
	// zpb_end

	// zpb_begin PopupOkCancelJavadocConstructor
    /**
     * Creates a specialized dialog with the specified app, parent, title and
     * modality.
     */
	 // zpb_end
	PopupOkCancel(Applet app, Frame parent, String title, boolean modal) {
		super(parent, title, modal);
		applet = app;
		setResizable(false);

		// zpb_begin PopupOkCancelConstructor_1
		// zpb_end

		setFont(new Font("Helvetica", Font.PLAIN, 12));
		LogFontLayout lfLayout = new LogFontLayout(this);
		setLayout(lfLayout);

		pButton1 = new Button("OK");
		add("55 70 32 15", pButton1);
		pButton2 = new Button("Cancel");
		add("100 70 32 15", pButton2);
		pTitle = new Label("This is the title:");
		add("5 5 185 12", pTitle);
		pTitle.setFont(new Font("Helvetica", Font.BOLD, 16));
		// zpb_begin PopupOkCancelConstructor_2
		// zpb_end

		// Size and Position in logical units
		initialLocation = lfLayout.du(15, 28);

		pack();
		move(initialLocation.x, initialLocation.y);

		// zpb_begin PopupOkCancelConstructor_3
		pButton1.hide();
		pButton2.hide();
		// zpb_end
	}

	// zpb_begin PopupOkCancelJavadocMinimumSize
    /**
     * @return  Returns a Dimension with the minimum width and height
     *          of this container.
     */
	 // zpb_end
	public Dimension minimumSize() {
		// zpb_begin PopupOkCancelMinimumSize
		// zpb_end

		LayoutManager layoutMgr = getLayout();
		if (layoutMgr instanceof LogFontLayout) {
			// Convert from logical units to absolute coordinates
			int w = initialSize.width;
			int h = initialSize.height;
			LogFontLayout layout = (LogFontLayout)layoutMgr;
			return new Dimension(layout.duX(w), layout.duY(h));
		}
		return new Dimension(initialSize);
	}

	// zpb_begin PopupOkCancelJavadocHandleEvent
    /**
     * Handle events that occur with components in this container.
     *
     * @return  Returns a boolean which specifies whether the event
     *          handler should stop at this level or continue up the
     *          parent hierarchy.
     */
	// zpb_end
	public boolean handleEvent(Event e) {
		if (e.id == Event.WINDOW_DESTROY) {
			// zpb_begin PopupOkCancelDestroy
			// zpb_end
			dispose();
			return true;
		}

		// zpb_begin PopupOkCancelHandleEvent
		// zpb_end

		return super.handleEvent(e);
	}

	// zpb_begin PopupOkCancelJavadocAction
    /**
     * Action handling routine.
     *
     * @return  Returns a boolean specifying whether the event should be handled
     *          furthur up the parent hierarchy.
     */
	// zpb_end
	public boolean action(Event evt, Object obj) {

		if (evt.target == pButton1) {
			// zpb_begin PopupOkCancelButton1Clicked
			// zpb_end
			dispose();
			return false;
		}
		else if (evt.target == pButton2) {
			// zpb_begin PopupOkCancelButton2Clicked
			// zpb_end
			dispose();
			return false;
		}

		// zpb_begin PopupOkCancelAction
		// zpb_end

		return false;
	}


	// zpb_begin PopupOkCancelUserMethods
	public void print(String s) {
		mes = mes + s;
	}

	public void println(String s) {
		mes = mes + s + " /n ";
	}

	public void title(String s) {
		remove(pTitle);
		pTitle = new Label(s);
		add("5 5 185 12", pTitle);
		pTitle.setFont(new Font("Helvetica", Font.BOLD, 16));
	}

        public void paint(Graphics g) {

		Dimension s = size();
		g.setFont(new Font("Helvetica", Font.PLAIN, 15));
		int x = 20;
		int y = 50;
		int tw;
		int maxWidth = s.width - x - 20;
		String word = "";
		String line = "";
		int beg = 0;
		int blank = 0;
		int numLines = 0;
		int len = mes.length();
		while (beg < len) {
			blank = mes.indexOf(' ', beg);
			if (blank < 0)
				blank = len;
			word = mes.substring(beg, blank);
			tw = g.getFontMetrics().stringWidth( line + word + " " );
			if (word.equals("/n")) {
				g.drawString(line, x, y);
				y = y + g.getFontMetrics().getHeight();
				line = "";
			}
			else if (tw < maxWidth) {
				line = line + word + " ";
			} else {
				g.drawString(line, x, y);
				y = y + g.getFontMetrics().getHeight();
				line = word + " ";
			}
			beg = blank+1;
		}
		if (line.length() > 0) {
			g.drawString(line, x, y);
			y = y + g.getFontMetrics().getHeight();
		}

		pButton1.move( (s.width/2)-pButton1.size().width-20, y + 20);
		pButton2.move( (s.width/2)+20, y + 20);
		pButton1.show();
		pButton2.show();
	}

        public void show() {
		System.out.println("show()");
		Dimension s = size();
		Font f = new Font("Helvetica", Font.PLAIN, 15);
		int x = 20;
		int y = 50;
		int tw;
		int maxWidth = s.width - x - 20;
		String word = "";
		String line = "";
		int beg = 0;
		int blank = 0;
		int numLines = 0;
		int len = mes.length();
		while (beg < len) {
			blank = mes.indexOf(' ', beg);
			if (blank < 0)
				blank = len;
			word = mes.substring(beg, blank);
			tw = getFontMetrics(f).stringWidth( line + word + " " );
			if (word.equals("/n")) {
				y = y + getFontMetrics(f).getHeight();
				line = "";
			}
			else if (tw < maxWidth) {
				line = line + word + " ";
			} else {
				y = y + getFontMetrics(f).getHeight();
				line = word + " ";
			}
			beg = blank+1;
		}
		if (line.length() > 0) {
			y = y + getFontMetrics(f).getHeight();
		}

		// resize window
		resize( s.width, y + pButton1.size().height + 40);
		pButton1.move( (s.width/2)-pButton1.size().width-20, y + 20);
		pButton2.move( (s.width/2)+20, y + 20);
		super.show();
	}

	// zpb_end
}
