package COM.ibm.jaws.app.trs.trswin2;
import java.awt.*;
import java.util.*;
import java.applet.*;
import com.roguewave.widgets.*;
// zpb_begin UserImports
import mlsoft.mct.*;
// zpb_end

/**
 * Class ProfileAirPanel.
 *
 *
 * @author    Bryce Curtis
 * @version   2.0 11/21/96 9:02:23am
 * @copyright IBM
 */
public
class ProfileAirPanel extends Panel {
	Label pStatic1, pStatic5, pTextClass;
	Choice pAirClass;
	Button pRight, pLeft;
	Checkbox pFoodVegetarian, pFoodKosher, pFoodAny;
	CheckboxGroup pFoodVegetarianGroup;
	Checkbox pIsle, pWindow;
	private Applet applet = null;
	private Frame  frame  = null;

	// Initial size in logical units
	Dimension initialSize = new Dimension(305, 165);
	Point initialLocation;
	// zpb_begin ProfileAirPanelUserVars
	// zpb_end

	// zpb_begin ProfileAirPanelJavadocConstructor
	/**
	 * Creates a specialized Panel with the specified app and frame.
	 */
	 // zpb_end
	ProfileAirPanel(Applet app, Frame frame) {
		applet = app;
		this.frame = frame;
		// zpb_begin ProfileAirPanelConstructor_1
		// zpb_end

		setFont(new Font("Helvetica", Font.PLAIN, 12));
		LogFontLayout lfLayout = new LogFontLayout(this);
		setLayout(lfLayout);

		pStatic1 = new Label("Seating:");
		add("10 15 43 12", pStatic1);
		pStatic1.setFont(new Font("Helvetica", Font.BOLD, 15));
		pStatic5 = new Label("Food:");
		add("10 70 27 12", pStatic5);
		pStatic5.setFont(new Font("Helvetica", Font.BOLD, 15));
		pRight = new Button(">");
		add("270 140 15 12", pRight);
		pIsle = new Checkbox("Isle");
		add("60 15 35 14", pIsle);
		pIsle.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pWindow = new Checkbox("Window");
		add("110 15 50 14", pWindow);
		pWindow.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pFoodVegetarianGroup = new CheckboxGroup();
		pFoodVegetarian = new Checkbox("Vegetarian", pFoodVegetarianGroup, false);
		add("60 100 53 14", pFoodVegetarian);
		pFoodVegetarian.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pFoodKosher = new Checkbox("Kosher", pFoodVegetarianGroup, false);
		add("60 85 41 14", pFoodKosher);
		pFoodKosher.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pFoodAny = new Checkbox("No Preference", pFoodVegetarianGroup, false);
		add("60 70 67 14", pFoodAny);
		pFoodAny.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pLeft = new Button("<");
		add("255 140 15 12", pLeft);
		pTextClass = new Label("Class:");
		add("10 40 31 12", pTextClass);
		pTextClass.setFont(new Font("Helvetica", Font.BOLD, 15));
		pAirClass = new Choice();
		add("60 40 75 80", pAirClass);
		pAirClass.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pAirClass.setBackground(Color.white);
		pAirClass.addItem("All");
		pAirClass.addItem("Business");
		pAirClass.addItem("Coach");
		pAirClass.addItem("First");
		add("60 40 75 80", pAirClass);
		// zpb_begin ProfileAirPanelConstructor_2
		// zpb_end

		// Size and Position in logical units
		initialLocation = lfLayout.du(5, 5);
		move(initialLocation.x, initialLocation.y);

		// zpb_begin ProfileAirPanelConstructor_3
		// zpb_end
	}

	// zpb_begin ProfileAirPanelAirClassJavadocPaint
	/**
	 * Paints the Panel.  Add specialized functionality for this Panel
	 * between the paint protect block.
	 */
	// zpb_end
	public void paint(Graphics g) {
		Dimension d = size();
		g.drawRect(0,0,d.width-1,d.height-1); // border
		// zpb_begin ProfileAirPanelPaint
		// zpb_end
	}


	// zpb_begin ProfileAirPanelJavadocHandleEvent
	/**
	 * Handle events that occur with components in this container.
	 *
	 * @return  Returns a boolean which specifies whether the event
	 *          handler should stop at this level or continue up the
	 *          parent hierarchy.
	 */
	// zpb_end
	public boolean handleEvent(Event e) {

		// zpb_begin ProfileAirPanelHandleEvent
		// zpb_end

		return super.handleEvent(e);
	}

	// zpb_begin ProfileAirPanelJavadocAction
	/**
	 * Action handling routine.
	 *
	 * @return  Returns a boolean specifying whether the event should be handled
	 *          furthur up the parent hierarchy.
	 */
	// zpb_end
	public boolean action(Event evt, Object obj) {
		if (evt.target == pRight) {
			// zpb_begin PanelRightClicked
			((EditTrip)frame).wProfilePage.tabPanel.showPage("Car");
			// zpb_end
			return false;
		}
		else if (evt.target == pLeft) {
			// zpb_begin PanelLeftClicked
			((EditTrip)frame).wProfilePage.tabPanel.showPage("Credit");
			// zpb_end
			return false;
		}
		else if (evt.target == pAirClass) {
			// zpb_begin PanelAirClassClicked
			// zpb_end
			return false;
		}

		// zpb_begin ProfileAirPanelAction
		// zpb_end

		return false;
	}


	// zpb_begin ProfileAirPanelUserMethods
	/**
    	*******************************************************
    	* Get data from server
    	*******************************************************
    	*/
    	public void getData() {
    	}

    	/**
    	*******************************************************
    	* Save data to server
    	*******************************************************
    	*/
    	public void saveData() {
    	}
	// zpb_end
}
