package COM.ibm.jaws.app.trs.trswin2;
import java.awt.*;
import java.util.*;
import java.applet.*;
import com.roguewave.widgets.*;
// zpb_begin UserImports
import mlsoft.mct.*;
// zpb_end

/**
 * Class ProfileCardPanel.
 *
 *
 * @author    Bryce Curtis
 * @version   2.0 11/21/96 1:29:09pm
 * @copyright IBM
 */
public
class ProfileCardPanel extends Panel {
	Button pLeft;
	private Applet applet = null;
	private Frame  frame  = null;

	// Initial size in logical units
	Dimension initialSize = new Dimension(335, 165);
	Point initialLocation;
	// zpb_begin ProfileCardPanelUserVars
    	MlTabPanel tabPanel;                	// Tab panel
       	ProfileGeneralPanel wGeneralPage;
   	ProfileAddrPanel wHomeAddrPage;
   	ProfileAddrPanel wWorkAddrPage;
       	ProfileCreditPanel wCreditPage;
       	ProfileAirPanel wAirPage;
       	ProfileCarPanel wCarPage;
       	ProfileHotelPanel wHotelPage;
	EditTrip parent = null;
	// zpb_end

	// zpb_begin ProfileCardPanelJavadocConstructor
	/**
	 * Creates a specialized Panel with the specified app and frame.
	 */
	 // zpb_end
	ProfileCardPanel(Applet app, Frame frame) {
		applet = app;
		this.frame = frame;
		// zpb_begin ProfileCardPanelConstructor_1
		parent = (EditTrip)frame;
		// zpb_end

		setFont(new Font("Helvetica", Font.PLAIN, 12));
		LogFontLayout lfLayout = new LogFontLayout(this);
		setLayout(lfLayout);

		pLeft = new Button("<");
		add("300 150 15 12", pLeft);
		// zpb_begin ProfileCardPanelConstructor_2
		pLeft.hide();
		pLeft = new Button("<");
		add("315 150 15 12", pLeft);

       		wGeneralPage = new ProfileGeneralPanel(applet, frame);
       		wGeneralPage.setFont(new Font("Helvetica", Font.PLAIN, 12));
       		wHomeAddrPage = new ProfileAddrPanel(applet, frame);
       		wHomeAddrPage.setFont(new Font("Helvetica", Font.PLAIN, 12));
       		wWorkAddrPage = new ProfileAddrPanel(applet, frame);
       		wWorkAddrPage.setFont(new Font("Helvetica", Font.PLAIN, 12));
       		wCreditPage = new ProfileCreditPanel(applet, frame);
       		wCreditPage.setFont(new Font("Helvetica", Font.PLAIN, 12));
       		wAirPage = new ProfileAirPanel(applet, frame);
       		wAirPage.setFont(new Font("Helvetica", Font.PLAIN, 12));
       		wCarPage = new ProfileCarPanel(applet, frame);
       		wCarPage.setFont(new Font("Helvetica", Font.PLAIN, 12));
       		wHotelPage = new ProfileHotelPanel(applet, frame);
       		wHotelPage.setFont(new Font("Helvetica", Font.PLAIN, 12));

       		tabPanel = new MlTabPanel();
       		//tabPanel.setValue("marginWidth", 5);
       		tabPanel.setValue("tabPlacement", "TABS_ON_RIGHT");
		tabPanel.setValue("highlightColor", Color.red);
	        //tabPanel.setValue("shadowThickness", 0);

        	tabPanel.add("General", wGeneralPage);
       		tabPanel.add("Home", wHomeAddrPage);
       		tabPanel.add("Work", wWorkAddrPage);
       		tabPanel.add("Credit", wCreditPage);
       		tabPanel.add("Air", wAirPage);
       		tabPanel.add("Car", wCarPage);
       		tabPanel.add("Hotel", wHotelPage);
       		//add("0 0 330 180", tabPanel);
       		add("5 5 325 158", tabPanel);

		// zpb_end

		// Size and Position in logical units
		initialLocation = lfLayout.du(5, 5);
		move(initialLocation.x, initialLocation.y);

		// zpb_begin ProfileCardPanelConstructor_3
		// zpb_end
	}

	// zpb_begin ProfileCardPanelLeftJavadocPaint
	/**
	 * Paints the Panel.  Add specialized functionality for this Panel
	 * between the paint protect block.
	 */
	// zpb_end
	public void paint(Graphics g) {
		Dimension d = size();
		g.drawRect(0,0,d.width-1,d.height-1); // border
		// zpb_begin ProfileCardPanelPaint
		// zpb_end
	}


	// zpb_begin ProfileCardPanelJavadocHandleEvent
	/**
	 * Handle events that occur with components in this container.
	 *
	 * @return  Returns a boolean which specifies whether the event
	 *          handler should stop at this level or continue up the
	 *          parent hierarchy.
	 */
	// zpb_end
	public boolean handleEvent(Event e) {

		// zpb_begin ProfileCardPanelHandleEvent
		// zpb_end

		return super.handleEvent(e);
	}

	// zpb_begin ProfileCardPanelJavadocAction
	/**
	 * Action handling routine.
	 *
	 * @return  Returns a boolean specifying whether the event should be handled
	 *          furthur up the parent hierarchy.
	 */
	// zpb_end
	public boolean action(Event evt, Object obj) {
		if (evt.target == pLeft) {
			// zpb_begin PanelLeftClicked
			((EditTrip)frame).tabPanel.showPage("Summary");
			// zpb_end
			return false;
		}

		// zpb_begin ProfileCardPanelAction
        	else if (evt.target == tabPanel) {
		    RCommon.waitCursor();
		    System.out.println("ProfileCardPanel: tabPanel " + obj);
	            String oldProfilePage = parent.currentProfilePage;
		    parent.currentProfilePage = (String)obj;
		    System.out.println("New page = " + parent.currentProfilePage);

		    // Save data of page being left
		    if (oldProfilePage.equals("General")) {
			wGeneralPage.saveData();
		    }
		    else if (oldProfilePage.equals("Home")) {
			wHomeAddrPage.saveData();
		    }
		    else if (oldProfilePage.equals("Work")) {
			wWorkAddrPage.saveData();
		    }
		    else if (oldProfilePage.equals("Credit")) {
			wCreditPage.saveData();
		    }
		    else if (oldProfilePage.equals("Air")) {
			wAirPage.saveData();
		    }
		    else if (oldProfilePage.equals("Car")) {
			wCarPage.saveData();
		    }
		    else if (oldProfilePage.equals("Hotel")) {
			wHotelPage.saveData();
		    }

		    // Get data for new page
		    if (parent.currentProfilePage.equals("General")) {
			    wGeneralPage.getData();
		    }
		    else if (parent.currentProfilePage.equals("Home")) {
			    wHomeAddrPage.getData();
		    }
		    else if (parent.currentProfilePage.equals("Work")) {
			    wWorkAddrPage.getData();
		    }
		    else if (parent.currentProfilePage.equals("Credit")) {
			    wCreditPage.getData();
		    }
		    else if (parent.currentProfilePage.equals("Air")) {
			    wAirPage.getData();
		    }
		    else if (parent.currentProfilePage.equals("Car")) {
			    wCarPage.getData();
		    }
		    else if (parent.currentProfilePage.equals("Hotel")) {
			    wHotelPage.getData();
		    }
		    RCommon.defaultCursor();
		}
		// zpb_end

		return false;
	}


	// zpb_begin ProfileCardPanelUserMethods
	/**
    	*******************************************************
    	* Get data from server
    	*******************************************************
    	*/
    	public void getData() {
	    RCommon.waitCursor();
	    // call getData functions of all embedded cards
	    wGeneralPage.getData();
	    wHomeAddrPage.getData();
	    wWorkAddrPage.getData();
	    wAirPage.getData();
	    wCarPage.getData();
	    wHotelPage.getData();
	    RCommon.defaultCursor();
    	}

    	/**
    	*******************************************************
    	* Save data to server
    	*******************************************************
    	*/
    	public void saveData() {
	    RCommon.waitCursor();
	    System.out.println("ProfileCardPanel::saveData()");
	    // call saveData functions of all embedded cards
	    wGeneralPage.saveData();
	    wHomeAddrPage.saveData();
	    wWorkAddrPage.saveData();
	    wAirPage.saveData();
	    wCarPage.saveData();
	    wHotelPage.saveData();
	    RCommon.defaultCursor();
    	}
	// zpb_end
}
