package COM.ibm.jaws.app.trs.trswin2;

import java.awt.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.applet.Applet;

import COM.ibm.jaws.app.trs.trswin2.Trs;
import COM.ibm.jaws.mofw.*;
import COM.ibm.jaws.motk.*;
import COM.ibm.jaws.util.*;
import COM.ibm.jaws.services.sroot.*;
import COM.ibm.jaws.models.trs.*;
import COM.ibm.corba.ClientORBlet;
import COM.ibm.corba.CORBA;
import COM.ibm.corba.porting.ORBPorting;
import COM.ibm.corba.IIOPStub;


public class RCommon extends Object {
    static BaseCollection 		srootBC = null;
    static public Session		session = null;
    static public RCIterator 		pendingTrips = null;
    static public RCIterator 		confirmedTrips = null;
    static public RCIterator 		takenTrips = null;

    static public int                   loginOk = 10000;
    static public int                   reservationOk = 10001;

    // Applet pointer to Trs
    static public Applet                applet = null;

    // Applet/application flag
    static boolean          		appl = false;

    // Determines if init was already run
    static public boolean               initRun = false;

    // IIOP orb variable
    static public ClientORBlet          orb = null;

    // List of all windows opened by application
    static public Vector		windowList = new Vector();

    // Window pointer to only show one of each window type
    static public EmptyFrame         	wEmptyFrame = null;
    static public EditTrip              wEditTrip = null;
    static public ReserveList           wReserveList = null;
    static public Login                 wLogin = null;
    static public PleaseWait            wPleaseWait = null;
    static public TripList              wTripList = null;
    static public InitObjects           wInitObjects = null;
    static public EditTripDestinationPanel      wEditTripDestination = null;
    static public EditTripOriginationPanel      wEditTripOrigination = null;

    // Next screen to show after init
    static public String                nextScreensAfterInit = "";

    // Cities list
    static public String                citiesList = null;

    // Airports list
    static public String                airportsList = null;

    // Login.java
    static public String                userId = "";
    static public String                userName = "";
    static public User			user = null;

    /**
    *******************************************************
    * Initialize the applet if not already done so.
    *******************************************************
    */
    static public void init(Applet applet) {

        System.out.println("RCommon.init(): Begin");
        try {

        // Run only once
        if (initRun == false) {

            Date tb = new Date();
            Date te = tb;

            // If doing local testing
            if (applet.getParameter("Local").equals("true")) {


        	// Attach to the root of the activation space
//	    	srootBC = SimpleRootBC.getRoot("/jaws/com/ibm/jaws/models/trs/trsApplicationSpace");
                srootBC = SimpleRootBC.getRoot("../../plugins/java/applets/trsApplicationSpace");
	    	session = (Session) srootBC.resolve("session");
	    	System.out.println("session = " + session);
            }

            // If using IIOP
            else {
                // Create iiop client
                orb = CORBA.ORB_init(applet);
                te = new Date();
                System.out.println("  RCommon: Time to init ClientORBlet = " + (te.getTime()-tb.getTime()) );
                applet.showStatus("  Time to init ClientORBlet = " + (te.getTime()-tb.getTime()) );

                tb = new Date();
            	srootBC = (BaseCollection) orb.URLToObject(applet.getParameter("URLToObjectContext") +
                    	";/" + "?COM.ibm.jaws.mofw.BaseCollection");
		ORBPorting.root = srootBC;
	    	session = (Session) srootBC.resolve("session");
	    	System.out.println("session = " + session);
            }

            te = new Date();
            System.out.println("  RCommon: Time to get srootBC = " + (te.getTime()-tb.getTime()) + " " + srootBC );

            // Create temporary user id
            userId = "Unknown";
            userName = "Unknown";
	    user = null;

            initRun = true;
            destroyPleaseWait();
            destroyInitObjects();

// Test
/*
	System.out.println("Temp STUFF -----------------------------------");
	// Get trip
	Trip trip = (Trip) srootBC.resolve("trsApplicationRoot/tripBC/2");
	System.out.println("trip = " + trip);
	System.out.println("================================");
	// Get flight
	Flight flight = (Flight) srootBC.resolve("trsApplicationRoot/flightBC/46");
	System.out.println("flight = " + flight);
	if (flight instanceof IIOPStub) {
		System.out.println("id = " + ((IIOPStub)flight).getIdentifier());
		System.out.println("ior = " + (((IIOPStub)flight).getIOR().toString()));
    	}
	System.out.println("================================");

	// Add flight to trip
    	FlightReservation flightReservation = trip.reserveReturnFlight(flight, 1, "99A");
	System.out.println("done");
//	RCommon.srootBC.release();
	System.out.println("flightReservation = " + flightReservation);
	flight = flightReservation.getFlight();
	System.out.println("flight = " + flight);
	flight = trip.getReturnFlightReservation().getFlight();
	System.out.println("flight = " + flight);
	System.out.println("Temp STUFF -----------------------------------");
*/
// Test

        }

        // If already run, then don't do it again
        else {
            destroyPleaseWait();
            System.out.println("  init() already run");
        }
        } catch (Throwable err) {
            error(err, "RCommon:init()", "Web server may need to be restarted.");
        }
        applet.showStatus("Done initializing remote objects.");
        System.out.println("RCommon.init(): Exit");
    }

    /**
    *******************************************************
    * Close the orb connection.
    *******************************************************
    */
    static public void closeOrb() {
    	orb.close();
    }

    /**
    *******************************************************
    * Display please wait dialog box
    *******************************************************
    */
    static public void showPleaseWait(Applet applet) {
        if (wPleaseWait == null) {
            wPleaseWait = new PleaseWait(applet, "Please Wait...");
	    wPleaseWait.move(150,150);
            wPleaseWait.show();
            wPleaseWait.toFront();

	    // Show WAIT cursor for all windows in application
	    Frame f = null;
       	    for (Enumeration en = windowList.elements() ; en.hasMoreElements() ;) {
	     	f = (Frame)en.nextElement();
		f.setCursor(java.awt.Frame.WAIT_CURSOR);
	    }
	    ((Trs)applet).frame.setCursor(java.awt.Frame.WAIT_CURSOR);
        }
    }

    /**
    *******************************************************
    * Destroys please wait dialog window
    *******************************************************
    */
    static public void destroyPleaseWait() {
        if (wPleaseWait != null) {
            Event re = new Event(wPleaseWait, 0, Event.WINDOW_DESTROY, 0, 0, 0, 0);
            wPleaseWait.handleEvent(re);
            wPleaseWait = null;
        }

	// Show DEFAULT cursor for all windows in application
	Frame f = null;
       	for (Enumeration en = windowList.elements() ; en.hasMoreElements() ;) {
	    f = (Frame)en.nextElement();
	    f.setCursor(java.awt.Frame.DEFAULT_CURSOR);
	}
	((Trs)applet).frame.setCursor(java.awt.Frame.DEFAULT_CURSOR);
    }


    /**
    *******************************************************
    * Sets cursor to wait
    *******************************************************
    */
    static public void waitCursor() {
	// Show WAIT cursor for all windows in application
	Frame f = null;
	for (Enumeration en = windowList.elements() ; en.hasMoreElements() ;) {
	    f = (Frame)en.nextElement();
	    f.setCursor(java.awt.Frame.WAIT_CURSOR);
	}
	((Trs)applet).frame.setCursor(java.awt.Frame.WAIT_CURSOR);
    }


    /**
    *******************************************************
    * Sets cursor to default
    *******************************************************
    */
    static public void defaultCursor() {
	// Show DEFAULT cursor for all windows in application
	Frame f = null;
	for (Enumeration en = windowList.elements() ; en.hasMoreElements() ;) {
	    f = (Frame)en.nextElement();
	    f.setCursor(java.awt.Frame.DEFAULT_CURSOR);
	}
	((Trs)applet).frame.setCursor(java.awt.Frame.DEFAULT_CURSOR);
    }


    /**
    *******************************************************
    * Display initializing objects dialog window
    *******************************************************
    */
    static public void showInitObjects(Applet applet) {
    	System.out.println("ShowInitObjects: entered");
        if (wInitObjects == null) {
        System.out.println("ShowInitObjects: showing dialog");
            wInitObjects = new InitObjects(applet, "Initializing Objects");
            wInitObjects.show();
            wInitObjects.toFront();
        }
    }

    /**
    *******************************************************
    * Destroy initializing objects dialog window
    *******************************************************
    */
    static public void destroyInitObjects() {
        if (wInitObjects != null) {
            Event re = new Event(wInitObjects, 0, Event.WINDOW_DESTROY, 0, 0, 0, 0);
            wInitObjects.handleEvent(re);
            wInitObjects = null;

            // If next screen is Login, then show it
            if (nextScreensAfterInit.lastIndexOf("Login") != -1) {
                if (wLogin == null) {
                    wLogin= new Login(applet, wEmptyFrame, "User Login", true);
                    if (nextScreensAfterInit.lastIndexOf("View") != -1)
                        wLogin.nextScreen = "View";
                    else if (nextScreensAfterInit.lastIndexOf("Profile") != -1) {
                        wLogin.nextScreen = "Profile";
                    }
                    wLogin.show();
                    wLogin.toFront();
                }
            }

            // If next screen is Reserve, then show it
            if (nextScreensAfterInit.lastIndexOf("EditTrip") != -1) {
		if (user != null) {
		    Trip trip = user.addTrip("New Trip",
		    			     "Austin", "Austin",
		    			     new Date(97,0,1), new Date(97,0,3));
                    showEditTrip(applet, trip);
		}
	    }
        }
    }

    /**
    *******************************************************
    * Create an empty frame to use as parent for dialog boxes
    *******************************************************
    */
    static public void showEmptyFrame(Applet applet) {
        if (wEmptyFrame == null) {
            //showPleaseWait(applet);
            wEmptyFrame= new EmptyFrame(applet, "");
        }
    }

    /**
    *******************************************************
    * Show window for editing a trip
    *******************************************************
    */
    static public void showEditTrip(Applet applet, Trip trip) {
    	if (wPleaseWait != null)
            return;
        showPleaseWait(applet);
        wEditTrip= new EditTrip(applet, "Edit Trip");
	wEditTrip.setTrip(trip);
        wEditTrip.move(30,30);
        wEditTrip.show();
        wEditTrip.toFront();
    }

    /**
    *******************************************************
    * Show window of trips taken
    *******************************************************
    */
    static public void showTakenTrip(Applet applet, Trip trip) {
    	if (wPleaseWait != null)
            return;
        showPleaseWait(applet);
        wReserveList= new ReserveList(applet, "Trip Taken");
	wReserveList.setTrip(trip);
        wReserveList.show();
        wReserveList.toFront();
    }

    /**
    *******************************************************
    * Show list of trips window
    *******************************************************
    */
    static public void showTripList(Applet applet) {
        if (wTripList == null) {
            showPleaseWait(applet);
            wTripList= new TripList(applet, "List of Trips");
            wTripList.show();
            wTripList.toFront();
        }
        else {
            wTripList.show();
            wTripList.toFront();
        }
    }

    /**
    *******************************************************
    * Show help about dialog box.
    *******************************************************
    */
    static public void helpAbout(Applet applet) {
	HelpAbout about = new HelpAbout(applet, RCommon.wEmptyFrame, "About", true);
	about.show();
    }

    /**
    *******************************************************
    * Show help.
    *******************************************************
    */
    static public void help(Applet applet, String topic) {
	if (!RCommon.appl) {
	    try {
	        URL nURL = new URL(applet.getDocumentBase(), "Help.html#" + topic);
	        applet.getAppletContext().showDocument(nURL, "_TOP");
            } catch (MalformedURLException ex) {
                System.out.println("Error in URL");
            }
	}
	else
	    notImplemented(applet);
    }


    /**
    *******************************************************
    * Show all windows.
    *******************************************************
    */
    static public void showAll(Applet applet) {
	Frame f = null;
       	for (Enumeration en = windowList.elements() ; en.hasMoreElements() ;) {
	    f = (Frame)en.nextElement();
//            System.out.println("  " + f);
	    f.show();
    	}
    }

    /**
    *******************************************************
    * Hide all windows.
    *******************************************************
    */
    static public void hideAll() {
	Frame f = null;
       	for (Enumeration en = windowList.elements() ; en.hasMoreElements() ;) {
	    f = (Frame)en.nextElement();
//            System.out.println("  " + f);
	    f.hide();
    	}
    }

    /**
    *******************************************************
    * Convert date to string of "mmm dd, yyyy"
    *******************************************************
    */
    static public String getDateString(Date d) {
//        System.out.println("getDateString = " + d);
        String ds = "";
	if (d != null) {
	    if (d.getMonth() == 0)
		ds = "Jan";
	    else if (d.getMonth() == 1)
		ds = "Feb";
	    else if (d.getMonth() == 2)
		ds = "Mar";
	    else if (d.getMonth() == 3)
		ds = "Apr";
	    else if (d.getMonth() == 4)
		ds = "May";
	    else if (d.getMonth() == 5)
		ds = "Jun";
	    else if (d.getMonth() == 6)
		ds = "Jul";
	    else if (d.getMonth() == 7)
		ds = "Aug";
	    else if (d.getMonth() == 8)
		ds = "Sep";
	    else if (d.getMonth() == 9)
		ds = "Oct";
	    else if (d.getMonth() == 10)
		ds = "Nov";
	    else if (d.getMonth() == 11)
		ds = "Dec";
	    ds = ds + " " + Integer.toString(d.getDate());
	    ds = ds + ", " + Integer.toString(d.getYear()+1900);
        }
        return (ds);
    }

    /**
    *******************************************************
    * Convert date to string of "mm/dd/yy"
    *******************************************************
    */
    static public String getDate(Date d) {
//        System.out.println("getDate = " + d);
	if (d == null) return ("");
        String ds = Integer.toString(d.getMonth()+1);
        ds = ds + "/" + Integer.toString(d.getDate());
        ds = ds + "/" + Integer.toString(d.getYear());
        return (ds);
    }

    /**
    *******************************************************
    * Convert time to string of "hh:mm AM"
    *******************************************************
    */
    static public String getTime(Date d) {
//        System.out.println("getTime = " + d);
	if (d == null) return ("");
	int h = d.getHours();
	int m = d.getMinutes();
	String ds = "";
	if (h > 12) {
	    if ((h-12) < 10)
	    	ds = "0";
	    ds = ds + Integer.toString(h-12) + ":";
	}
	else {
	    if (h < 10)
	    	ds = "0";
	    ds = ds + Integer.toString(h) + ":";
	}
	if (m < 10)
	    ds = ds + "0";
        ds = ds + Integer.toString(m);
	if (h > 11)
	    ds = ds + " PM";
	else
	    ds = ds + " AM";
        return (ds);
    }

    /**
    *******************************************************
    * Convert date string to Date object
    *******************************************************
    */
    static public Date stringToDate(String s) {
        System.out.println("stringToDate(" + s + ")");
	try {
	String t = "";
	if (s.indexOf("-") > 0)
	    t = "-";
	else if (s.indexOf("/") > 0)
	    t = "/";
        else {
            System.out.println("stringToDate:  invalid date");
	    return null;
        }
	StringTokenizer st = new StringTokenizer(s, t);
	String m = "";
	String d = "";
	String y = "";
	if (st.hasMoreTokens())
	    m = st.nextToken();
	if (st.hasMoreTokens())
	    d = st.nextToken();
	if (st.hasMoreTokens())
	    y = st.nextToken();
	if (y.equals("")) {
	    y = d;
	    d = "1";
	}
	//System.out.println("m=" + m + " d=" + d + "y=" + y);
	int vm, vd, vy;
	vm = Integer.valueOf(m.trim()).intValue() -1;
	vd = Integer.valueOf(d.trim()).intValue();
	vy = Integer.valueOf(y.trim()).intValue();
	if (vy > 1900)
	    vy = vy-1900;
	Date date = new Date(vy, vm, vd);
        System.out.println("stringToDate: (" + s + ") Returning date" + date);
	return date;
    	} catch (RuntimeException e) {
	    System.out.println("stringToDate error: (" + s + ") Returning current date");
	    return new Date();
	}
    }

    /**
    *******************************************************
    * Get list of cities as a tokenized string and fill in
    * up to two choice controls.
    *******************************************************
    */
    static public void getCities(Choice choice1, Choice choice2) {
	System.out.println("  RCommon::getCities()");
        try {
        // Only read in cities list once from server
        if (citiesList == null) {

	    RCIterator cities = session.getCities();
	    cities.reset();
	    System.out.println("Iterator cities = " + cities);
	    City city = (City) cities.getNext();
//	    System.out.println("1st city = " + city);
	    if (city != null) {
            	citiesList = city.getCityState();
	    	while ((city = (City) cities.getNext()) != null) {
            	    citiesList = citiesList + "|" + city.getCityState();
		}
	    }

            // There is only data for Austin & Atlanta for trips
            citiesList = "Austin, TX|Atlanta, GA";
            System.out.println("  RCommon: Read Cities = " + citiesList);
        }
        String c = "";
        StringTokenizer st = new StringTokenizer(citiesList, "|");
        while (st.hasMoreTokens()) {
            c = st.nextToken();
            if (choice1 != null)
                choice1.addItem( c );
            if (choice2 != null)
                choice2.addItem( c );
        }
        } catch (Throwable err) {
            error(err, "RCommon:getCities()", "Web server may need to be restarted.");
        }

    }

    /**
    *******************************************************
    * Get list of airports as a tokenized string and fill in
    * up to two choice controls.
    *******************************************************
    */
    // This method isn't being used
    static public void getAirports(Choice choice1, Choice choice2) {
        try {
        // Only read in cities list once from server
        if (airportsList == null) {
	    airportsList = "Atlanta, GA|Austin, TX|Miami, FL|New York, NY";
            System.out.println("  RCommon: Read Airports = " + airportsList);
        }
        String c = "";
        StringTokenizer st = new StringTokenizer(airportsList, "|");
        while (st.hasMoreTokens()) {
            c = st.nextToken();
            if (choice1 != null)
                choice1.addItem( c );
            if (choice2 != null)
                choice2.addItem( c );
        }
        } catch (Throwable err) {
            error(err, "RCommon:getAirports()", "Web server may need to be restarted.");
        }

    }

    /**
    *******************************************************
    * Pops up a not implemented dialog box.
    *******************************************************
    */
    static public void notImplemented(Applet applet) {
        NotImplemented dNotImplemented =
                new NotImplemented(applet, wEmptyFrame, "Not Implemented", true);
        dNotImplemented.show();
    }

    /**
    *******************************************************
    * Pops up an error dialog box.
    *******************************************************
    */
    static public void error(Throwable err, String m, String s) {
    	PopupOk dErrorBox = new PopupOk(applet, wEmptyFrame, "Error", true);
    	dErrorBox.title("An Application Error Has Occurred:");
    	dErrorBox.print("There has been an error in the application.  You should close your web");
    	dErrorBox.print(" browser and restart it.  If this does not resolve the error, then the web");
    	dErrorBox.println(" server may need to be restarted.  Please contact your system administrator.");
    	if (err.getMessage() != null) {
            dErrorBox.println("");
            dErrorBox.println( err.getMessage() );
    	}
    	dErrorBox.println("");
        dErrorBox.println( "Module = "+m );
        if (s.equals("")) {}
        else
           dErrorBox.println( s );
        dErrorBox.show();
        err.printStackTrace();
    }

    /**
    *******************************************************
    * Pops up an error dialog box.
    *******************************************************
    */
    static public void error(String m, String s) {
	error(m, s, true);
    }

    /**
    *******************************************************
    * Pops up an error dialog box.
    *******************************************************
    */
    static public void error(String m, String s, boolean b) {
    	PopupOk dErrorBox = new PopupOk(applet, wEmptyFrame, "Error", b);
    	dErrorBox.title("An Application Error Has Occurred:");
    	dErrorBox.print("There has been an error in the application.  You should close your web");
    	dErrorBox.print(" browser and restart it.  If this does not resolve the error, then the web");
    	dErrorBox.println(" server may need to be restarted.  Please contact your system administrator.");
    	dErrorBox.println("");
        dErrorBox.println( "Module = "+m );
        if (s.equals("")) {}
        else
           dErrorBox.println( s );
        dErrorBox.show();
    	dErrorBox.toFront();
    }

    /**
    *******************************************************
    * Determine if two managed objects are the same
    *******************************************************
    */
    static public boolean isIdentical(Object object1, Object object2) {
	if ((object1 == null) || (object2 == null))
	    return false;
//	System.out.println("RCommon::isIdentical()");
	String id1, id2;
	if (object1 instanceof Managed) {
//		System.out.println("  objects are Managed");
		id1 = ((Managed)object1).getIdentifier(srootBC);
		id2 = ((Managed)object2).getIdentifier(srootBC);
	}
	else if (object1 instanceof IIOPStub) {
//		System.out.println("  objects are Stubs");
		id1 = ((IIOPStub)object1).getIdentifier();
		id2 = ((IIOPStub)object2).getIdentifier();
	}
	else  // if not managed or stub
	    return false;

//	System.out.println("  Identifiers: id1=" + id1 + "  id2=" + id2);
	if (id1.equals(id2)) {
//	    System.out.println("  Objects are EQUAL! id1=" + id1 + "id2=" + id2);
	    return true;
	}
//	System.out.println("  Objects are NOT equal!");
	return false;
    }

    /**
    *******************************************************
    * Get the hashcode of an object instead of doing a remote method call
    *******************************************************
    */
    static public String getHash(Object o) {
        return o.getClass().getName() + "@" + Integer.toHexString(o.hashCode());
    }

    static public void showDateMsg() {
            DateMsg wDateMsg = new DateMsg(applet, "No Trip Data");
	    wDateMsg.move(10,10);
            wDateMsg.show();
            wDateMsg.toFront();
    }

    static public void reservationsCancelled() {
            PopupOk dBox = new PopupOk(applet, wEmptyFrame, "Reservations Cancelled", false);
            dBox.title("Reservations Cancelled:");
            dBox.println("You have modified the trip, so your reservations have been cancelled.");
            dBox.move(10,10);
            dBox.show();
            dBox.toFront();
    }


}
