package COM.ibm.jaws.app.trs.trswin2;
import java.awt.*;
import java.util.*;
import java.applet.*;
import com.roguewave.widgets.*;
// zpb_begin UserImports

import mlsoft.mct.*;
import COM.ibm.jaws.models.trs.*;
import java.net.*;
// zpb_end

/**
 * Class ReserveList.
 *
 *
 * @author    Bryce Curtis
 * @version   2.0 11/21/96 8:48:55am
 * @copyright IBM
 */
public
class ReserveList extends Frame {

	private static Applet applet;
	Label pTitle;
	Hashtable menuitems = new Hashtable();
	Button pMakeReservations, pCancel;

	// Initial size in logical units
	Dimension initialSize = new Dimension(351, 226);
	Point initialLocation;
	// zpb_begin ReserveListUserVars

    	MlTabPanel tabPanel;                // Tab panel
    	boolean cancelPressed = true;
       	ReserveList1Main wMainPage = null;
       	ReserveList1Air wAirPage = null;
       	ReserveList1Car wCarPage = null;
       	ReserveList1Hotel wHotelPage = null;
	Trip trip = null;					// reference to remote trip object
	FlightReservation departFlight = null;
	FlightReservation returnFlight = null;
	HotelReservation hotelRes = null;
	CarReservation carRes = null;

        MlProgress prog = null;                                 // variables for progress indicator
        Label pStatus = null;
        int progValue = 0;
        int progTotal = 0;

	// zpb_end

	// zpb_begin ReserveListJavadocConstructor
    /**
     * Creates a specialized window with the specified app and title.
     */
	 // zpb_end
	ReserveList(Applet app, String title) {
		super(title);
		applet = app;

		// zpb_begin ReserveListConstructor_1
		RCommon.windowList.addElement(this);
		// zpb_end

		setBackground(Color.lightGray);
		setFont(new Font("Helvetica", Font.PLAIN, 12));
		LogFontLayout lfLayout = new LogFontLayout(this);
		setLayout(lfLayout);

		pMakeReservations = new Button("Make Reservations Now!");
		add("99 243 121 16", pMakeReservations);
		pMakeReservations.setFont(new Font("Helvetica", Font.BOLD, 15));
		pTitle = new Label("Trip to the Olympics");
		pTitle.setAlignment(Label.CENTER);
		add("10 5 330 12", pTitle);
		pTitle.setFont(new Font("Helvetica", Font.BOLD, 17));
		pCancel = new Button("Cancel");
		add("143 195 60 16", pCancel);
		pCancel.setFont(new Font("Helvetica", Font.BOLD, 15));

		// Add the MenuBar, Menus, and Menuitems
		MenuBar mbMenu1 = new MenuBar();
		MenuItem mi;
		Menu mFile = new Menu("File");
		menuitems.put("File", mFile);
		mi=new MenuItem("Close");
		mFile.add(mi);
		menuitems.put("FileClose",mi);
		mbMenu1.add(mFile);
		Menu mView = new Menu("View");
		menuitems.put("View", mView);
		mi=new MenuItem("Leave City Info");
		mView.add(mi);
		menuitems.put("ViewLeaveCityInfo",mi);
		mi=new MenuItem("Leave City Weather");
		mView.add(mi);
		menuitems.put("ViewLeaveCityWeather",mi);
		mi=new MenuItem("Leave City Airport");
		mView.add(mi);
		menuitems.put("ViewLeaveCityAirport",mi);
		mView.add(new MenuItem("-"));
		mi=new MenuItem("Return City Info");
		mView.add(mi);
		menuitems.put("ViewReturnCityInfo",mi);
		mi=new MenuItem("Return City Weather");
		mView.add(mi);
		menuitems.put("ViewReturnCityWeather",mi);
		mi=new MenuItem("Return City Airport");
		mView.add(mi);
		menuitems.put("ViewReturnCityAirport",mi);
		mView.add(new MenuItem("-"));
		mi=new MenuItem("Airline Reservation");
		mView.add(mi);
		menuitems.put("ViewAirlineReservation",mi);
		mi=new MenuItem("Car Rental Reservation");
		mView.add(mi);
		menuitems.put("ViewCarRentalReservation",mi);
		mi=new MenuItem("Hotel Reservation");
		mView.add(mi);
		menuitems.put("ViewHotelReservation",mi);
		mbMenu1.add(mView);
		Menu mHelp = new Menu("Help");
		menuitems.put("Help", mHelp);
		mi=new MenuItem("Contents");
		mHelp.add(mi);
		menuitems.put("HelpContents",mi);
		mi=new MenuItem("Search...");
		mHelp.add(mi);
		menuitems.put("HelpSearch",mi);
		mHelp.add(new MenuItem("-"));
		mi=new MenuItem("About...");
		mHelp.add(mi);
		menuitems.put("HelpAbout",mi);
		mbMenu1.add(mHelp);
		this.setMenuBar(mbMenu1);
		// zpb_begin ReserveListConstructor_2

		pCancel.setLabel("Close");

        	wMainPage = new ReserveList1Main(applet, this);
        	wMainPage.setFont(new Font("Helvetica", Font.PLAIN, 12));
        	wAirPage = new ReserveList1Air(applet, this);
        	wAirPage.setFont(new Font("Helvetica", Font.PLAIN, 12));
        	wCarPage = new ReserveList1Car(applet, this);
        	wMainPage.setFont(new Font("Helvetica", Font.PLAIN, 12));
        	wHotelPage = new ReserveList1Hotel(applet, this);
        	wHotelPage.setFont(new Font("Helvetica", Font.PLAIN, 12));

        	tabPanel = new MlTabPanel();
        	tabPanel.setValue("marginWidth", 15);

	        tabPanel.add("General", wMainPage);
        	add("5 25 335 160", tabPanel);
        	tabPanel.add("Airline", wAirPage);
        	add("5 25 335 160", tabPanel);
        	tabPanel.add("Car Rental", wCarPage);
        	add("5 25 335 160", tabPanel);
        	tabPanel.add("Hotel", wHotelPage);
        	add("5 25 335 160", tabPanel);

		// zpb_end

		// Size and Position in logical units
		initialLocation = lfLayout.du(15, 28);

		pack();
		move(initialLocation.x, initialLocation.y);

		// zpb_begin ReserveListConstructor_3
		// zpb_end
	}

	// zpb_begin ReserveListJavadocMinimumSize
    /**
     * @return  Returns a Dimension with the minimum width and height
     *          of this container.
     */
	 // zpb_end
	public Dimension minimumSize() {
		// zpb_begin ReserveListMinimumSize
		// zpb_end

		LayoutManager layoutMgr = getLayout();
		if (layoutMgr instanceof LogFontLayout) {
			// Convert from logical units to absolute coordinates
			int w = initialSize.width;
			int h = initialSize.height;
			LogFontLayout layout = (LogFontLayout)layoutMgr;
			return new Dimension(layout.duX(w), layout.duY(h));
		}
		return new Dimension(initialSize);
	}

	// zpb_begin ReserveListJavadocHandleEvent
    /**
     * Handle events that occur with components in this container.
     *
     * @return  Returns a boolean which specifies whether the event
     *          handler should stop at this level or continue up the
     *          parent hierarchy.
     */
	// zpb_end
	public boolean handleEvent(Event e) {
		if (e.id == Event.WINDOW_DESTROY) {
			// zpb_begin ReserveListDestroy
			RCommon.windowList.removeElement(this);
			// zpb_end
			dispose();
			return true;
		}

		// zpb_begin ReserveListHandleEvent
		// zpb_end

		return super.handleEvent(e);
	}

	// zpb_begin ReserveListJavadocAction
    /**
     * Action handling routine.
     *
     * @return  Returns a boolean specifying whether the event should be handled
     *          furthur up the parent hierarchy.
     */
	// zpb_end
	public boolean action(Event evt, Object obj) {
		if (evt.target instanceof MenuItem) {
			if (menuitems.get("FileClose") == evt.target) {
				// zpb_begin ReserveListFileCloseSelection
            			cancelPressed = true;
            			Event e = new Event(this, 0, Event.WINDOW_DESTROY, 0, 0, 0, 0);
            			handleEvent(e);
				// zpb_end
			}
			else if (menuitems.get("ViewLeaveCityInfo") == evt.target) {
				// zpb_begin ReserveListViewLeaveCityInfoSelection
                                URL nURL = trip.getDepartureCity().getURL();
                                System.out.println("URL = " + nURL);
	    			if (!RCommon.appl) {
                        	    applet.getAppletContext().showDocument(nURL, "_TOP");
				}
				// zpb_end
			}
			else if (menuitems.get("ViewLeaveCityWeather") == evt.target) {
				// zpb_begin ReserveListViewLeaveCityWeatherSelection
                                URL nURL = trip.getDepartureCity().getWeatherURL();
                                System.out.println("URL = " + nURL);
	    			if (!RCommon.appl) {
                        	    applet.getAppletContext().showDocument(nURL, "_TOP");
				}
				// zpb_end
			}
			else if (menuitems.get("ViewLeaveCityAirport") == evt.target) {
				// zpb_begin ReserveListViewLeaveCityAirportSelection
                                if (departFlight != null) {
                                    URL nURL = departFlight.getFlight().getFlightPlan().getDepartureAirport().getURL();
                                    System.out.println("URL = " + nURL);
                                    if (!RCommon.appl) {
                        	    	applet.getAppletContext().showDocument(nURL, "_TOP");
				    }
				}
				// zpb_end
			}
			else if (menuitems.get("ViewReturnCityInfo") == evt.target) {
				// zpb_begin ReserveListViewReturnCityInfoSelection
                                URL nURL = trip.getDestinationCity().getURL();
                                System.out.println("URL = " + nURL);
	    			if (!RCommon.appl) {
                        	    applet.getAppletContext().showDocument(nURL, "_TOP");
				}
				// zpb_end
			}
			else if (menuitems.get("ViewReturnCityWeather") == evt.target) {
				// zpb_begin ReserveListViewReturnCityWeatherSelection
                                URL nURL = trip.getDestinationCity().getWeatherURL();
                                System.out.println("URL = " + nURL);
	    			if (!RCommon.appl) {
                        	    applet.getAppletContext().showDocument(nURL, "_TOP");
				}
				// zpb_end
			}
			else if (menuitems.get("ViewReturnCityAirport") == evt.target) {
				// zpb_begin ReserveListViewReturnCityAirportSelection
                                if (returnFlight != null) {
                                    URL nURL = returnFlight.getFlight().getFlightPlan().getDepartureAirport().getURL();
                                    System.out.println("URL = " + nURL);
                                    if (!RCommon.appl) {
                        	    	applet.getAppletContext().showDocument(nURL, "_TOP");
				    }
				}
				// zpb_end
			}
			else if (menuitems.get("ViewAirlineReservation") == evt.target) {
				// zpb_begin ReserveListViewAirlineReservationSelection
				tabPanel.showPage("Airline");
				// zpb_end
			}
			else if (menuitems.get("ViewCarRentalReservation") == evt.target) {
				// zpb_begin ReserveListViewCarRentalReservationSelection
				tabPanel.showPage("Car Rental");
				// zpb_end
			}
			else if (menuitems.get("ViewHotelReservation") == evt.target) {
				// zpb_begin ReserveListViewHotelReservationSelection
				tabPanel.showPage("Hotel");
				// zpb_end
			}
			else if (menuitems.get("HelpContents") == evt.target) {
				// zpb_begin ReserveListHelpContentsSelection
                		RCommon.help(applet, "ReserveList");
				// zpb_end
			}
			else if (menuitems.get("HelpSearch") == evt.target) {
				// zpb_begin ReserveListHelpSearchSelection
                		RCommon.notImplemented(applet);
				// zpb_end
			}
			else if (menuitems.get("HelpAbout") == evt.target) {
				// zpb_begin ReserveListHelpAboutSelectionCreate
                		RCommon.helpAbout(applet);
				// zpb_end
				// zpb_begin ReserveListHelpAboutSelection
				// zpb_end
			}

			return false;
		}


		if (evt.target == pMakeReservations) {
			// zpb_begin ReserveListMakeReservationsClicked
			// zpb_end
		}
		else if (evt.target == pCancel) {
			// zpb_begin ReserveListCancelClicked
            		cancelPressed = true;
            		Event e = new Event(this, 0, Event.WINDOW_DESTROY, 0, 0, 0, 0);
            		handleEvent(e);
			// zpb_end
		}

		// zpb_begin ReserveListAction
		// zpb_end

		return false;
	}


	// zpb_begin ReserveListUserMethods
    	/**
    	*******************************************************
    	* Set trip to be edited
    	*******************************************************
    	*/
	public void setTrip(Trip t) {
	    // If trip is not valid, then close window
	    if (t == null) {
       	    	RCommon.destroyPleaseWait();
		System.out.println("Could not set trip");
		return;
	    }
	    trip = t;
	    getData();				// Get data from server
	    setTitle("Viewing Trip '" + trip.getName() + "'");
	    remove(pTitle);
	    pTitle = new Label(trip.getName());
	    pTitle.setAlignment(Label.CENTER);
	    add("10 5 330 12", pTitle);
	    pTitle.setFont(new Font("Helvetica", Font.BOLD, 17));
       	    RCommon.destroyPleaseWait();	// remove wait dialog
	}

	/**
    	*******************************************************
    	* Get data from server
    	*******************************************************
    	*/
	public void getData() {
//	    System.out.println("ReserveList::getData()  trip=" + trip);

	    PopupOk dServerMsgBox = new PopupOk(applet, RCommon.wPleaseWait, "Please Wait...", false);
	    dServerMsgBox.title("Getting trip data...");
	    dServerMsgBox.move(100,100);
	    prog = new MlProgress();
	    prog.reshape(0, 0, 280, 16); // 300, 20);
	    prog.setValue("showTime", true);
	    dServerMsgBox.add("20 35 140 8", prog);
            progTotal = 37;
            prog.setValue("completeValue", progTotal);
            pStatus = new Label("Querying server...      ");
	    dServerMsgBox.add("20 20 70 15", pStatus);
	    pStatus.setFont(new Font("Helvetica", Font.PLAIN, 15));
	    dServerMsgBox.pButton1.hide();
	    dServerMsgBox.show();
	    dServerMsgBox.toFront();
	    prog.setValue(0);
	    prog.updateDisplay();

	    departFlight = trip.getDepartureFlightReservation();
            setNextProgress();
	    returnFlight = trip.getReturnFlightReservation();
            setNextProgress();
	    carRes = trip.getCarReservation();
            setNextProgress();
	    hotelRes = trip.getHotelReservation();
            setNextProgress();
            wMainPage.getData();
            setNextProgress();
            wAirPage.getData();
            setNextProgress();
            wCarPage.getData();
            setNextProgress();
            wHotelPage.getData();
            setNextProgress();
	    dServerMsgBox.pButton1.hide();
            dServerMsgBox.hide();
            dServerMsgBox.dispose();
	    dServerMsgBox = null;
    	}

    	public void saveData() {
    	}

        public void setNextProgress() {
            progValue++;
            prog.setValue(progValue);
    	    prog.updateDisplay();
            pStatus.setText("Getting " + progValue + " of " + progTotal + " Items");
        }

	// zpb_end
}
