package COM.ibm.jaws.app.trs.trswin2;
import java.awt.*;
import java.util.*;
import java.applet.*;
import com.roguewave.widgets.*;
// zpb_begin UserImports
import COM.ibm.jaws.models.trs.*;
// zpb_end

/**
 * Class ReserveList1Air.
 *
 *
 * @author    Bryce Curtis
 * @version   2.0 11/21/96 8:49:03am
 * @copyright IBM
 */
public
class ReserveList1Air extends Panel {
	Label pLeaveFlight5, pLeaveFlight4, pLeaveFlight3, pLeaveFlight2, pLeaveFlight1,
pReturnFlight5, pReturnFlight4, pReturnFlight3, pReturnFlight2, pReturnFlight1,
pConfirmation, pPrice, pStatic1, pStatic2, pStatic3, pStatic4;
	private Applet applet = null;
	private Frame  frame  = null;

	// Initial size in logical units
	Dimension initialSize = new Dimension(335, 140);
	Point initialLocation;
	// zpb_begin ReserveList1AirUserVars
	ReserveList parent = null;
	// zpb_end

	// zpb_begin ReserveList1AirJavadocConstructor
    /**
     * Creates a specialized Panel with the specified app and frame.
     */
	 // zpb_end
	ReserveList1Air(Applet app, Frame frame) {
		applet = app;
		this.frame = frame;
		// zpb_begin ReserveList1AirConstructor_1
		parent = (ReserveList)frame;
		// zpb_end

		setFont(new Font("Helvetica", Font.PLAIN, 12));
		LogFontLayout lfLayout = new LogFontLayout(this);
		setLayout(lfLayout);

		pLeaveFlight5 = new Label("   ");
		add("75 45 8 12", pLeaveFlight5);
		pLeaveFlight5.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pLeaveFlight4 = new Label("Connections in Dallas, TX");
		add("75 35 97 12", pLeaveFlight4);
		pLeaveFlight4.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pLeaveFlight3 = new Label("Depart 7:35 AM -> Arrive 12:10 PM");
		add("75 25 129 12", pLeaveFlight3);
		pLeaveFlight3.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pLeaveFlight2 = new Label("Delta, Flight 1327, B767, Seat 15E");
		add("75 15 129 10", pLeaveFlight2);
		pLeaveFlight2.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pLeaveFlight1 = new Label("Jul 19, 1996 from AUS to ATL");
		add("75 5 110 12", pLeaveFlight1);
		pLeaveFlight1.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pReturnFlight5 = new Label("   ");
		add("75 100 8 12", pReturnFlight5);
		pReturnFlight5.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pReturnFlight4 = new Label("Connections in Dallas, TX");
		add("75 90 97 12", pReturnFlight4);
		pReturnFlight4.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pReturnFlight3 = new Label("Depart 10:35 AM -> Arrive 2:20 PM");
		add("75 80 129 12", pReturnFlight3);
		pReturnFlight3.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pReturnFlight2 = new Label("Delta, Flight 7727, B767, Seat 34A");
		add("75 70 129 10", pReturnFlight2);
		pReturnFlight2.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pReturnFlight1 = new Label("Aug 8, 1996 from ATL to AUS");
		add("75 60 145 12", pReturnFlight1);
		pReturnFlight1.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pConfirmation = new Label("12N348273");
		add("75 120 43 12", pConfirmation);
		pConfirmation.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pPrice = new Label("$1200.00");
		add("190 120 35 12", pPrice);
		pPrice.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pStatic1 = new Label("Leave Flight:");
		add("10 5 62 12", pStatic1);
		pStatic1.setFont(new Font("Helvetica", Font.BOLD, 15));
		pStatic2 = new Label("Return Flight:");
		add("10 60 58 12", pStatic2);
		pStatic2.setFont(new Font("Helvetica", Font.BOLD, 15));
		pStatic3 = new Label("Confirmation:");
		add("10 120 57 12", pStatic3);
		pStatic3.setFont(new Font("Helvetica", Font.BOLD, 15));
		pStatic4 = new Label("Price:");
		add("155 120 26 12", pStatic4);
		pStatic4.setFont(new Font("Helvetica", Font.BOLD, 15));
		// zpb_begin ReserveList1AirConstructor_2
		// zpb_end

		// Size and Position in logical units
		initialLocation = lfLayout.du(10, 30);
		move(initialLocation.x, initialLocation.y);

		// zpb_begin ReserveList1AirConstructor_3
		// zpb_end
	}

	// zpb_begin ReserveList1AirStatic4JavadocPaint
	/**
	 * Paints the Panel.  Add specialized functionality for this Panel
	 * between the paint protect block.
	 */
	// zpb_end
	public void paint(Graphics g) {
		Dimension d = size();
		g.drawRect(0,0,d.width-1,d.height-1); // border
		// zpb_begin ReserveList1AirPaint
		// zpb_end
	}


	// zpb_begin ReserveList1AirJavadocHandleEvent
    /**
     * Handle events that occur with components in this container.
     *
     * @return  Returns a boolean which specifies whether the event
     *          handler should stop at this level or continue up the
     *          parent hierarchy.
     */
	// zpb_end
	public boolean handleEvent(Event e) {

		// zpb_begin ReserveList1AirHandleEvent
		// zpb_end

		return super.handleEvent(e);
	}


	// zpb_begin ReserveList1AirUserMethods

	/**
    	*******************************************************
    	* Get data from server
    	*******************************************************
    	*/
	public void getData() {
	    Trip t = parent.trip;
	    Flight flight = null;
	    FlightPlan flightPlan = null;
	    float p = 0;
	    String c = "";

	    // Set departure flight info
	    if (parent.departFlight != null) {
		flight = parent.departFlight.getFlight();
		flightPlan = flight.getFlightPlan();
                parent.setNextProgress();
                pLeaveFlight1.setText(
                    RCommon.getDateString(flight.getDepartureDateTime()) +
                    " from " + flightPlan.getDepartureAirport().getCode() +
                    " to " + flightPlan.getDestinationAirport().getCode());
                parent.setNextProgress();
                pLeaveFlight2.setText(
		    flightPlan.getAirlineCompany().getName() + ", " +
		    flightPlan.getFlightNumber() + ", Seat " +
		    parent.departFlight.getSeat() + ", " +
		    flight.getPlane().getName());
                parent.setNextProgress();
                pLeaveFlight3.setText("Depart " +
		    RCommon.getTime(flight.getDepartureDateTime()) + " ->  Arrive " +
		    RCommon.getTime(flight.getArrivalDateTime()));
                parent.setNextProgress();
                pLeaveFlight4.setText("   ");  //"Connections in Dallas, TX");
                pLeaveFlight5.setText("   ");
		p = p + flightPlan.getPrice();
		c = c + parent.departFlight.getConfirmationNumber() + " ";
                parent.setNextProgress();
	    }
	    else {
                pLeaveFlight1.setText("");
                pLeaveFlight2.setText("");
                pLeaveFlight3.setText("");
                pLeaveFlight4.setText("");
                pLeaveFlight5.setText("");
	    }

	    // Set return flight info
	    if (parent.returnFlight != null) {
		flight = parent.returnFlight.getFlight();
		flightPlan = flight.getFlightPlan();
                parent.setNextProgress();
                pReturnFlight1.setText(
                    RCommon.getDateString(flight.getDepartureDateTime()) +
                    " from " + flightPlan.getDepartureAirport().getCode() +
                    " to " + flightPlan.getDestinationAirport().getCode());
                parent.setNextProgress();
                pReturnFlight2.setText(
		    flightPlan.getAirlineCompany().getName() + ", " +
		    flightPlan.getFlightNumber() + ", Seat " +
		    parent.returnFlight.getSeat() + ", " +
		    flight.getPlane().getName());
                parent.setNextProgress();
                pReturnFlight3.setText("Depart " +
		    RCommon.getTime(flight.getDepartureDateTime()) + " ->  Arrive " +
		    RCommon.getTime(flight.getArrivalDateTime()));
                parent.setNextProgress();
                pReturnFlight4.setText("   ");  //"Connections in Dallas, TX");
                pReturnFlight5.setText("   ");
		p = p + flightPlan.getPrice();
		c = c + parent.returnFlight.getConfirmationNumber() + " ";
                parent.setNextProgress();
	    }
	    else {
                pReturnFlight1.setText("");
                pReturnFlight2.setText("");
                pReturnFlight3.setText("");
                pReturnFlight4.setText("");
                pReturnFlight5.setText("");
	    }

	    // Set price and confirmation numbers
            pPrice.setText( "$"+Float.toString(p) );
            pConfirmation.setText(c);
	}
	// zpb_end
}
