package COM.ibm.jaws.app.trs.trswin2;
import java.awt.*;
import java.util.*;
import java.applet.*;
import com.roguewave.widgets.*;
// zpb_begin UserImports
import COM.ibm.jaws.models.trs.*;
// zpb_end

/**
 * Class ReserveList1Car.
 *
 *
 * @author    Bryce Curtis
 * @version   2.0 11/21/96 8:49:06am
 * @copyright IBM
 */
public
class ReserveList1Car extends Panel {
	Label pPickup4, pPickup3, pPickup2, pPickup1, pReturn1, pPrice, pConfirmation,
pStatic1, pStatic2, pStatic3, pStatic4;
	private Applet applet = null;
	private Frame  frame  = null;

	// Initial size in logical units
	Dimension initialSize = new Dimension(335, 140);
	Point initialLocation;
	// zpb_begin ReserveList1CarUserVars
	ReserveList parent = null;
	// zpb_end

	// zpb_begin ReserveList1CarJavadocConstructor
    /**
     * Creates a specialized Panel with the specified app and frame.
     */
	 // zpb_end
	ReserveList1Car(Applet app, Frame frame) {
		applet = app;
		this.frame = frame;
		// zpb_begin ReserveList1CarConstructor_1
		parent = (ReserveList)frame;
		// zpb_end

		setFont(new Font("Helvetica", Font.PLAIN, 12));
		LogFontLayout lfLayout = new LogFontLayout(this);
		setLayout(lfLayout);

		pPickup4 = new Label("Connections in Dallas, TX");
		add("75 40 97 12", pPickup4);
		pPickup4.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pPickup3 = new Label("Mid-sized car");
		add("75 30 51 12", pPickup3);
		pPickup3.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pPickup2 = new Label("Hertz, Gold #2392");
		add("75 20 69 10", pPickup2);
		pPickup2.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pPickup1 = new Label("Jul 19, 1996 at ATL airport");
		add("75 10 98 12", pPickup1);
		pPickup1.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pReturn1 = new Label("Aug 8 to ATL airport");
		add("75 60 110 12", pReturn1);
		pReturn1.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pPrice = new Label("$120 plus $0.20/mile");
		add("75 85 77 12", pPrice);
		pPrice.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pConfirmation = new Label("12N348273");
		add("75 110 43 12", pConfirmation);
		pConfirmation.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pStatic1 = new Label("Pickup:");
		add("10 10 39 12", pStatic1);
		pStatic1.setFont(new Font("Helvetica", Font.BOLD, 15));
		pStatic2 = new Label("Return:");
		add("10 60 33 12", pStatic2);
		pStatic2.setFont(new Font("Helvetica", Font.BOLD, 15));
		pStatic3 = new Label("Confirmation:");
		add("10 110 57 12", pStatic3);
		pStatic3.setFont(new Font("Helvetica", Font.BOLD, 15));
		pStatic4 = new Label("Price:");
		add("10 85 26 12", pStatic4);
		pStatic4.setFont(new Font("Helvetica", Font.BOLD, 15));
		// zpb_begin ReserveList1CarConstructor_2
		// zpb_end

		// Size and Position in logical units
		initialLocation = lfLayout.du(5, 20);
		move(initialLocation.x, initialLocation.y);

		// zpb_begin ReserveList1CarConstructor_3
		// zpb_end
	}

	// zpb_begin ReserveList1CarStatic4JavadocPaint
	/**
	 * Paints the Panel.  Add specialized functionality for this Panel
	 * between the paint protect block.
	 */
	// zpb_end
	public void paint(Graphics g) {
		Dimension d = size();
		g.drawRect(0,0,d.width-1,d.height-1); // border
		// zpb_begin ReserveList1CarPaint
		// zpb_end
	}


	// zpb_begin ReserveList1CarJavadocHandleEvent
    /**
     * Handle events that occur with components in this container.
     *
     * @return  Returns a boolean which specifies whether the event
     *          handler should stop at this level or continue up the
     *          parent hierarchy.
     */
	// zpb_end
	public boolean handleEvent(Event e) {

		// zpb_begin ReserveList1CarHandleEvent
		// zpb_end

		return super.handleEvent(e);
	}


	// zpb_begin ReserveList1CarUserMethods
	/**
    	*******************************************************
    	* Get data from server
    	*******************************************************
    	*/
	public void getData() {
	    System.out.println("ReserveList1Car::getData()");
	    CarFleet carFleet = null;
	    Trip t = parent.trip;

            // Set text fields
	    if (parent.carRes != null) {
		System.out.println("setting fields");
		carFleet = parent.carRes.getCarFleet();
                parent.setNextProgress();

                pPickup1.setText(
		    RCommon.getDateString(t.getDepartureDate()) +
                    " at " + carFleet.getAirport().getCode());
                parent.setNextProgress();
                pPickup2.setText(carFleet.getCarRentalCompany().getName());
                parent.setNextProgress();
                pPickup3.setText(carFleet.getName() + ", " + carFleet.getCar().getName());
                parent.setNextProgress();
                pPickup4.setText("");

                pReturn1.setText(
		    RCommon.getDateString(t.getReturnDate()) +
                    " to " + carFleet.getAirport().getCode());
                parent.setNextProgress();

                pConfirmation.setText(Integer.toString(parent.carRes.getConfirmationNumber()));
                parent.setNextProgress();

                long days = (t.getReturnDate().getTime() - t.getDepartureDate().getTime() + 10000000) / 86399560;
                if (days < 1) days = 1;
                float perday =  carFleet.getPrice();
                float f = perday * days;
                pPrice.setText( "$"+Float.toString(f) + " ($"+perday+"/day)" );
            }
            else {
		System.out.println("clearing fields");
                pPickup1.setText("");
                pReturn1.setText("");
                pPickup2.setText("");
                pPickup3.setText("");
                pPickup4.setText("");
                pConfirmation.setText("");
                pPrice.setText("");
            }
	}
	// zpb_end
}
