package COM.ibm.jaws.app.trs.trswin2;
import java.awt.*;
import java.util.*;
import java.applet.*;
import com.roguewave.widgets.*;
// zpb_begin UserImports
import COM.ibm.jaws.models.trs.*;
// zpb_end

/**
 * Class ReserveList1Main.
 *
 *
 * @author    Bryce Curtis
 * @version   2.0 11/21/96 8:49:01am
 * @copyright IBM
 */
public
class ReserveList1Main extends Panel {
	Label pTitle, pStatic1, pTripName, pLeaveDate, pStatic2, pStatic5, pReturnDate,
pStatic6, pPrice;
	private Applet applet = null;
	private Frame  frame  = null;

	// Initial size in logical units
	Dimension initialSize = new Dimension(335, 140);
	Point initialLocation;
	// zpb_begin ReserveList1MainUserVars
	ReserveList parent = null;
	// zpb_end

	// zpb_begin ReserveList1MainJavadocConstructor
    /**
     * Creates a specialized Panel with the specified app and frame.
     */
	 // zpb_end
	ReserveList1Main(Applet app, Frame frame) {
		applet = app;
		this.frame = frame;
		// zpb_begin ReserveList1MainConstructor_1
		parent = (ReserveList)frame;
		// zpb_end

		setFont(new Font("Helvetica", Font.PLAIN, 12));
		LogFontLayout lfLayout = new LogFontLayout(this);
		setLayout(lfLayout);

		pTitle = new Label("Reservation for Trip");
		pTitle.setAlignment(Label.CENTER);
		add("15 10 298 12", pTitle);
		pTitle.setFont(new Font("Helvetica", Font.BOLD, 17));
		pStatic1 = new Label("Trip Name:");
		add("10 35 54 12", pStatic1);
		pStatic1.setFont(new Font("Helvetica", Font.BOLD, 15));
		pTripName = new Label("Trip to the Olympics                                                                  ");
		add("75 35 220 12", pTripName);
		pTripName.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pLeaveDate = new Label("Jul 31, 1996 at Austin, TX");
		add("75 60 129 12", pLeaveDate);
		pLeaveDate.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pStatic2 = new Label("Leave:");
		add("10 60 30 12", pStatic2);
		pStatic2.setFont(new Font("Helvetica", Font.BOLD, 15));
		pStatic5 = new Label("Return:");
		add("10 85 35 12", pStatic5);
		pStatic5.setFont(new Font("Helvetica", Font.BOLD, 15));
		pReturnDate = new Label("Aug 8, 1996 from Atlanta, GA");
		add("75 85 143 12", pReturnDate);
		pReturnDate.setFont(new Font("Helvetica", Font.PLAIN, 15));
		pStatic6 = new Label("Price:");
		add("10 110 28 12", pStatic6);
		pStatic6.setFont(new Font("Helvetica", Font.BOLD, 15));
		pPrice = new Label("$2600.00");
		add("75 110 71 12", pPrice);
		pPrice.setFont(new Font("Helvetica", Font.PLAIN, 15));
		// zpb_begin ReserveList1MainConstructor_2
		// zpb_end

		// Size and Position in logical units
		initialLocation = lfLayout.du(15, 40);
		move(initialLocation.x, initialLocation.y);

		// zpb_begin ReserveList1MainConstructor_3
		// zpb_end
	}

	// zpb_begin ReserveList1MainPriceJavadocPaint
	/**
	 * Paints the Panel.  Add specialized functionality for this Panel
	 * between the paint protect block.
	 */
	// zpb_end
	public void paint(Graphics g) {
		Dimension d = size();
		g.drawRect(0,0,d.width-1,d.height-1); // border
		// zpb_begin ReserveList1MainPaint
		// zpb_end
	}


	// zpb_begin ReserveList1MainJavadocHandleEvent
    /**
     * Handle events that occur with components in this container.
     *
     * @return  Returns a boolean which specifies whether the event
     *          handler should stop at this level or continue up the
     *          parent hierarchy.
     */
	// zpb_end
	public boolean handleEvent(Event e) {

		// zpb_begin ReserveList1MainHandleEvent
		// zpb_end

		return super.handleEvent(e);
	}


	// zpb_begin ReserveList1MainUserMethods
        // Set text fields

	/**
    	*******************************************************
    	* Get data from server
    	*******************************************************
    	*/
	public void getData() {
	    Trip t = parent.trip;
            pTripName.setText( t.getName() );
            parent.setNextProgress();
            pLeaveDate.setText( RCommon.getDateString(t.getDepartureDate()) +
                       		" from " + t.getDepartureCity().getCityState());
            parent.setNextProgress();
            pReturnDate.setText( RCommon.getDateString(t.getReturnDate()) +
                        	" from " + t.getDestinationCity().getCityState());
            parent.setNextProgress();

            float f = 0;

            long days = (t.getReturnDate().getTime() - t.getDepartureDate().getTime() + 10000000) / 86399560;
            parent.setNextProgress();
            if (days < 1) days = 1;
	    if (parent.departFlight != null)
	        f = f + parent.departFlight.getFlight().getFlightPlan().getPrice();
            parent.setNextProgress();
	    if (parent.returnFlight != null)
	        f = f + parent.returnFlight.getFlight().getFlightPlan().getPrice();
            parent.setNextProgress();
	    if (parent.carRes != null)
	        f = f + parent.carRes.getCarFleet().getPrice() * days;
            parent.setNextProgress();
	    if (parent.hotelRes != null) {
	        f = f + parent.hotelRes.getRoomGroup().getPrice() * days;
            parent.setNextProgress();
	    }

            pPrice.setText( "$"+Float.toString(f) );

	}
	// zpb_end
}
