package COM.ibm.jaws.app.trs.trswin2;
import java.awt.*;
import java.util.*;
import java.applet.*;
import com.roguewave.widgets.*;
// zpb_begin UserImports 
// zpb_end 

/**
 * Class SelectSeat.
 *
 *
 * @author    Bryce Curtis
 * @version   2.0 11/21/96 8:49:21am
 * @copyright IBM
 */
public
class SelectSeat extends Dialog {

	private static Applet applet;
	TextField pStatus;
	Label pStatic1;

	// Initial size in logical units
	Dimension initialSize = new Dimension(175, 314);
	Point initialLocation;
	// zpb_begin SelectSeatUserVars 

    	Rectangle fRect[] = {
        	new Rectangle(105,92,9,9),
        	new Rectangle(117,92,9,9),
        	new Rectangle(141,92,9,9),
        	new Rectangle(153,92,9,9),
        	new Rectangle(177,92,9,9),
        	new Rectangle(189,92,9,9)
    	};
    	Rectangle rRect[] = {
	        new Rectangle(105,145,8,8),
	        new Rectangle(114,145,8,8),
	        new Rectangle(135,145,8,8),
	        new Rectangle(144,145,8,8),
	        new Rectangle(153,145,8,8),
	        new Rectangle(162,145,8,8),
	        new Rectangle(183,145,8,8),
	        new Rectangle(192,145,8,8)
    	};
    	String sRow[] = {
	        new String("A"),
	        new String("B"),
	        new String("C"),
	        new String("D"),
	        new String("E"),
	        new String("F"),
	        new String("G"),
	        new String("H"),
	        new String("I"),
	        new String("J")
    	};

    	String seat = "";
    	Image img;
	EditTrip parent;


	// zpb_end 

	// zpb_begin SelectSeatJavadocConstructor 
    /**
     * Creates a specialized dialog with the specified app, parent, title and
     * modality.
     */
	 // zpb_end 
	SelectSeat(Applet app, Frame parent, String title, boolean modal) {
		super(parent, title, modal);
		applet = app;
		setResizable(false);

		// zpb_begin SelectSeatConstructor_1 
		this.parent = (EditTrip)parent;
        	initialSize = new Dimension(174, 311);
		// zpb_end 

		setFont(new Font("Helvetica", Font.PLAIN, 12));
		LogFontLayout lfLayout = new LogFontLayout(this);
		setLayout(lfLayout);

		pStatic1 = new Label("Click on Seat to Select It:");
		add("5 5 153 12", pStatic1);
		pStatic1.setFont(new Font("Helvetica", Font.BOLD, 15));
		pStatus = new TextField("Select Seat");
		add("5 275 160 11", pStatus);
		pStatus.setEditable(false);
		// zpb_begin SelectSeatConstructor_2 
        	img = applet.getImage(applet.getDocumentBase(), "images/l1011.gif");
		// zpb_end 

		// Size and Position in logical units
		initialLocation = lfLayout.du(15, 28);
		
		pack();
		move(initialLocation.x, initialLocation.y);

		// zpb_begin SelectSeatConstructor_3 
		// zpb_end 
	}

	// zpb_begin SelectSeatJavadocMinimumSize 
    /**
     * @return  Returns a Dimension with the minimum width and height
     *          of this container.
     */
	 // zpb_end 
	public Dimension minimumSize() {
		// zpb_begin SelectSeatMinimumSize 
		// zpb_end 
			
		LayoutManager layoutMgr = getLayout();
		if (layoutMgr instanceof LogFontLayout) {
			// Convert from logical units to absolute coordinates
			int w = initialSize.width;
			int h = initialSize.height;
			LogFontLayout layout = (LogFontLayout)layoutMgr;
			return new Dimension(layout.duX(w), layout.duY(h));
		}
		return new Dimension(initialSize);
	}

	// zpb_begin SelectSeatJavadocHandleEvent 
    /**
     * Handle events that occur with components in this container.
     *
     * @return  Returns a boolean which specifies whether the event
     *          handler should stop at this level or continue up the
     *          parent hierarchy.
     */
	// zpb_end 
	public boolean handleEvent(Event e) {
		if (e.id == Event.WINDOW_DESTROY) {
			// zpb_begin SelectSeatDestroy 
			// zpb_end 
			dispose();
			return true;
		}

		// zpb_begin SelectSeatHandleEvent 
		// zpb_end 

		return super.handleEvent(e);
	}


	// zpb_begin SelectSeatUserMethods 

    /**
     * Handle mouseDown events
     *
     * @return  Returns a boolean which specifies whether the event
     *          handler should stop at this level or continue up the
     *          parent hierarchy.
     */
    public boolean mouseDown( Event e, int mx, int my) {

        System.out.println("SelectSeat: Checking mouse click");
        System.out.println("SelectSeat: Pressed "+ "(x="+mx+"y="+my+")");
        if (seat.equals("")) {
            return true;
        }
        else {
            //if (RCommon.wEditTrip.wOriginationPage.sLeave == true) {
            //    RCommon.wEditTrip.wOriginationPage.seatLeave.setText(seat);
            //    RCommon.wEditTrip.wOriginationPage.pSeatNum.setText("Seat: " + seat);
            //    RCommon.wEditTrip.wOriginationPage.sLeave = false;
            //}
            //if ( RCommon.wEditTrip.wDestinationPage.sReturn == true) {
            //    RCommon.wEditTrip.wDestinationPage.seatReturn.setText(seat);
            //    RCommon.wEditTrip.wDestinationPage.pSeatNum.setText("Seat: " + seat);
            //    RCommon.wEditTrip.wDestinationPage.sReturn = false;
            //}
            if (parent.sLeave == true) {
                parent.wOriginationPage.seat.setText(seat);
                parent.wOriginationPage.pSeatNum.setText("Seat: " + seat);
                parent.sLeave = false;
            }
            if ( parent.sReturn == true) {
                parent.wOriginationPage.seat.setText(seat);
                parent.wDestinationPage.pSeatNum.setText("Seat: " + seat);
                parent.sReturn = false;
            }
            dispose();
        }
        return true;
    }

    /**
     * Handle mouseMove events
     *
     * @return  Returns a boolean which specifies whether the event
     *          handler should stop at this level or continue up the
     *          parent hierarchy.
     */
    public boolean mouseMove( Event e, int mx, int my) {

        int i,j;
        Rectangle r = new Rectangle(0,0,1,1);
        for (j=0; j<3; j++) {
            for (i=0; i<fRect.length; i++) {
                r.x = fRect[i].x;
                r.y = fRect[i].y;
                r.height = fRect[i].height;
                r.width = fRect[i].width;
                r.y = r.y + j*15;
                if (r.inside(mx,my)) {
                    seat = Integer.toString(j+1) + sRow[i];
                    pStatus.setText("Seat: " + seat);
                    return true;
                }
            }
        }
        for (j=0; j<10; j++) {
            for (i=0; i<rRect.length; i++) {
                r.x = rRect[i].x;
                r.y = rRect[i].y;
                r.height = rRect[i].height;
                r.width = rRect[i].width;
                r.y = r.y + j*10;
                if (r.inside(mx,my)) {
                    seat = Integer.toString(j+10) + sRow[i];
                    pStatus.setText("Seat: " + seat);
                    return true;
                }
            }
        }
        for (j=0; j<18; j++) {
            for (i=0; i<rRect.length; i++) {
                r.x = rRect[i].x;
                r.y = rRect[i].y;
                r.height = rRect[i].height;
                r.width = rRect[i].width;
                r.y = r.y + j*10 + 265 - 145;
                if (r.inside(mx,my)) {
                    seat = Integer.toString(j+20) + sRow[i];
                    pStatus.setText("Seat: " + seat);
                    return true;
                }
            }
        }

        pStatus.setText("Select Seat");
        seat = "";
        return true;
    }

    public void paint(Graphics g) {
        update(g);
    }

    public void update(Graphics g) {
        g.drawImage(img, 10, 40, this);
    }
	// zpb_end 
}
