package COM.ibm.jaws.app.trs.trswin2;
import java.awt.*;
import java.util.*;
import java.applet.*;
import com.roguewave.widgets.*;
// zpb_begin UserImports
import mlsoft.mct.*;
import COM.ibm.jaws.models.trs.*;
import java.net.*;
// zpb_end

/**
 * Class TripList.
 *
 *
 * @author    Bryce Curtis
 * @version   2.0 11/21/96 8:49:11am
 * @copyright IBM
 */
public
class TripList extends Frame {

	private static Applet applet;
	Label pTitle;
	Hashtable menuitems = new Hashtable();
	Button pNewTrip, pEditTrip, pCancelTrip;

	// Initial size in logical units
	Dimension initialSize = new Dimension(352, 245);
	Point initialLocation;
	// zpb_begin TripListUserVars

    	MlTabPanel tabPanel;                			// Tab panel
	TripListPendingPanel wPendingPage = null;		// Pending panel
	TripListReservationsPanel wReservationsPage = null;	// Confirmed panel
	TripListTakenPanel wTakenPage = null;			// Taken panel
	String currentPage = "Pending";				// Panel that is currently showing

	// zpb_end

	// zpb_begin TripListJavadocConstructor
    /**
     * Creates a specialized window with the specified app and title.
     */
	 // zpb_end
	TripList(Applet app, String title) {
		super(title);
		applet = app;

		// zpb_begin TripListConstructor_1
		RCommon.windowList.addElement(this);
		// zpb_end

		setBackground(Color.lightGray);
		setFont(new Font("Helvetica", Font.PLAIN, 12));
		LogFontLayout lfLayout = new LogFontLayout(this);
		setLayout(lfLayout);

		pTitle = new Label("Trips for Bryce Curtis");
		pTitle.setAlignment(Label.CENTER);
		add("5 5 319 12", pTitle);
		pTitle.setFont(new Font("Helvetica", Font.BOLD, 17));
		pNewTrip = new Button("New Trip");
		add("60 200 60 16", pNewTrip);
		pNewTrip.setFont(new Font("Helvetica", Font.BOLD, 15));
		pEditTrip = new Button("Edit Trip");
		add("145 200 60 16", pEditTrip);
		pEditTrip.setFont(new Font("Helvetica", Font.BOLD, 15));
		pCancelTrip = new Button("Cancel Trip");
		add("230 200 60 16", pCancelTrip);
		pCancelTrip.setFont(new Font("Helvetica", Font.BOLD, 15));

		// Add the MenuBar, Menus, and Menuitems
		MenuBar mbMenu1 = new MenuBar();
		MenuItem mi;
		Menu mFile = new Menu("File");
		menuitems.put("File", mFile);
		mi=new MenuItem("Close");
		mFile.add(mi);
		menuitems.put("FileClose",mi);
		mbMenu1.add(mFile);
		Menu mView = new Menu("View");
		menuitems.put("View", mView);
		mi=new MenuItem("New Trip");
		mView.add(mi);
		menuitems.put("ViewNewTrip",mi);
		mi=new MenuItem("Edit Trip");
		mView.add(mi);
		menuitems.put("ViewEditTrip",mi);
		mi=new MenuItem("View Trip");
		mView.add(mi);
		menuitems.put("ViewViewTrip",mi);
		mView.add(new MenuItem("-"));
		mi=new MenuItem("Cancel Trip");
		mView.add(mi);
		menuitems.put("ViewCancelTrip",mi);

                // @BC 2/12/97
		mView.add(new MenuItem("-"));
		mi=new MenuItem("Origination City Info");
		mView.add(mi);
		menuitems.put("ViewOriginationCityInfo",mi);
		mi=new MenuItem("Origination Weather");
		mView.add(mi);
		menuitems.put("ViewOriginationWeather",mi);
		mi=new MenuItem("Origination Airport");
		mView.add(mi);
		menuitems.put("ViewOriginationAirport",mi);
		mView.add(new MenuItem("-"));
		mi=new MenuItem("Destination City Info");
		mView.add(mi);
		menuitems.put("ViewDestinationCityInfo",mi);
		mi=new MenuItem("Destination Weather");
		mView.add(mi);
		menuitems.put("ViewDestinationWeather",mi);
                mi=new MenuItem("Destination Airport");
		mView.add(mi);
                menuitems.put("ViewDestinationAirport",mi);


		mbMenu1.add(mView);
		Menu mHelp = new Menu("Help");
		menuitems.put("Help", mHelp);
		mi=new MenuItem("Contents");
		mHelp.add(mi);
		menuitems.put("HelpContents",mi);
		mi=new MenuItem("Search...");
		mHelp.add(mi);
		menuitems.put("HelpSearch",mi);
		mHelp.add(new MenuItem("-"));
		mi=new MenuItem("About...");
		mHelp.add(mi);
		menuitems.put("HelpAbout",mi);
		mbMenu1.add(mHelp);
		this.setMenuBar(mbMenu1);
		// zpb_begin TripListConstructor_2

		// Set heading of page
        	pTitle.setText( "List of Trips for " + RCommon.user.getName() );

		// Create tab panels
        	wPendingPage = new TripListPendingPanel(applet, this);
        	wReservationsPage = new TripListReservationsPanel(applet, this);
        	wTakenPage = new TripListTakenPanel(applet, this);

        	tabPanel = new MlTabPanel();
        	tabPanel.setValue("marginWidth", 5);

	        tabPanel.add("Pending", wPendingPage);
        	add("5 25 335 160", tabPanel);
        	tabPanel.add("Confirmed", wReservationsPage);
        	add("5 25 335 160", tabPanel);
        	tabPanel.add("Taken", wTakenPage);
        	add("5 25 335 160", tabPanel);

		// zpb_end

		// Size and Position in logical units
		initialLocation = lfLayout.du(15, 28);

		pack();
		move(initialLocation.x, initialLocation.y);

		// zpb_begin TripListConstructor_3

		// Remove wait dialog
        	RCommon.destroyPleaseWait();

                getData();

		// zpb_end
	}

	// zpb_begin TripListJavadocMinimumSize
    /**
     * @return  Returns a Dimension with the minimum width and height
     *          of this container.
     */
	 // zpb_end
	public Dimension minimumSize() {
		// zpb_begin TripListMinimumSize
		// zpb_end

		LayoutManager layoutMgr = getLayout();
		if (layoutMgr instanceof LogFontLayout) {
			// Convert from logical units to absolute coordinates
			int w = initialSize.width;
			int h = initialSize.height;
			LogFontLayout layout = (LogFontLayout)layoutMgr;
			return new Dimension(layout.duX(w), layout.duY(h));
		}
		return new Dimension(initialSize);
	}

	// zpb_begin TripListJavadocHandleEvent
    /**
     * Handle events that occur with components in this container.
     *
     * @return  Returns a boolean which specifies whether the event
     *          handler should stop at this level or continue up the
     *          parent hierarchy.
     */
	// zpb_end
	public boolean handleEvent(Event e) {
		if (e.id == Event.WINDOW_DESTROY) {
			// zpb_begin TripListDestroy

			RCommon.windowList.removeElement(this);
            		RCommon.wTripList = null;
			// zpb_end
			dispose();
			return true;
		}

		// zpb_begin TripListHandleEvent
		// zpb_end

		return super.handleEvent(e);
	}

	// zpb_begin TripListJavadocAction
    /**
     * Action handling routine.
     *
     * @return  Returns a boolean specifying whether the event should be handled
     *          furthur up the parent hierarchy.
     */
	// zpb_end
	public boolean action(Event evt, Object obj) {
		if (evt.target instanceof MenuItem) {
			if (menuitems.get("FileClose") == evt.target) {
				// zpb_begin TripListFileCloseSelection
                		Event e = new Event(this, 0, Event.WINDOW_DESTROY, 0, 0, 0, 0);
                		handleEvent(e);
				// zpb_end
			}
			else if (menuitems.get("ViewNewTrip") == evt.target) {
				// zpb_begin TripListViewNewTripSelection

				// Create new trip
				Trip trip = RCommon.user.addTrip("New Trip", "Austin", "Austin", new Date(97,0,1), new Date(97,0,3));

				// Edit it
                		RCommon.showEditTrip(applet, trip);
				// zpb_end
			}
			else if (menuitems.get("ViewEditTrip") == evt.target) {
				// zpb_begin TripListViewEditTripSelection

				// Get the trip
				Trip trip = getTrip(currentPage);
				if (trip == null) {
   				    PopupOk dMsgBox = new PopupOk(applet, RCommon.wEmptyFrame, "Trip Not Selected", false);
    				    dMsgBox.title("Trip Not Selected");
        		            dMsgBox.println("You must select a trip to edit or view.");
				    dMsgBox.show();
				    return false;
				}

				// Edit it
				if (pEditTrip.getLabel().equals("Edit Trip"))
               				RCommon.showEditTrip(applet, trip);
				else
					RCommon.showTakenTrip(applet, trip);
				// zpb_end
			}
			else if (menuitems.get("ViewViewTrip") == evt.target) {
				// zpb_begin TripListViewViewTripSelection
                		RCommon.notImplemented(applet);
				// zpb_end
			}
			else if (menuitems.get("ViewCancelTrip") == evt.target) {
				// zpb_begin TripListViewCancelTripSelection

				// Get the trip
				Trip trip = getTrip(currentPage);
				if (trip == null) {
   				    PopupOk dMsgBox = new PopupOk(applet, RCommon.wEmptyFrame, "Trip Not Selected", false);
    				    dMsgBox.title("Trip Not Selected");
        		            dMsgBox.println("You must select a trip to cancel.");
				    dMsgBox.show();
				    return false;
				}

				// Delete it
                                RCommon.waitCursor();
                                trip.cancel();
                                getData();
//                                if (pCancelTrip.getLabel().equals("Cancel Trip"))
//                                        trip.cancel();
//                                else
//                                        trip.remove();
				// zpb_end
			}

                        // @BC 2/12/97
			else if (menuitems.get("ViewOriginationCityInfo") == evt.target) {
				// zpb_begin EditTripViewOriginationCityInfoSelection
				Trip trip = getTrip(currentPage);
				if (trip == null) {
   				    PopupOk dMsgBox = new PopupOk(applet, RCommon.wEmptyFrame, "Trip Not Selected", false);
    				    dMsgBox.title("Trip Not Selected");
                                    dMsgBox.println("You must select a trip.");
				    dMsgBox.show();
				    return false;
				}
                                URL nURL = trip.getDepartureCity().getURL();
                                System.out.println("URL = " + nURL);
	    			if (!RCommon.appl)
                                    applet.getAppletContext().showDocument(nURL, "_TOP");
				// zpb_end
			}
			else if (menuitems.get("ViewOriginationWeather") == evt.target) {
				// zpb_begin EditTripViewOriginationWeatherSelection
				Trip trip = getTrip(currentPage);
				if (trip == null) {
   				    PopupOk dMsgBox = new PopupOk(applet, RCommon.wEmptyFrame, "Trip Not Selected", false);
    				    dMsgBox.title("Trip Not Selected");
                                    dMsgBox.println("You must select a trip.");
				    dMsgBox.show();
				    return false;
				}
                                URL nURL = trip.getDepartureCity().getWeatherURL();
                                System.out.println("URL = " + nURL);
	    			if (!RCommon.appl)
                                    applet.getAppletContext().showDocument(nURL, "_TOP");
				// zpb_end
			}
			else if (menuitems.get("ViewOriginationAirport") == evt.target) {
				// zpb_begin EditTripViewOriginationAirportSelection
				Trip trip = getTrip(currentPage);
				if (trip == null) {
   				    PopupOk dMsgBox = new PopupOk(applet, RCommon.wEmptyFrame, "Trip Not Selected", false);
    				    dMsgBox.title("Trip Not Selected");
                                    dMsgBox.println("You must select a trip.");
				    dMsgBox.show();
				    return false;
				}
                                FlightReservation departFlight = trip.getDepartureFlightReservation();
                                if (departFlight != null) {
                                    URL nURL = departFlight.getFlight().getFlightPlan().getDepartureAirport().getURL();
                                    System.out.println("URL = " + nURL);
                                    if (!RCommon.appl) {
                        	    	applet.getAppletContext().showDocument(nURL, "_TOP");
				    }
				}
				// zpb_end
			}
			else if (menuitems.get("ViewDestinationCityInfo") == evt.target) {
				// zpb_begin EditTripViewDestinationCityInfoSelection
				Trip trip = getTrip(currentPage);
				if (trip == null) {
   				    PopupOk dMsgBox = new PopupOk(applet, RCommon.wEmptyFrame, "Trip Not Selected", false);
    				    dMsgBox.title("Trip Not Selected");
                                    dMsgBox.println("You must select a trip.");
				    dMsgBox.show();
				    return false;
				}
                                URL nURL = trip.getDestinationCity().getURL();
                                System.out.println("URL = " + nURL);
	    			if (!RCommon.appl)
                                    applet.getAppletContext().showDocument(nURL, "_TOP");
				// zpb_end
			}
			else if (menuitems.get("ViewDestinationWeather") == evt.target) {
				// zpb_begin EditTripViewDestinationWeatherSelection
				Trip trip = getTrip(currentPage);
				if (trip == null) {
   				    PopupOk dMsgBox = new PopupOk(applet, RCommon.wEmptyFrame, "Trip Not Selected", false);
    				    dMsgBox.title("Trip Not Selected");
                                    dMsgBox.println("You must select a trip.");
				    dMsgBox.show();
				    return false;
				}
                                URL nURL = trip.getDestinationCity().getWeatherURL();
                                System.out.println("URL = " + nURL);
	    			if (!RCommon.appl)
                                    applet.getAppletContext().showDocument(nURL, "_TOP");
				// zpb_end
			}
                        else if (menuitems.get("ViewDestinationAirport") == evt.target) {
                                // zpb_begin EditTripViewDestinationAirportSelection
				Trip trip = getTrip(currentPage);
				if (trip == null) {
   				    PopupOk dMsgBox = new PopupOk(applet, RCommon.wEmptyFrame, "Trip Not Selected", false);
    				    dMsgBox.title("Trip Not Selected");
                                    dMsgBox.println("You must select a trip.");
				    dMsgBox.show();
				    return false;
				}
                                FlightReservation returnFlight = trip.getReturnFlightReservation();
                                if (returnFlight != null) {
                                    URL nURL = returnFlight.getFlight().getFlightPlan().getDepartureAirport().getURL();
                                    System.out.println("URL = " + nURL);
                                    if (!RCommon.appl) {
                        	    	applet.getAppletContext().showDocument(nURL, "_TOP");
				    }
				}
				// zpb_end
			}
                        //@BC END


			else if (menuitems.get("HelpContents") == evt.target) {
				// zpb_begin TripListHelpContentsSelection
                		RCommon.help(applet, "TripList");
				// zpb_end
			}
			else if (menuitems.get("HelpSearch") == evt.target) {
				// zpb_begin TripListHelpSearchSelection
                		RCommon.notImplemented(applet);
				// zpb_end
			}
			else if (menuitems.get("HelpAbout") == evt.target) {
				// zpb_begin TripListHelpAboutSelectionCreate
                		RCommon.helpAbout(applet);
				// zpb_end
				// zpb_begin TripListHelpAboutSelection
				// zpb_end
			}

			return false;
		}


		if (evt.target == pNewTrip) {
			// zpb_begin TripListNewTripClicked

			// Create a new trip
			Trip trip = RCommon.user.addTrip("New Trip", "Austin", "Austin", new Date(97,0,1), new Date(97,0,3));

			// Edit it
                	RCommon.showEditTrip(applet, trip);
			// zpb_end
		}
		else if (evt.target == pEditTrip) {
			// zpb_begin TripListEditTripClicked

			// Get the trip
			Trip trip = getTrip(currentPage);
			if (trip == null) {
  				PopupOk dMsgBox = new PopupOk(applet, RCommon.wEmptyFrame, "Trip Not Selected", false);
    				dMsgBox.title("Trip Not Selected");
        		        dMsgBox.println("You must select a trip to edit or view.");
				dMsgBox.show();
				return false;
			}

			// Edit it
			if (pEditTrip.getLabel().equals("Edit Trip"))
               			RCommon.showEditTrip(applet, trip);
			else
				RCommon.showTakenTrip(applet, trip);
			// zpb_end
		}
		else if (evt.target == pCancelTrip) {
			// zpb_begin TripListCancelTripClicked

			// Get the trip
			Trip trip = getTrip(currentPage);
			if (trip == null) {
  				PopupOk dMsgBox = new PopupOk(applet, RCommon.wEmptyFrame, "Trip Not Selected", false);
    				dMsgBox.title("Trip Not Selected");
        		        dMsgBox.println("You must select a trip to cancel.");
				dMsgBox.show();
				return false;
			}

			// Delete it
                        RCommon.waitCursor();
                        trip.cancel();
                        getData();
//                        if (pCancelTrip.getLabel().equals("Cancel Trip"))
//                            trip.cancel();
//                        else
//                            trip.remove();
			// zpb_end
		}

		// zpb_begin TripListAction
        	else if (evt.target == tabPanel) {

		        // Change labels on buttons and menu
// Still need to add menu change
			if (((String)obj).equals("Pending")) {
				pEditTrip.setLabel("Edit Trip");
				pCancelTrip.setLabel("Cancel Trip");
				currentPage = "Pending";
			}
			else if	(((String)obj).equals("Confirmed")) {
				pEditTrip.setLabel("Edit Trip");
				pCancelTrip.setLabel("Cancel Trip");
				currentPage = "Confirmed";
			}
			else if	(((String)obj).equals("Taken")) {
				pEditTrip.setLabel("View Trip");
				pCancelTrip.setLabel("Remove Trip");
				currentPage = "Taken";
			}
		}
		// zpb_end

		return false;
	}


	// zpb_begin TripListUserMethods
    	/**
    	*******************************************************
    	* Get the higlighted grid row from the current panel.
    	*******************************************************
    	*/
	int getRow(String tab) {
	    if (tab.equals("Pending"))
		return wPendingPage.grid.getSelectedRow();
	    else if (tab.equals("Confirmed"))
		return wReservationsPage.grid.getSelectedRow();
	    else if (tab.equals("Taken"))
		return wTakenPage.grid.getSelectedRow();
	    RCommon.error("TripList", "getRow(): Tab did not match");
	    return -1;
	}

    	/**
    	*******************************************************
    	* Get the higlighted trip from the current panel.
    	*******************************************************
    	*/
	Trip getTrip(String currentPage) {
	    System.out.println("TripList::getTrip("+currentPage+")");
	    int row = 0;
	    Trip trip = null;
	    if (currentPage.equals("Pending")) {
		row = wPendingPage.grid.getSelectedRow();
		System.out.println("row = " + row);
		if (RCommon.pendingTrips != null) {
		    RCommon.pendingTrips.reset();
		    for (int i=0; i<=row; i++)
		    	trip = (Trip) RCommon.pendingTrips.getNext();
		}
	    }
	    else if (currentPage.equals("Confirmed")) {
		row = wReservationsPage.grid.getSelectedRow();
		if (RCommon.confirmedTrips != null) {
		    RCommon.confirmedTrips.reset();
		    for (int i=0; i<=row; i++)
		    	trip = (Trip) RCommon.confirmedTrips.getNext();
		}
	    }
	    else if (currentPage.equals("Taken")) {
		row = wTakenPage.grid.getSelectedRow();
		if (RCommon.takenTrips != null) {
		    RCommon.takenTrips.reset();
		    for (int i=0; i<=row; i++)
		    	trip = (Trip) RCommon.takenTrips.getNext();
		}
	    }
	    System.out.println(RCommon.getHash((Object)trip));
	    return trip;
	}

    	/**
    	*******************************************************
    	* Get data from server
    	*******************************************************
    	*/
	public void getData() {
	    System.out.println("TripList::getData()");
	    RCommon.showPleaseWait(applet);
	    String cPage = currentPage;
            wPendingPage.getData();
            wReservationsPage.getData();
            wTakenPage.getData();
            if (cPage.equals("Taken")) {
                tabPanel.showPage("Pending");
            }
            else {
                tabPanel.showPage("Taken");
            }
	    tabPanel.showPage(cPage);
       	    RCommon.destroyPleaseWait();
	}

	// zpb_end
}
