package COM.ibm.jaws.app.trs.trswin2;
import java.awt.*;
import java.util.*;
import java.applet.*;
import com.roguewave.widgets.*;
// zpb_begin UserImports
import COM.ibm.jaws.models.trs.*;
import mlsoft.mct.*;
// zpb_end

/**
 * Class TripListReservationsPanel.
 *
 *
 * @author    Bryce Curtis
 * @version   2.0 11/21/96 8:49:17am
 * @copyright IBM
 */
public
class TripListReservationsPanel extends Panel {
	Label pTitle;
	Button pLeft, pRight;
	private Applet applet = null;
	private Frame  frame  = null;

	// Initial size in logical units
	Dimension initialSize = new Dimension(335, 145);
	Point initialLocation;
	// zpb_begin TripListReservationsPanelUserVars
    	MlGrid grid;
	// zpb_end

	// zpb_begin TripListReservationsPanelJavadocConstructor
	/**
	 * Creates a specialized Panel with the specified app and frame.
	 */
	 // zpb_end
	TripListReservationsPanel(Applet app, Frame frame) {
		applet = app;
		this.frame = frame;
		// zpb_begin TripListReservationsPanelConstructor_1
		// zpb_end

		setFont(new Font("Helvetica", Font.PLAIN, 12));
		LogFontLayout lfLayout = new LogFontLayout(this);
		setLayout(lfLayout);

		pTitle = new Label("Trips That Have a Confirmed Reservation");
		pTitle.setAlignment(Label.CENTER);
		add("5 5 315 12", pTitle);
		pTitle.setFont(new Font("Helvetica", Font.BOLD, 15));
		pLeft = new Button("<");
		add("300 130 15 12", pLeft);
		pRight = new Button(">");
		add("315 130 15 12", pRight);
		// zpb_begin TripListReservationsPanelConstructor_2
		// zpb_end

		// Size and Position in logical units
		initialLocation = lfLayout.du(5, 5);
		move(initialLocation.x, initialLocation.y);

		// zpb_begin TripListReservationsPanelConstructor_3

		// Get data from server
//                getData();
		// zpb_end
	}

	// zpb_begin TripListReservationsPanelRightJavadocPaint
	/**
	 * Paints the Panel.  Add specialized functionality for this Panel
	 * between the paint protect block.
	 */
	// zpb_end
	public void paint(Graphics g) {
		Dimension d = size();
		g.drawRect(0,0,d.width-1,d.height-1); // border
		// zpb_begin TripListReservationsPanelPaint
		// zpb_end
	}


	// zpb_begin TripListReservationsPanelJavadocHandleEvent
	/**
	 * Handle events that occur with components in this container.
	 *
	 * @return  Returns a boolean which specifies whether the event
	 *          handler should stop at this level or continue up the
	 *          parent hierarchy.
	 */
	// zpb_end
	public boolean handleEvent(Event e) {

		// zpb_begin TripListReservationsPanelHandleEvent
		// zpb_end

		return super.handleEvent(e);
	}

	// zpb_begin TripListReservationsPanelJavadocAction
	/**
	 * Action handling routine.
	 *
	 * @return  Returns a boolean specifying whether the event should be handled
	 *          furthur up the parent hierarchy.
	 */
	// zpb_end
	public boolean action(Event evt, Object obj) {
		if (evt.target == pLeft) {
			// zpb_begin PanelLeftClicked
			((TripList)frame).tabPanel.showPage("Pending");
			// zpb_end
			return false;
		}
		else if (evt.target == pRight) {
			// zpb_begin PanelRightClicked
			((TripList)frame).tabPanel.showPage("Taken");
			// zpb_end
			return false;
		}

		// zpb_begin TripListReservationsPanelAction
        	else if (evt.target == grid) {
            		disable();
            		MlGridEvent e = (MlGridEvent) evt;
            		System.out.println("GRID EVENT (" + e.row +","+ e.column +")");

			// Edit trip double-clicked on
                        int row = e.row;
                        Trip trip = null;
                        if (RCommon.confirmedTrips != null) {
                            RCommon.confirmedTrips.reset();
                            for (int i=0; i<=row; i++)
                               trip = (Trip) RCommon.confirmedTrips.getNext();
                            if (trip != null) 
                                RCommon.showEditTrip(applet, trip);
                        }

            		enable();
        	}
		// zpb_end

		return false;
	}


	// zpb_begin TripListReservationsPanelUserMethods

    	/**
    	*******************************************************
    	* Get data from server
    	*******************************************************
    	*/
	public void getData() {

		boolean exists = false;
	        if (grid != null) {
		    remove(grid);
		    exists = true;
		}

        	// Create grid for displaying trip information
        	MlResources res;
        	res = new MlResources();
        	grid = new MlGrid();
        	grid.setValue("layoutFrozen", true);

        	res.add("allowColumnResize", true);
        	res.add("selectionPolicy", "SELECT_SINGLE_ROW");
        	res.add("headingRows", 1);
        	res.add("columns", 7);
        	res.add("simpleWidths", "25c 11c 11c 25c 5c 5c 5c");
        	res.add("rightFixedCount", 0);
        	res.add("leftFixedCount", 0);
        	res.add("simpleHeadings", "Trip Name|Leave|Return|Destination|Air|Car|Hotel");
        	grid.setValues(res);

        	// set defaults for content cells
        	res.clear();
        	res.add("cellDefaults", true);
        	res.add("cellBackground", "#ffffff");
        	res.add("cellLeftBorderType", "BORDER_NONE");
        	res.add("cellRightBorderType", "BORDER_NONE");
        	res.add("cellTopBorderType", "BORDER_NONE");
        	res.add("cellBottomBorderType", "BORDER_NONE");
        	grid.setValues(res);

        	res.clear();
        	res.add("cellDefaults", true);
        	res.add("cellAlignment", "ALIGNMENT_CENTER");
        	grid.setValues(res);

		// Get data from server
   		PopupOk dServerMsgBox = new PopupOk(applet, RCommon.wPleaseWait, "Please Wait...", false);
		dServerMsgBox.title("Getting list of confirmed trips...");
		dServerMsgBox.move(100,100);

		MlProgress prog;
		prog = new MlProgress();
		prog.reshape(0, 0, 280, 16); // 300, 20);
		prog.setValue("showTime", true);
		dServerMsgBox.add("20 35 140 8", prog);
		prog.setValue("completeValue", 10);

		Label pStatus = new Label("Querying server...");
		dServerMsgBox.add("20 20 60 15", pStatus);
		pStatus.setFont(new Font("Helvetica", Font.PLAIN, 15));

		dServerMsgBox.noButton();
        	dServerMsgBox.show();
    		prog.setValue(0);
    		prog.updateDisplay();
		dServerMsgBox.toFront();

  		RCommon.confirmedTrips = (RCIterator)RCommon.user.getTrips("Confirmed");
		int rows = 0;
		if (RCommon.confirmedTrips != null) {

		    // Find out how many trips there are
//		    rows = RCommon.confirmedTrips.size();
		    Trip trip = null;
		    while ((trip = (Trip) RCommon.confirmedTrips.getNext()) != null) {
			rows++;
		    }
		    int total = rows;
    		    prog.setValue("completeValue", total);
		    System.out.println("number of rows = " + rows);
        	    grid.addRows(rows);

		    // Add data to grid
		    trip = null;
		    rows = 0;
		    String r;
		    RCommon.confirmedTrips.reset();
		    while ((trip = (Trip) RCommon.confirmedTrips.getNext()) != null) {
//		    	System.out.println(trip);
			pStatus.setText("Adding " + (rows+1) + " of " + total + "...");
        		prog.setValue(rows);
        		prog.updateDisplay();
			r = trip.getName() + "|" +
			    RCommon.getDate(trip.getDepartureDate()) + "|" +
			    RCommon.getDate(trip.getReturnDate()) + "|";
			City dCity = trip.getDestinationCity();
			if (dCity != null)
			    r = r + trip.getDestinationCity().getCityState();
			else
			    r = r + "NO CITY";
			if ((trip.getDepartureFlightReservation() == null) &&
			   (trip.getReturnFlightReservation() == null))
			    r = r + "|N";
			else
			    r = r + "|Y";
			if (trip.getCarReservation() == null)
			    r = r + "|N";
			else
			    r = r + "|Y";
			if (trip.getHotelReservation() == null)
			    r = r + "|N";
			else
			    r = r + "|Y";

		    	grid.setStrings(rows, r);
			rows++;
			System.out.println("Added row:" + r);
		    }
        	    prog.setValue(total);
        	    prog.updateDisplay();
		}
		else {
		    System.out.println("There are no confirmed trips for " + RCommon.user.getName());
		}
        	grid.setValue("layoutFrozen", false);
        	add("10 20 315 100", grid);

		if (rows > 0)
        	    grid.selectRow(0, true);

		// Required to force the tab Panel to show new grid results (bug?)
                ((TripList)frame).pack();
//                if (exists == true) {
//                    ((TripList)frame).tabPanel.showPage("Pending");
//                    ((TripList)frame).tabPanel.showPage("Confirmed");
//                }
        	dServerMsgBox.hide();
                dServerMsgBox.dispose();
		dServerMsgBox = null;

	}
	// zpb_end
}
