import java.lang.*;

import COM.ibm.jaws.services.sroot.SimpleRootBC;
import COM.ibm.jaws.util.Debug;
import COM.ibm.jaws.mofw.*;
import COM.ibm.corba.ORB;
import COM.ibm.corba.CORBA;

import netscape.server.applet.ServerApplet;

/**
 * The run method of this class is started by the Netscape server and
 * will continue to run as long as the socket connection to the client
 * applet is alive. It will process requests from a client until the
 * session is broken. This is usually because the client breaks the
 * connection, but it could be because of a communications problem.
 * <p>ServerApplet is a class provided by netscape, and is one of the
 * set of possible classes that a servlet must extend to be able to
 * execute within the bounds of the netscape process.
 */
public class TrswinServlet extends ServerApplet
{
    // Bojangles provides a debug class to help in debugging and
    // maintaining your code. Currently this using this support is the
    // best way to get information about failures as Netscape does not
    // provide an error log.
    private static Debug d = new Debug("TrswinServlet", false);
    private static String dbgFile = "c:/TrswinServlet.dbg";
    
    /**
    * The run method will be started by the Netscape server and
    * execute until the client applet is destroyed. It will run on the
    * Netscape servers thread provided at start. The thread will
    * execute the complete request and return the IIOPReply to the
    * client.
    */
    public void run() throws Exception
    {
	try {

	    //d.rebindOut(dbgFile);
	    //d.rebindErr(dbgFile);

	    // Connect to your activation space.
	    String activationSpace = "../../plugins/java/applets/trsApplicationSpace";
	    // E.g., String activationSpaceName = "TRSActivationSpace";
		
	    // E.g.; String key = "/TRSRoot";
		
	    //String relativeContext = new String("COM.ibm.mofw.KeyedCollection");
	    //String relativeContext = new String("/TRSRoot");
	    String relativeContext = null;
		
	    // Create the server orb and run it.
	    String args[] = new String[3];
	    args[0] = activationSpace;
	    args[1] = relativeContext;
	    args[2] = null;
	    ORB orb = CORBA.ORB_init(args, "TrswinServletORB");
	    orb.run(getClientSocket());
	    /*        
		      ORB orb = CORBA.serverORBInit(activationSpace, relativeContext, getClientSocket(), null);
		      orb.run();
		      */
	} catch (Throwable e) {
	    e.printStackTrace();
	    throw new Error(e.getMessage());
	}
    }
}

