/*
 *  Source file: AirlineCompanyBase.java
 *  Class file:  COM.ibm.jaws.models.trs.AirlineCompanyBase
 */

package COM.ibm.jaws.models.trs;

import COM.ibm.jaws.mofw.*;
import java.lang.StringBuffer;
import COM.ibm.jaws.mofw.Iterator;
import java.lang.String;
import COM.ibm.jaws.mofw.ReferenceCollection;
import COM.ibm.jaws.mofw.BaseCollection;
import COM.ibm.jaws.mofw.QueryableCollection;

/**
 * This is the implementation class for the interface AirlineCompany.
 * @see COM.ibm.jaws.models.trs.AirlineCompanyBase
 * @see COM.ibm.jaws.models.trs.AirlineCompany
 */
public class AirlineCompanyImpl
	extends AirlineCompanyBase
        implements AirlineCompany,
	           COM.ibm.jaws.motk.Activation {

  public  AirlineCompanyImpl()
  {
    super();
  }

  public  AirlineCompanyImpl(String parm1)
  {
    super(parm1);
  }

  public void externalizeToStream(OutputEDStream out)
  {
    prepareForExternalization();
    out.writeObject(name);
    out.writeObject(contact);
    out.writeObject(planeRC);
    out.writeObject(flightPlanRC);
  }

  public void internalizeFromStream(InputEDStream in)
  {
    name = (String) in.readObject();
    contact = (Contact) in.readObject();
    planeRC = (ReferenceCollection) in.readObject();
    flightPlanRC = (ReferenceCollection) in.readObject();
    activate();
  }

  /**
   * See <a href="COM.ibm.jaws.mofw.Lifecycle#release">Lifecycle.release</a>
   */
  public void release() {}

  /**
   * See <a href="COM.ibm.jaws.mofw.Lifecycle#remove">Lifecycle.remove</a>
   */
  public void remove() {}

  /**
   * See <a href="COM.ibm.jaws.motk.Activation#activate">Activation.activate</a>
   */
  public void activate() {}

  /**
   * See <a href="COM.ibm.jaws.motk.Activation#prepareForExternalization">Activation.prepareForExternalization</a>
   */
  public void prepareForExternalization() {}

} // end of class: AirlineCompanyImpl
