package COM.ibm.jaws.models.trs;


import java.net.*;


abstract public class AirportBase extends CommonBase
{
    protected String name = null;
    protected String code = null;
    protected transient URL url = null;
    protected String urlString = null;
    protected City city = null;
    
    
    public
    AirportBase()
    {
    }


    public
    AirportBase(String name,
		String code,
		URL url)
    {
	this.name = name;
	this.code = code;
	this.url = url;
	this.city = city;
    }


    public void
    activate()
    {
	try {
	    if (url == null && urlString != null) {
		url = new URL(urlString);
	    }
	} catch (Throwable e) {
	}
    }


    public City
    addCity(City city)
    {
	this.city = city;
	return city;
    }


    public City
    getCity()
    {
	return city;
    }


    public String
    getCode()
    {
	return code;
    }


    public String
    getName()
    {
	return name;
    }


    public URL
    getURL()
    {
	return url;
    }


    public void
    prepareForExternalization()
    {
	if (url != null) {
	    urlString = url.toString();
	}
    }


    public String
    toString()
    {
	return
	    "Name: " + name + "\n" +
	    "Code: " + code + "\n" +
	    "URL: " + url + "\n";
    }
}
