package COM.ibm.jaws.models.trs;


import java.net.*;
import COM.ibm.jaws.mofw.*;


abstract public class CarRentalCompanyBase extends CommonBase
{
    protected String name = null;
    protected Contact contact = null;
    protected ReferenceCollection carRC = null;
    protected ReferenceCollection carFleetRC = null;


    public
    CarRentalCompanyBase()
    {
    }


    public
    CarRentalCompanyBase(String name)
    {
	this.name = name;
    }


    public Contact
    addContact(String address1,
	       String address2,
	       String city,
	       String zip,
	       String phoneAreaCode,
	       String phoneNumber,
	       String faxAreaCode,
	       String faxNumber,
	       String emailId,
	       String emailAddress,
	       URL url)
    {
	Contact contactManageable =
	    new ContactImpl(self,
			    address1, address2,
			    city, zip,
			    phoneAreaCode, phoneNumber,
			    faxAreaCode, faxNumber,
			    emailId, emailAddress, url);

	contact =
	    (Contact) contactBC().createFromCopy(null,
						 contactManageable,
						 null);

	return contact;
    }



    public Contact
    getContact()
    {
	return contact;
    }


    public Car
    addCar(String name,
	   String image)
    {
	if (carRC == null) {
	    carRC = (ReferenceCollection)
		carRentalCarRCBC().createFromCopy(null, null, null);
	}

	Car car = new CarImpl(name, image);

	Car carManaged =
	    (Car) carBC().createFromCopy(name, car, null);

	carRC.insertElement(carManaged);

	return carManaged;
    }


    public Iterator
    getCars()
    {
	return carRC.evaluate(null, "MOFW::objects");
    }


    public CarFleet
    addCarFleet(String airportCode,
		String name,
		float price,
		String carString)
    {
	if (carFleetRC == null) {
	    carFleetRC = (ReferenceCollection)
		carRentalCarFleetRCBC().createFromCopy(null, null, null);
	}

	CarFleet carFleet = new CarFleetImpl(this,
					     airportCode,
					     name,
					     carString,
					     price);

	CarFleet carFleetManaged =
	    (CarFleet) carFleetBC().createFromCopy(null, carFleet, null);

	carFleetRC.insertElement(carFleetManaged);

	return carFleetManaged;
    }


    public Iterator
    getCarFleets()
    {
	return carFleetRC.evaluate(null, "MOFW::objects");
    }


    public String
    getName()
    {
	return name;
    }


    public String
    toString()
    {
	return
	    "Name: " + name + "\n";
    }
}
