package COM.ibm.jaws.models.trs;

import COM.ibm.jaws.mofw.*;
import java.lang.StringBuffer;
import java.lang.String;
import java.lang.Object;

abstract public class CarReservationBase extends ReservationBase
                                         implements CarReservation
{
    protected CarFleet carFleet = null;

  public void externalizeToStream(OutputEDStream out)
  {
    out.writeObject(carFleet);

    out.writeObject(trip);
    out.writeObject(status);
    out.writeInt(numberTraveling);
    out.writeObject(creditCard);
    out.writeInt(confirmationNumber);
  }

  public void internalizeFromStream(InputEDStream in)
  {
    carFleet = (CarFleet) in.readObject();

    trip = (Object) in.readObject();
    status = (String) in.readObject();
    numberTraveling = in.readInt();
    creditCard = (CreditCard) in.readObject();
    confirmationNumber = in.readInt();
  }


    public
    CarReservationBase()
    {
    }


    public
    CarReservationBase(Object trip,
		       int numberTraveling,
		       CarFleet carFleet)
    {
	super(trip, numberTraveling);
	this.carFleet = carFleet;
	carFleet.reserve((CarReservation) this);
    }


    public void
    cancel()
    {
	carFleet.cancel(this);
    }


    public CarFleet
    getCarFleet()
    {
	return carFleet;
    }
}
