package COM.ibm.jaws.models.trs;


import java.net.*;
import COM.ibm.jaws.mofw.*;


abstract public class CityBase extends CommonBase
{
    protected String name = null;

    protected transient URL url = null;
    protected String urlString = null;

    protected transient URL weatherURL = null;
    protected String weatherURLString = null;

    protected State state = null;
    protected String stateString = null;

    protected Airport airport = null;


    public
    CityBase()
    {
    }


    public
    CityBase(String name,
	     String stateString,
	     URL url,
	     URL weatherURL)
    {
	this.name = name;
	this.stateString = stateString;
	this.url = url;
	this.weatherURL = weatherURL;
    }


    public void
    activate()
    {
	try {
	    if (urlString != null) {
		url = new URL(urlString);
	    }

	    if (weatherURLString != null) {
		weatherURL = new URL(weatherURLString);
	    }
	} catch (Throwable e) {
	}

	if (stateString != null) {
	    setState(stateString);
	}
    }


    public void
    addAirport(Airport airport)
    {
	this.airport = airport;
    }


    public Airport
    getAirport()
    {
	return airport;
    }
    

    public String
    getCityState()
    {
	return getName() + ", " + getState().getAbbreviation();
    }


    public String
    getName()
    {
	return name;
    }


    public State
    getState()
    {
	return state;
    }


    public URL
    getURL()
    {
	return url;
    }


    public URL
    getWeatherURL()
    {
	return weatherURL;
    }


    public void
    prepareForExternalization()
    {
	if (url != null) {
	    urlString = url.toString();
	}

	if (weatherURL != null) {
	    weatherURLString = weatherURL.toString();
	}
    }


    public String
    toString()
    {
	return
	    "Name: " + name + "\n" +
	    "URL: " + url + "\n" +
	    "Weather URL: " + weatherURL + "\n";
    }


    //-------------------------------------------------------------------------
    // Protected methods


    protected void
    setState(String stateString)
    {
	Iterator states = stateBC().evaluate(null, "MOFW::objects");
	State state = null;
	while ((state = (State) states.getNext()) != null) {
	    if (state.getName().equals(stateString)) {
		this.state = state;
		break;
	    }
	}
    }
}
