package COM.ibm.jaws.models.trs;


import COM.ibm.jaws.mofw.*;
import COM.ibm.jaws.util.*;


public abstract class CommonBase implements Manageable,
                                            Dependent,
                                            IdentityDelegator
{
    public static Debug d = new Debug("Common", true);

    public static final String ApplicationSpace = "trsApplicationSpace";

    public static final String ApplicationRootBC = "TRS::ApplicationRootBC";

    public static final String AirlineCompanyBC = "TRS::AirlineCompanyBC";
    public static final String AirportBC = "TRS::AirportBC";
    public static final String FlightReservationBC = "TRS::FlightReservationBC";
    public static final String CarBC = "TRS::CarBC";
    public static final String CarFleetBC = "TRS::CarFleetBC";
    public static final String CarFleetAvailabilityBC =
    "TRS::CarFleetAvailabilityBC";
    public static final String CarRentalCompanyBC = "TRS::CarRentalCompanyBC";
    public static final String CarReservationBC = "TRS::CarReservationBC";
    public static final String CityBC = "TRS::CityBC";
    public static final String ConfirmationBC = "TRS::ConfirmationBC";
    public static final String ContactBC = "TRS::ContactBC";
    public static final String CreditCardBC = "TRS::CreditCardBC";
    public static final String FlightBC = "TRS::FlightBC";
    public static final String FlightPlanBC = "TRS::FlightPlanBC";
    public static final String HotelCompanyBC = "TRS::HotelCompanyBC";
    public static final String HotelReservationBC = "TRS::HotelReservationBC";
    public static final String PlaneBC = "TRS::PlaneBC";
    public static final String RoomGroupBC = "TRS::RoomGroupBC";
    public static final String RoomGroupAvailabilityBC =
    "TRS::RoomGroupAvailabilityBC";
    public static final String StateBC = "TRS::StateBC";
    public static final String CountryBC = "TRS::CountryBC";
    public static final String TravelProfileBC = "TRS::TravelProfileBC";
    public static final String TripBC = "TRS::TripBC";
    public static final String UserBC = "TRS::UserBC";

    public static final String AirlineFlightPlanRCBC =
    "TRS::AirlineCompany::FlightPlanRCBC";
    public static final String AirlinePlaneRCBC =
    "TRS::AirlineCompany::AirlinePlaneRCBC";
    public static final String CarRentalCarRCBC =
    "TRS::CarRentalCompany::CarRCBC";
    public static final String CarRentalCarFleetRCBC =
    "TRS::CarRentalCompany::CarFleetRCBC";
    public static final String CarFleetCarRCBC =
    "TRS::CarFleet::CarRCBC";
    public static final String CarFleetCarFleetAvailabilityRCBC =
    "TRS::CarFleet::CarFleetAvailabilityRCBC";
    public static final String FlightPlanFlightRCBC =
    "TRS::FlightPlan::FlightRCBC";
    public static final String HotelRoomRCBC = "TRS::HotelCompany::RoomRCBC";
    public static final String UserTripRCBC = "TRS::User::TripRCBC";
    public static final String RoomGroupRoomGroupAvailabilityRCBC =
    "TRS::RoomGroup::RoomGroupAvailabilityRCBC";
    public static final String TravelProfileCreditCardRCBC =
    "TRS::TravelProfile::CreditCardRCBC";
    public static final String TripReservationRCBC =
    "TRS::Trip::ReservationRCBC";

    protected transient KeyedCollection dependentContext = null;
    protected transient Object self = this;


    public void
    setDependentContext(KeyedCollection dependentContext)
    {
	this.dependentContext = dependentContext;
    }


    public void
    setSelf(Object self)
    {
	this.self = (Manageable) (IdentityDelegator) (Dependent) self;
    }


    public BaseCollection
    applicationRootBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(ApplicationRootBC);
    }


    public BaseCollection
    airlineCompanyBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(AirlineCompanyBC);
    }


    public BaseCollection
    carRentalCompanyBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(CarRentalCompanyBC);
    }


    public BaseCollection
    carBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(CarBC);
    }


    public BaseCollection
    carFleetBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(CarFleetBC);
    }


    public BaseCollection
    carFleetAvailabilityBC()
    {
	return
	    (BaseCollection)
	    dependentContext.resolve(CarFleetAvailabilityBC);
    }


    public BaseCollection
    countryBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(CountryBC);
    }


    public BaseCollection
    hotelCompanyBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(HotelCompanyBC);
    }


    public BaseCollection
    roomGroupBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(RoomGroupBC);
    }


    public BaseCollection
    roomGroupAvailabilityBC()
    {
	return
	    (BaseCollection)
	    dependentContext.resolve(RoomGroupAvailabilityBC);
    }


    public BaseCollection
    airportBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(AirportBC);
    }


    public BaseCollection
    flightReservationBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(FlightReservationBC);
    }


    public BaseCollection
    carReservationBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(CarReservationBC);
    }


    public BaseCollection
    cityBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(CityBC);
    }


    public BaseCollection
    contactBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(ContactBC);
    }


    public BaseCollection
    confirmationBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(ConfirmationBC);
    }


    public BaseCollection
    creditCardBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(CreditCardBC);
    }


    public BaseCollection
    flightBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(FlightBC);
    }


    public BaseCollection
    flightPlanBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(FlightPlanBC);
    }


    public BaseCollection
    hotelReservationBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(HotelReservationBC);
    }


    public BaseCollection
    planeBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(PlaneBC);
    }


    public BaseCollection
    stateBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(StateBC);
    }


    public BaseCollection
    tripBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(TripBC);
    }


    public BaseCollection
    travelProfileBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(TravelProfileBC);
    }


    public BaseCollection
    userBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(UserBC);
    }



    //-------------------------------------------------------------------------
    // RCBC


    public BaseCollection
    airlineFlightPlanRCBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(AirlineFlightPlanRCBC);
    }


    public BaseCollection
    airlinePlaneRCBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(AirlinePlaneRCBC);
    }


    public BaseCollection
    carRentalCarRCBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(CarRentalCarRCBC);
    }

    
    public BaseCollection
    carRentalCarFleetRCBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(CarRentalCarFleetRCBC);
    }

    
    public BaseCollection
    carFleetCarRCBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(CarFleetCarRCBC);
    }

    
    public BaseCollection
    carFleetCarFleetAvailabilityRCBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(CarFleetCarFleetAvailabilityRCBC);
    }

    
    public BaseCollection
    flightPlanFlightRCBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(FlightPlanFlightRCBC);
    }


    public BaseCollection
    hotelRoomRCBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(HotelRoomRCBC);
    }


    public BaseCollection
    roomGroupRoomGroupAvailabilityRCBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(RoomGroupRoomGroupAvailabilityRCBC);
    }


    public BaseCollection
    travelProfileCreditCardRCBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(TravelProfileCreditCardRCBC);
    }


    public BaseCollection
    userTripRCBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(UserTripRCBC);
    }


    public BaseCollection
    tripReservationRCBC()
    {
	return (BaseCollection)
	    dependentContext.resolve(TripReservationRCBC);
    }
}
