/*
 *  Source file: CommonBase.java
 *  Class file:  COM.ibm.jaws.models.trs.CommonBase
 */

package COM.ibm.jaws.models.trs;

import COM.ibm.jaws.mofw.*;
import COM.ibm.jaws.mofw.Dependent;
import COM.ibm.jaws.mofw.Manageable;
import COM.ibm.jaws.mofw.IdentityDelegator;
import COM.ibm.jaws.mofw.EDStreamFormatError;
import java.lang.String;
import COM.ibm.jaws.util.Debug;
import COM.ibm.jaws.mofw.InputEDStream;
import COM.ibm.jaws.mofw.KeyedCollection;
import COM.ibm.jaws.mofw.BaseCollection;
import COM.ibm.jaws.mofw.OutputEDStream;
import java.lang.Object;

/**
 * This is the implementation class for the interface Common.
 * @see COM.ibm.jaws.models.trs.CommonBase
 * @see COM.ibm.jaws.models.trs.Common
 */
public class CommonImpl
	extends CommonBase
        implements Common,
	           COM.ibm.jaws.motk.Activation {

  public  CommonImpl()
  {
    super();
  }

  public void externalizeToStream(OutputEDStream out)
  {
    prepareForExternalization();
  }

  public void internalizeFromStream(InputEDStream in)
  {
    activate();
  }

  /**
   * See <a href="COM.ibm.jaws.mofw.Lifecycle#release">Lifecycle.release</a>
   */
  public void release() {}

  /**
   * See <a href="COM.ibm.jaws.mofw.Lifecycle#remove">Lifecycle.remove</a>
   */
  public void remove() {}

  /**
   * See <a href="COM.ibm.jaws.motk.Activation#activate">Activation.activate</a>
   */
  public void activate() {}

  /**
   * See <a href="COM.ibm.jaws.motk.Activation#prepareForExternalization">Activation.prepareForExternalization</a>
   */
  public void prepareForExternalization() {}

} // end of class: CommonImpl
