package COM.ibm.jaws.models.trs;


import java.net.*;
import COM.ibm.jaws.mofw.*;


abstract public class ContactBase extends CommonBase
{
    protected Object backPointer = null;
    protected String address1 = null;
    protected String address2 = null;

    protected City city = null;
    protected String cityString = null;

    protected String zip = null;
    protected String phoneAreaCode = null;
    protected String phoneNumber = null;
    protected String faxAreaCode = null;
    protected String faxNumber = null;
    protected String emailId = null;
    protected String emailAddress = null;

    protected transient URL url = null;
    protected String urlString = null;


    public
    ContactBase()
    {
    }


    public
    ContactBase(Object backPointer,
		String address1,
		String address2,
		String cityString,
		String zip,
		String phoneAreaCode,
		String phoneNumber,
		String faxAreaCode,
		String faxNumber,
		String emailId,
		String emailAddress,
		URL url)
    {
	this.backPointer = backPointer;
	this.address1 = address1;
	this.address2 = address2;
	this.cityString = cityString;
	this.zip = zip;
	this.phoneAreaCode = phoneAreaCode;
	this.phoneNumber = phoneNumber;
	this.faxAreaCode = faxAreaCode;
	this.faxNumber = faxNumber;
	this.emailId = emailId;
	this.emailAddress = emailAddress;
	this.url = url;
    }


    public void
    activate()
    {
	try {
	    if (urlString != null) {
		url = new URL(urlString);
	    }
	} catch (Throwable e) {
	}

	if (cityString != null) {
	    setCity(cityString);
	    cityString = null;
	}
    }


    public String
    getAddress1()
    {
	return address1;
    }


    public String
    getAddress2()
    {
	return address2;
    }


    public City
    getCity()
    {
	return city;
    }


    public String
    getEmailId()
    {
	return emailId;
    }

    public String
    getEmailAddress()
    {
	return emailAddress;
    }

    public String
    getFaxNumber()
    {
	return faxNumber;
    }

    public String
    getFaxAreaCode()
    {
	return faxAreaCode;
    }


    public String
    getPhoneAreaCode()
    {
	return phoneAreaCode;
    }

    public String
    getPhoneNumber()
    {
	return phoneNumber;
    }

    public URL
    getURL()
    {
	return url;
    }


    public String
    getZip()
    {
	return zip;
    }

//@BC BEGIN
    public void
    setAddress1(String d)
    {
	address1 = d;
    }

    public void
    setAddress2(String d)
    {
	address2 = d;
    }

    public void
    setCityString(String d)
    {
	cityString = d;
	if (cityString != null) {
	    setCity(cityString);
	    cityString = null;
	}
    }

    public void
    setEmailId(String d)
    {
	emailId = d;
    }

    public void
    setEmailAddress(String d)
    {
	emailAddress = d;
    }

    public void
    setFaxAreaCode(String d)
    {
	faxAreaCode = d;
    }

    public void
    setFaxNumber(String d)
    {
	faxNumber = d;
    }

    public void
    setPhoneAreaCode(String d)
    {
	phoneAreaCode = d;
    }

    public void
    setPhoneNumber(String d)
    {
	phoneNumber = d;
    }

    public void
    setURL(String d)
    {
	try {
	    if (d != null) {
		url = new URL(d);
	    }
	} catch (Throwable e) {
	}
    }

    public void
    setZip(String d)
    {
	zip = d;
    }
//@BC END

    public void
    prepareForExternalization()
    {
	if (url != null) {
	    urlString = url.toString();
	}
    }


    public String
    toString()
    {
	return
	    "Address1: " + address1 + "\n" +
	    "Address2: " + address2 + "\n" +
	    "Zip: " + zip + "\n" +
	    "Phone: (" + phoneAreaCode + ") " + phoneNumber + "\n" +
	    "Fax: (" + faxAreaCode + ") " + faxNumber + "\n" +
	    "Email: " + emailId + "@" + emailAddress + "\n" +
	    "URL: " + url + "\n";
    }


    //-------------------------------------------------------------------------
    // Protected methods


    protected void
    setCity(String cityString)
    {
	Iterator cities = null;
	if ((cities = cityBC().evaluate(null, "MOFW::objects")) == null) {
	    return;
	}

	City city = null;
	while ((city = (City) cities.getNext()) != null) {
	    if (city.getName().equals(cityString)) {
		this.city = city;
		break;
	    }
	}
    }
}
