package COM.ibm.jaws.models.trs;


import java.net.*;


abstract public class CountryBase extends CommonBase
{
    protected String name = null;
    protected String abbreviation = null;
    protected transient URL url = null;
    protected String urlString = null;


    public
    CountryBase()
    {
    }


    public
    CountryBase(String name,
		String abbreviation,
		URL url)
    {
	this.name = name;
	this.abbreviation = abbreviation;
	this.url = url;
    }


    public void
    activate()
    {
	try {
	    if (url == null && urlString != null) {
		url = new URL(urlString);
	    }
	} catch (Throwable e) {
	}
    }


    public String
    getAbbreviation()
    {
	return abbreviation;
    }


    public String
    getName()
    {
	return name;
    }


    public URL
    getURL()
    {
	return url;
    }


    public void
    prepareForExternalization()
    {
	if (url != null) {
	    urlString = url.toString();
	}
    }


    public String
    toString()
    {
	return
	    "Name: " + name + "\n" +
	    "Abbreviation: " + abbreviation + "\n" +
	    "URL: " + url + "\n";
    }
}
