package COM.ibm.jaws.models.trs;


import java.util.*;


abstract public class CreditCardBase extends CommonBase
{
    protected Object travelProfile = null;
    protected String type = null;
    protected String number = null;
    protected transient Date expirationDate = null;
    protected String expirationDateString = null;


    public
    CreditCardBase()
    {
    }


    public
    CreditCardBase(Object travelProfile,
		   String type,
		   String number,
		   Date expirationDate)
    {
	this.travelProfile = travelProfile;
	this.type = type;
	this.number = number;
	this.expirationDate = expirationDate;
    }


    public void
    activate()
    {
	if (expirationDateString != null) {
	    expirationDate = stringToDate(expirationDateString); //new Date(expirationDateString);
	}
    }


    public Date
    getExpirationDate()
    {
	return expirationDate;
    }


    public String
    getNumber()
    {
	return number;
    }


    public String
    getType()
    {
	return type;
    }


    public void
    setExpirationDate(Date d)
    {
	expirationDate = d;
    }


    public void
    setNumber(String d)
    {
	number = d;
    }


    public void
    setType(String d)
    {
	type = d;
    }


    public void
    prepareForExternalization()
    {
	if (expirationDate != null) {
	    expirationDateString = dateToString(expirationDate); //.toGMTString();
	}
    }


    public String
    toString()
    {
	return
	    "Type: " + type + "\n" +
	    "Number: " + number + "\n" +
	    "ExpirationDate: " + expirationDate + "\n";
    }

    protected Date stringToDate( String date ) {
	Date d = new Date();
	String c = "";
	StringTokenizer st = new StringTokenizer(date, "|");
	c = st.nextToken();
	d.setMonth( Integer.valueOf(c).intValue() );
	c = st.nextToken();
	d.setDate( Integer.valueOf(c).intValue() );
	c = st.nextToken();
	d.setYear( Integer.valueOf(c).intValue() );
	c = st.nextToken();
	d.setHours( Integer.valueOf(c).intValue() );
	c = st.nextToken();
	d.setMinutes( Integer.valueOf(c).intValue() );
	c = st.nextToken();
	d.setSeconds( Integer.valueOf(c).intValue() );
	//System.out.println("stringToDate -> Date = " + date + " converted date = " + d);
	return d;
    }

    protected String dateToString( Date value) {
	String date = Integer.toString( ((Date)value).getMonth() );
	date = date + "|" + Integer.toString( ((Date)value).getDate() );
	date = date + "|" + Integer.toString( ((Date)value).getYear() );
	date = date + "|" + Integer.toString( ((Date)value).getHours() );
	date = date + "|" + Integer.toString( ((Date)value).getMinutes() );
	date = date + "|" + Integer.toString( ((Date)value).getSeconds() );
	//System.out.println("stringToDate -> date String = " + date + " actual date = " + value);
	return date;
    }

}
