/*
 *  Source file: FlightImpl.java
 *  Class file:  COM.ibm.jaws.models.trs.FlightImpl
 *  Produced: Thu Feb 13 09:49:15  1997
 */
package COM.ibm.jaws.models.trs;

import COM.ibm.jaws.mofw.*;
import COM.ibm.jaws.services.bcfw.*;
import COM.ibm.jaws.services.lrucmgr.*;
import COM.ibm.jaws.services.filepobc.*;
import java.util.Date;
import COM.ibm.jaws.mofw.ReferenceCollection;
import COM.ibm.jaws.motk.Activation;
import java.lang.String;
import COM.ibm.jaws.mofw.InputEDStream;
import COM.ibm.jaws.mofw.OutputEDStream;
import java.lang.Object;

/**
 * This is effectively an implementation mixin of the specific
 * Manageable class (with Impl suffix) and the LruCacheEntryImpl 
 * class.  The CachedSuffix is the same as the one given to the
 * FilepoBCImpl instance (eg, FilepoCached) that will manage
 * this Cached object.
 */
public class FlightFilepoCached
	extends FlightImpl
        implements FilepoCached {

  
/**
 * The following is a copy of the LruCacheEntryImpl code. 
 */  
   // The LRU clock algorithm's clock count 
   //    - set to maxClock when used() 
   //    - decrement while looking for victim
   //    - 0 ==> candidate for victim
   public int clockCountLruCacheEntry = 0;

   // The Cached object's BC
   private BaseCollectionEC cachedBaseLruCacheEntry; 
   // The Cached object's key 
   private String cachedKeyLruCacheEntry; 
   // The Cached object 
   private Manageable cachedLruCacheEntry; 
   // The single attached MO
   private ManagedDel attachedManagedDelLruCacheEntry; 
   // Indicates whether cached internal MO has newer state 
   // than its disk version.
   //    - set to false when activated or cleaned
   //    - set to true when used(true) by an updating method 
   private  boolean dirtyLruCacheEntry = false; 
   // Set clockCountLruCacheEntry to this when used()
   private int maxClockLruCacheEntry = 3; 
   // The hold count.  This is incremented/decremented at the beginning
   // and end of a ManagedDel method, so the cache entry cannot be
   // chosen as a victim during the method.  
   private int holdCountLruCacheEntry = 0; 

  /**
   * All Cached classes must provide a public default constructor. 
   * The FilepoBC uses this when activating a Cached object.
   */
  public FlightFilepoCached()
  {}
   
   // Constructor parameters include Cached object's BaseCollectionEC, Key and Cached object.
   public FlightFilepoCached(
                            BaseCollectionEC yourCachedBase, 
                            String yourCachedKey, 
                            Manageable yourCached) {
      cachedBaseLruCacheEntry = yourCachedBase; 
      cachedKeyLruCacheEntry  = yourCachedKey;    
      cachedLruCacheEntry     = yourCached; 
   } 

   public void setCacheEntryKey(String yourKey) { 
      cachedKeyLruCacheEntry = yourKey; 
   }  
   public String getCacheEntryKey() {  
      return cachedKeyLruCacheEntry; 
   } 
   public void setCacheEntryCached(Manageable yourCached) { 
      cachedLruCacheEntry = yourCached;  
   } 
   public Manageable getCacheEntryCached() {  
      return cachedLruCacheEntry; 
   } 
   public void setCacheEntryAttachedManagedDel(ManagedDel yourManagedDel) { 
      attachedManagedDelLruCacheEntry = yourManagedDel;  
   }   
   public ManagedDel getCacheEntryAttachedManagedDel() { 
      return attachedManagedDelLruCacheEntry;
   }  
   public void setCacheEntryBase(BaseCollection yourBase) {  
      cachedBaseLruCacheEntry = (BaseCollectionEC)yourBase; 
   } 
   public BaseCollection getCacheEntryBase() { 
      return cachedBaseLruCacheEntry; 
   } 

   public void usedCacheEntry(boolean updated) { 
      clockCountLruCacheEntry = maxClockLruCacheEntry; 
      if (updated)
         dirtyLruCacheEntry = true; 
   } 
   
   public void cleanedCacheEntry() {  
      dirtyLruCacheEntry = false; 
   } 

   public boolean updatedCacheEntry() { 
      return dirtyLruCacheEntry; 
   } 

   public int getLruCacheEntryClockCount() { 
      return clockCountLruCacheEntry; 
   } 
   public void decrementLruCacheEntryClockCount() { 
      clockCountLruCacheEntry--; 
   } 
   public void holdCacheEntry() { 
      holdCountLruCacheEntry++; 
   } 
   public void unholdCacheEntry() { 
      holdCountLruCacheEntry--; 
   } 
   public int getHoldCountCacheEntry() { 
      return holdCountLruCacheEntry; 
   } 
} // end of FlightFilepoCached
