/*
 *  Source file: FlightBase.java
 *  Class file:  COM.ibm.jaws.models.trs.FlightBase
 */

package COM.ibm.jaws.models.trs;

import COM.ibm.jaws.mofw.*;
import java.io.PrintStream;
import java.lang.StringBuffer;
import java.util.Date;
import java.lang.String;
import COM.ibm.jaws.mofw.ReferenceCollection;
import java.lang.System;
import COM.ibm.jaws.util.Debug;
import java.lang.RuntimeException;
import COM.ibm.jaws.mofw.KeyedCollection;
import java.util.StringTokenizer;
import java.lang.Integer;
import java.lang.Object;

/**
 * This is the implementation class for the interface Flight.
 * @see COM.ibm.jaws.models.trs.FlightBase
 * @see COM.ibm.jaws.models.trs.Flight
 */
public class FlightImpl
	extends FlightBase
        implements Flight,
	           COM.ibm.jaws.motk.Activation {

  public  FlightImpl()
  {
    super();
  }

  public  FlightImpl(Object parm1,
                     java.util.Date parm2,
                     java.util.Date parm3)
  {
    super(parm1, parm2, parm3);
  }

  public void externalizeToStream(OutputEDStream out)
  {
    prepareForExternalization();
    out.writeObject(flightPlan);
    out.writeObject(departureDateTimeString);
    out.writeObject(arrivalDateTimeString);
    out.writeObject(plane);
    out.writeInt(numberSeatsReserved);
    out.writeObject(flightReservationRC);
  }

  public void internalizeFromStream(InputEDStream in)
  {
    flightPlan = (Object) in.readObject();
    departureDateTimeString = (String) in.readObject();
    arrivalDateTimeString = (String) in.readObject();
    plane = (Plane) in.readObject();
    numberSeatsReserved = in.readInt();
    flightReservationRC = (ReferenceCollection) in.readObject();
    activate();
  }

  /**
   * See <a href="COM.ibm.jaws.mofw.Lifecycle#release">Lifecycle.release</a>
   */
  public void release() {}

  /**
   * See <a href="COM.ibm.jaws.mofw.Lifecycle#remove">Lifecycle.remove</a>
   */
  public void remove() {}

} // end of class: FlightImpl
