package COM.ibm.jaws.models.trs;


import COM.ibm.jaws.mofw.*;
import java.util.Date;


abstract public class FlightPlanBase extends CommonBase
{
    protected Object airlineCompany = null;
    protected String flightNumber = null;
    protected float price = (float) 0;
    //     public float priceFirstClass;
    //     public float priceCoach;
    //     public float price BusinessClass;
    protected Airport departureAirport = null;
    protected Airport destinationAirport = null;
    protected ReferenceCollection flightRC = null;


    public
    FlightPlanBase()
    {
    }


    public
    FlightPlanBase(Object airlineCompany,
		   String flightNumber,
		   float price)
    {
	this.airlineCompany = airlineCompany;
	this.flightNumber = flightNumber;
	this.price = price;
    }


    public void
    setDepartureAirport(String departureAirportString)
    {
	if ((departureAirport =
	     (Airport) airportBC().resolve(departureAirportString)) == null) {
	    throw new RuntimeException();
	}
    }


    public Airport
    getDepartureAirport()
    {
	return departureAirport;
    }


    public void
    setDestinationAirport(String destinationAirportString)
    {
	if ((destinationAirport =
	     (Airport) airportBC().resolve(destinationAirportString)) == null) {
	    throw new RuntimeException();
	}
    }


    public Airport
    getDestinationAirport()
    {
	return destinationAirport;
    }


    public Flight
    addFlight(Date departureDateTime,
	      Date arrivalDateTime,
	      String planeString)
    {
	// Implement the lazy create for the local trip reference collection
	// if this is the first trip added for this user.
	if (flightRC == null) {
	    flightRC = (ReferenceCollection)
		airlineFlightPlanRCBC().createFromCopy(null, null, null);
	}

	// New up the manageable trip object.
	Flight flight = new FlightImpl(this,
				       departureDateTime,
				       arrivalDateTime);

	// Resolve the application's credit card base collection, and add the
	// credit card to the BC, managing it.
	Flight flightManaged =
	    (Flight) flightBC().createFromCopy(null, flight, null);
	

	flightManaged.setPlane(planeString);


	// Insert the managed trip into the local reference collection.
	flightRC.insertElement(flightManaged);

	return flightManaged;
    }


    public AirlineCompany
    getAirlineCompany()
    {
	return (AirlineCompany) airlineCompany;
    }


    public String
    getFlightNumber()
    {
	return flightNumber;
    }


    public Iterator
    getFlights()
    {
	if (flightRC == null) {
	    return null;
	}

	return flightRC.evaluate(null, "MOFW::objects");
    }

    
    public Iterator
    getConnections()
    {
	return null;
    }


    public float
    getPrice()
    {
	return price;
    }


    public String
    toString()
    {
	return
	    "FlightNumber: " + flightNumber + "\n" +
	    "Price: " + price + "\n";
    }
}
