/*
 *  Source file: FlightPlanBase.java
 *  Class file:  COM.ibm.jaws.models.trs.FlightPlanBase
 */

package COM.ibm.jaws.models.trs;

import COM.ibm.jaws.mofw.*;
import java.lang.StringBuffer;
import COM.ibm.jaws.mofw.Iterator;
import java.lang.String;
import COM.ibm.jaws.mofw.ReferenceCollection;
import COM.ibm.jaws.mofw.KeyedCollection;
import java.lang.RuntimeException;
import COM.ibm.jaws.mofw.BaseCollection;
import COM.ibm.jaws.mofw.QueryableCollection;
import java.lang.Object;

/**
 * This is the implementation class for the interface FlightPlan.
 * @see COM.ibm.jaws.models.trs.FlightPlanBase
 * @see COM.ibm.jaws.models.trs.FlightPlan
 */
public class FlightPlanImpl
	extends FlightPlanBase
        implements FlightPlan,
	           COM.ibm.jaws.motk.Activation {

  public  FlightPlanImpl()
  {
    super();
  }

  public  FlightPlanImpl(Object parm1,
                         String parm2,
                         float parm3)
  {
    super(parm1, parm2, parm3);
  }

  public void externalizeToStream(OutputEDStream out)
  {
    prepareForExternalization();
    out.writeObject(airlineCompany);
    out.writeObject(flightNumber);
    out.writeFloat(price);
    out.writeObject(departureAirport);
    out.writeObject(destinationAirport);
    out.writeObject(flightRC);
  }

  public void internalizeFromStream(InputEDStream in)
  {
    airlineCompany = (Object) in.readObject();
    flightNumber = (String) in.readObject();
    price = in.readFloat();
    departureAirport = (Airport) in.readObject();
    destinationAirport = (Airport) in.readObject();
    flightRC = (ReferenceCollection) in.readObject();
    activate();
  }

  /**
   * See <a href="COM.ibm.jaws.mofw.Lifecycle#release">Lifecycle.release</a>
   */
  public void release() {}

  /**
   * See <a href="COM.ibm.jaws.mofw.Lifecycle#remove">Lifecycle.remove</a>
   */
  public void remove() {}

  /**
   * See <a href="COM.ibm.jaws.motk.Activation#activate">Activation.activate</a>
   */
  public void activate() {}

  /**
   * See <a href="COM.ibm.jaws.motk.Activation#prepareForExternalization">Activation.prepareForExternalization</a>
   */
  public void prepareForExternalization() {}

} // end of class: FlightPlanImpl
