package COM.ibm.jaws.models.trs;

import COM.ibm.jaws.mofw.*;
import java.lang.StringBuffer;
import java.lang.String;
import java.lang.Object;

abstract public class FlightReservationBase extends ReservationBase
                                            implements FlightReservation
{
    protected Flight flight = null;
    protected String seat = null;

  public void externalizeToStream(OutputEDStream out)
  {
    out.writeObject(flight);
    out.writeObject(seat);
    out.writeObject(trip);
    out.writeObject(status);
    out.writeInt(numberTraveling);
    out.writeObject(creditCard);
    out.writeInt(confirmationNumber);
  }

  public void internalizeFromStream(InputEDStream in)
  {
    flight = (Flight) in.readObject();
    seat = (String) in.readObject();

    trip = (Object) in.readObject();
    status = (String) in.readObject();
    numberTraveling = in.readInt();
    creditCard = (CreditCard) in.readObject();
    confirmationNumber = in.readInt();
  }

    public
    FlightReservationBase()
    {
    }


    public
    FlightReservationBase(Object trip,
			  int numberTraveling,
			  Flight flight,
			  String seat)
    {
	super(trip, numberTraveling);
	this.flight = flight;
	this.seat = seat;
	flight.reserve(this);
    }


    public void
    cancel()
    {
	flight.cancel(this);
    }


    public Flight
    getFlight()
    {
	return flight;
    }


    public String
    getSeat()
    {
	return seat;
    }


    public void
    setSeat(String seat)
    {
	this.seat = seat;
    }


    public String
    toString()
    {
	return
	    super.toString() +
	    "Seat: " + seat + "\n";
    }
}
