package COM.ibm.jaws.models.trs;


import java.net.*;
import COM.ibm.jaws.mofw.*;


abstract public class HotelCompanyBase extends CommonBase
{
    protected String name = null;
    protected String image = null;
    protected Contact contact = null;
    protected ReferenceCollection roomGroupRC = null;


    public
    HotelCompanyBase()
    {
    }


    public
    HotelCompanyBase(String name,
		     String image)
    {
	this.name = name;
	this.image = image;
    }


    public Contact
    addContact(String address1,
	       String address2,
	       String city,
	       String zip,
	       String phoneAreaCode,
	       String phoneNumber,
	       String faxAreaCode,
	       String faxNumber,
	       String emailId,
	       String emailAddress,
	       URL url)
    {
	Contact contactManageable =
	    new ContactImpl(self,
			    address1, address2,
			    city, zip,
			    phoneAreaCode, phoneNumber,
			    faxAreaCode, faxNumber,
			    emailId, emailAddress, url);

	contact =
	    (Contact) contactBC().createFromCopy(null,
						 contactManageable,
						 null);

	return contact;
    }



    public Contact
    getContact()
    {
	return contact;
    }


    public String
    getImage()
    {
	return image;
    }


    public RoomGroup
    addRoomGroup(String cityString,
		 String name,
		 String info,
		 float price)
    {
	if (roomGroupRC == null) {
	    roomGroupRC = (ReferenceCollection)
		hotelRoomRCBC().createFromCopy(null, null, null);
	}

	RoomGroup roomGroupManaged = (RoomGroup) roomGroupBC().resolve(name);
	if (roomGroupManaged == null) {
	    RoomGroup roomGroup = new RoomGroupImpl(this,
						    cityString,
						    name,
						    info,
						    price);

	    roomGroupManaged =
		(RoomGroup) roomGroupBC().createFromCopy(null,
							 roomGroup,
							 null);
	}

	roomGroupRC.insertElement(roomGroupManaged);

	return roomGroupManaged;
    }


    public Iterator
    getRoomGroups()
    {
	return roomGroupRC.evaluate(null, "MOFW::objects");
    }


    public String
    getName()
    {
	return name;
    }


    public String
    toString()
    {
	return
	    "Name: " + name + "\n";
    }
}
