package COM.ibm.jaws.models.trs;

import COM.ibm.jaws.mofw.*;
import java.lang.StringBuffer;
import java.lang.String;
import java.lang.Object;

import java.util.*;


abstract public class HotelReservationBase extends ReservationBase
                                           implements HotelReservation
{
    protected RoomGroup roomGroup = null;

    public void
    prepareForExternalization() {
    }

  public void externalizeToStream(OutputEDStream out)
  {
    out.writeObject(roomGroup);

    out.writeObject(trip);
    out.writeObject(status);
    out.writeInt(numberTraveling);
    out.writeObject(creditCard);
    out.writeInt(confirmationNumber);
  }

  public void internalizeFromStream(InputEDStream in)
  {
    roomGroup = (RoomGroup) in.readObject();

    trip = (Object) in.readObject();
    status = (String) in.readObject();
    numberTraveling = in.readInt();
    creditCard = (CreditCard) in.readObject();
    confirmationNumber = in.readInt();
  }


    public
    HotelReservationBase()
    {
    }


    public
    HotelReservationBase(Object trip,
			 int numberTraveling,
			 RoomGroup roomGroup)
    {
	super(trip, numberTraveling);
	this.roomGroup = roomGroup;
	roomGroup.reserve(this);
    }


    public void
    cancel()
    {
	roomGroup.cancel(this);
    }


    public RoomGroup
    getRoomGroup()
    {
	return roomGroup;
    }
}
