/*
 *  Source file: PlaneBase.java
 *  Class file:  COM.ibm.jaws.models.trs.PlaneBase
 */

package COM.ibm.jaws.models.trs;

import COM.ibm.jaws.mofw.*;
import java.lang.StringBuffer;
import java.lang.String;

/**
 * This is the implementation class for the interface Plane.
 * @see COM.ibm.jaws.models.trs.PlaneBase
 * @see COM.ibm.jaws.models.trs.Plane
 */
public class PlaneImpl
	extends PlaneBase
        implements Plane,
	           COM.ibm.jaws.motk.Activation {

  public  PlaneImpl()
  {
    super();
  }

  public  PlaneImpl(String parm1,
                    String parm2,
                    String parm3,
                    int parm4)
  {
    super(parm1, parm2, parm3, parm4);
  }

  public void externalizeToStream(OutputEDStream out)
  {
    prepareForExternalization();
    out.writeObject(name);
    out.writeObject(seatImage);
    out.writeObject(planeImage);
    out.writeInt(totalSeats);
  }

  public void internalizeFromStream(InputEDStream in)
  {
    name = (String) in.readObject();
    seatImage = (String) in.readObject();
    planeImage = (String) in.readObject();
    totalSeats = in.readInt();
    activate();
  }

  /**
   * See <a href="COM.ibm.jaws.mofw.Lifecycle#release">Lifecycle.release</a>
   */
  public void release() {}

  /**
   * See <a href="COM.ibm.jaws.mofw.Lifecycle#remove">Lifecycle.remove</a>
   */
  public void remove() {}

  /**
   * See <a href="COM.ibm.jaws.motk.Activation#activate">Activation.activate</a>
   */
  public void activate() {}

  /**
   * See <a href="COM.ibm.jaws.motk.Activation#prepareForExternalization">Activation.prepareForExternalization</a>
   */
  public void prepareForExternalization() {}

} // end of class: PlaneImpl
