package COM.ibm.jaws.models.trs;


import COM.ibm.jaws.mofw.*;
import COM.ibm.jaws.motk.BaseCommandOn;
import java.util.Vector;
import java.util.Enumeration;


public class RCBase implements ReferenceCollection
{
    protected int elements = 0;
    protected Vector v = null;


    public
    RCBase()
    {
	v = new Vector();
    }


    public boolean
    insertElement(Object element)
    {
	v.addElement(element);
	return true;
    }
	
  
    public void
    removeElement(Object element)
    {
	boolean continueLoop = true;
	while (continueLoop) {
	    continueLoop = v.removeElement(element);
	}
    }


    public Iterator
    evaluate(String queryParameters,
	     String queryKey)
    {
	if (queryParameters != null) {
	    throw new MOFWError("Only null queryParameters are supported");
	}

	if (queryParameters != null &&
	    queryParameters.equals("") == false) {
	    throw new MOFWError("Only null queryParameters are supported");
	}

	if (queryKey.equalsIgnoreCase("MOFW::objects") == false) {
	    throw new MOFWError("Query key must be MOFW::objects");
	}

	return new RCIteratorImpl(v);
    }


    public Iterator
    dispatchAll(String queryParameters,
		String queryKey,
		CommandOn command)
    {
	Iterator qResults = evaluate(queryParameters, queryKey);
	Vector cmdResults = new Vector(20);
	Object obj;
	while ((obj = qResults.getNext()) != null) {
	    CommandOn newCommand =
		(CommandOn) ((BaseCommandOn) command).clone();
	    newCommand.setTarget(obj);
	    cmdResults.addElement(newCommand);
	}

	return new RCIteratorImpl(cmdResults);
    }


    public void
    externalizeToStream(OutputEDStream out)
    {
	Enumeration e = v.elements();
	out.writeString(String.valueOf(elements));
	out.writeBegin();
	while (e.hasMoreElements()) {
	    out.writeObject(e.nextElement());
	}
	out.writeEnd();
    }


    public void
    internalizeFromStream(InputEDStream in)
    {
	v.removeAllElements();
	elements = Integer.valueOf(in.readString()).intValue();
	in.readBegin();
	while (!in.atEnd()) {
	    v.addElement(in.readObject());
	}
	in.readEnd();
    }
}
