package COM.ibm.jaws.models.trs;


import COM.ibm.jaws.mofw.*;
import COM.ibm.jaws.motk.*;
import java.util.Vector;


public class RCIteratorBase implements Iterator
{
    Vector v = null;
    int nextPosition = 0;
    int startingPosition = 0;
    int endingPosition = 0;


    public
    RCIteratorBase()
    {
    }


    public
    RCIteratorBase(Vector v)
    {
	this.v = v;
	nextPosition = 0;
	startingPosition = 0;
	endingPosition = v.size();
    }


    public
    RCIteratorBase(Vector v,
		   int startingPosition,
		   int endingPosition)
    {
	this.v = v;
	nextPosition = startingPosition;
	this.startingPosition = startingPosition;
	this.endingPosition = endingPosition;
    }


    public Object
    getNext()
    {
	if (nextPosition < endingPosition) {
	    return v.elementAt(nextPosition++);
	}

	return null;
    }


    public int
    size()
    {
	return endingPosition;
    }


    public void
    reset()
    {
	nextPosition = startingPosition;
    }


    public void
    externalizeToStream(OutputEDStream out)
    {
	out.writeInt(nextPosition);
	out.writeInt(startingPosition);
	out.writeInt(endingPosition);
	for (int j=0; j<endingPosition; j++) {
	    out.writeObject(v.elementAt(j));
	}
    }


    public void
    internalizeFromStream(InputEDStream in)
    {
	nextPosition = in.readInt();
	startingPosition = in.readInt();
	endingPosition = in.readInt();
	if (v == null)
	    v = new Vector(endingPosition, 10);
	for (int j=0; j<endingPosition; j++) {
	    v.addElement( in.readObject());
	}
    }
}
