package COM.ibm.jaws.models.trs;


import java.lang.*;
import java.util.*;


abstract public class ReservationBase extends CommonBase
{
    public static final String Initiating = "Initiating";
    public static final String Confirmed = "Confirmed";
    public static final String Taken = "Taken";


    protected Object trip = null;
    protected String status = Initiating;
    protected int numberTraveling = 0;
    protected CreditCard creditCard = null;
    protected int confirmationNumber = 0;
    protected transient Random random = new Random();;


    public
    ReservationBase()
    {
    }


    public
    ReservationBase(Object trip,
		    int numberTraveling)
    {
	this.trip = trip;
	this.numberTraveling = numberTraveling;
	confirmationNumber = (random.nextInt() % 9000);
	if (confirmationNumber < 0) {
	    confirmationNumber = 0 - confirmationNumber;
	}
	confirmationNumber += 1000;
	this.status = Initiating;
    }


    public void
    confirm(CreditCard creditCard)
    {
 	this.creditCard = creditCard;
 	status = Confirmed;
    }


    public int
    getConfirmationNumber()
    {
	return confirmationNumber;
    }


    public CreditCard
    getCreditCard()
    {
	return creditCard;
    }


    public int
    getNumberTraveling()
    {
	return numberTraveling;
    }


    public String
    getStatus()
    {
	return status;
    }


    public Trip
    getTrip()
    {
	return (Trip) trip;
    }


    public void
    taken()
    {
	status = Taken;
    }


    public String
    toString()
    {
	return
	    "Status: " + status + "\n" +
	    "ConfirationNumber: " + confirmationNumber + "\n" +
	    "NumberTraveling: " + numberTraveling + "\n";
    }
}
