/*
 *  Source file: ReservationBase.java
 *  Class file:  COM.ibm.jaws.models.trs.ReservationBase
 */

package COM.ibm.jaws.models.trs;

import COM.ibm.jaws.mofw.*;
import java.lang.StringBuffer;
import java.lang.String;
import java.util.Random;
import java.lang.Object;

/**
 * This is the implementation class for the interface Reservation.
 * @see COM.ibm.jaws.models.trs.ReservationBase
 * @see COM.ibm.jaws.models.trs.Reservation
 */
public class ReservationImpl
	extends ReservationBase
        implements Reservation,
	           COM.ibm.jaws.motk.Activation {

  public  ReservationImpl()
  {
    super();
  }

  public  ReservationImpl(Object parm1,
                          int parm2)
  {
    super(parm1, parm2);
  }

  public void externalizeToStream(OutputEDStream out)
  {
    prepareForExternalization();
    out.writeObject(trip);
    out.writeObject(status);
    out.writeInt(numberTraveling);
    out.writeObject(creditCard);
    out.writeInt(confirmationNumber);
  }

  public void internalizeFromStream(InputEDStream in)
  {
    trip = (Object) in.readObject();
    status = (String) in.readObject();
    numberTraveling = in.readInt();
    creditCard = (CreditCard) in.readObject();
    confirmationNumber = in.readInt();
    activate();
  }

  /**
   * See <a href="COM.ibm.jaws.mofw.Lifecycle#release">Lifecycle.release</a>
   */
  public void release() {}

  /**
   * See <a href="COM.ibm.jaws.mofw.Lifecycle#remove">Lifecycle.remove</a>
   */
  public void remove() {}

  /**
   * See <a href="COM.ibm.jaws.motk.Activation#activate">Activation.activate</a>
   */
  public void activate() {}

  /**
   * See <a href="COM.ibm.jaws.motk.Activation#prepareForExternalization">Activation.prepareForExternalization</a>
   */
  public void prepareForExternalization() {}

} // end of class: ReservationImpl
