package COM.ibm.jaws.models.trs;


import java.util.*;
import java.lang.String;


abstract public class RoomGroupAvailabilityBase extends CommonBase
{
    protected Object carFleet = null;
    protected int totalAvailableRooms = 0;

    protected transient Date date = null;
    protected String dateString = null;


    public
    RoomGroupAvailabilityBase()
    {
    }


    public
    RoomGroupAvailabilityBase(Object carFleet,
			      Date date,
			      int totalAvailableRooms)
    {
	this.carFleet = carFleet;
	this.date = date;
	this.totalAvailableRooms = totalAvailableRooms;
    }


    public void
    activate()
    {
	if (date == null && dateString != null) {
	    date = stringToDate(dateString); //new Date(dateString);
	}
    }


    public void
    cancel()
    {
	totalAvailableRooms++;
    }


    public Date
    getDate()
    {
	return date;
    }


    public int
    getTotalAvailableRooms()
    {
	return totalAvailableRooms;
    }


    public void
    prepareForExternalization()
    {
	if (date != null) {
	    dateString = dateToString(date); //.toGMTString();
	}
    }


    public void
    reserve()
    {
	totalAvailableRooms--;
    }


    public String
    toString()
    {
	return
	    "Date: " + date + "\n" +
	    "TotalAvailableRooms: " + totalAvailableRooms + "\n";
    }

    protected Date stringToDate( String date ) {
	Date d = new Date();
	String c = "";
	StringTokenizer st = new StringTokenizer(date, "|");
	c = st.nextToken();
	d.setMonth( Integer.valueOf(c).intValue() );
	c = st.nextToken();
	d.setDate( Integer.valueOf(c).intValue() );
	c = st.nextToken();
	d.setYear( Integer.valueOf(c).intValue() );
	c = st.nextToken();
	d.setHours( Integer.valueOf(c).intValue() );
	c = st.nextToken();
	d.setMinutes( Integer.valueOf(c).intValue() );
	c = st.nextToken();
	d.setSeconds( Integer.valueOf(c).intValue() );
	//System.out.println("stringToDate -> Date = " + date + " converted date = " + d);
	return d;
    }

    protected String dateToString( Date value) {
	String date = Integer.toString( ((Date)value).getMonth() );
	date = date + "|" + Integer.toString( ((Date)value).getDate() );
	date = date + "|" + Integer.toString( ((Date)value).getYear() );
	date = date + "|" + Integer.toString( ((Date)value).getHours() );
	date = date + "|" + Integer.toString( ((Date)value).getMinutes() );
	date = date + "|" + Integer.toString( ((Date)value).getSeconds() );
	//System.out.println("stringToDate -> date String = " + date + " actual date = " + value);
	return date;
    }

}
