/*
 *  Source file: SessionImpl.java
 *  Class file:  COM.ibm.jaws.models.trs.SessionImpl
 *  Produced: Thu Feb 13 10:02:22  1997
 */
package COM.ibm.jaws.models.trs;

import COM.ibm.jaws.mofw.*;
import COM.ibm.jaws.services.sroot.*;
import COM.ibm.jaws.motk.*;

/**
 * Derived from: COM.ibm.jaws.models.trs.SessionImpl
 */
public class SessionSRootMO
	extends SessionImpl
        implements SRootMO {

  /**
   * All MOs must provide a public default constructor. This is used
   * prior the internalizeFromStream when re-activating an MO.
   */
  public SessionSRootMO()
  {
  }

  /**
   * The base collection containing this object.
   */  
  protected transient BaseCollection srootBase;

  public void srootSetBase(BaseCollection base)
  {
    srootBase = base;
  }

  /**
   * The key for this MO in its containing BC.
   */
  protected transient String srootKey;
  
  public void setSRootKey(String key) {
    srootKey = key;
  }

  /**
   * Shadows the parent class's implementation if any.
   */
  public String getIdentifier(BaseCollection relativeTo)
  {
    return BaseMO.getIdentifier(relativeTo, srootKey, srootBase);
  }

  /**
   * Shadows the parent class's implementation if any.
   */
  public boolean isIdentical(Identifiable otherObject)
  {
    if (otherObject instanceof Managed) {
      return getIdentifier(null).equals(
        ((Managed) otherObject).getIdentifier(null));
    } else {
      return false;
    }
  }

  /**
   * Shadows the parent class's implementation if any.
   */
  public int getConstantRandomId()
  {
    return getIdentifier(null).hashCode();
  }

  public void externalizeToStream(OutputEDStream out)
  {
      super.externalizeToStream(out); 
  }

  public void internalizeFromStream(InputEDStream in)
  {
      super.internalizeFromStream(in); 
  }

  public void setDependentContext(KeyedCollection  dependentContext)
  {
    super.setDependentContext(dependentContext); 
  }
  public void release()
  {
    super.release(); 
  }
  public void remove(KeyedCollection  dependentContext)
  {
    super.remove(); 
    // Base call is not needed as SRoot does not support remove
    // ((SRootMO) srootmoBase).remove((Managed) self);
  }

} // end of interface: SessionSRootMO

