package COM.ibm.jaws.models.trs;


import java.net.*;


abstract public class StateBase extends CommonBase
{
    protected String name = null;
    protected String abbreviation = null;
    protected transient URL url = null;
    protected String urlString = null;
    protected Country country = null;
    protected String countryString = null;


    public
    StateBase()
    {
    }


    public
    StateBase(String name,
	      String abbreviation,
	      String countryString,
	      URL url)
    {
	this.name = name;
	this.abbreviation = abbreviation;
	this.url = url;
	this.countryString = countryString;
    }


    public void
    activate()
    {
	if (countryString != null) {
	    setCountry(countryString);
	}

	try {
	    if (urlString != null) {
		url = new URL(urlString);
	    }
	} catch (Throwable e) {
	}
    }


    public String
    getAbbreviation()
    {
	return abbreviation;
    }


    public Country
    getCountry()
    {
	return country;
    }


    public String
    getName()
    {
	return name;
    }


    public URL
    getURL()
    {
	return url;
    }


    protected void
    setCountry(String countryString)
    {
	if ((country = (Country) countryBC().resolve(countryString)) == null) {
	    throw new RuntimeException("Country not found: " +
				       countryString);
	}
    }


    public void
    prepareForExternalization()
    {
	if (url != null) {
	    urlString = url.toString();
	}
    }


    public String
    toString()
    {
	return
	    "Name: " + name + "\n" +
	    "Abbreviation: " + abbreviation + "\n" +
	    "URL: " + url + "\n";
    }
}
