/*
 *  Source file: StateBase.java
 *  Class file:  COM.ibm.jaws.models.trs.StateBase
 */

package COM.ibm.jaws.models.trs;

import COM.ibm.jaws.mofw.*;
import java.lang.StringBuffer;
import java.lang.String;
import java.lang.Throwable;
import COM.ibm.jaws.mofw.KeyedCollection;
import java.lang.RuntimeException;
import java.net.URL;

/**
 * This is the implementation class for the interface State.
 * @see COM.ibm.jaws.models.trs.StateBase
 * @see COM.ibm.jaws.models.trs.State
 */
public class StateImpl
	extends StateBase
        implements State,
	           COM.ibm.jaws.motk.Activation {

  public  StateImpl()
  {
    super();
  }

  public  StateImpl(String parm1,
                    String parm2,
                    String parm3,
                    java.net.URL parm4)
  {
    super(parm1, parm2, parm3, parm4);
  }

  public void externalizeToStream(OutputEDStream out)
  {
    prepareForExternalization();
    out.writeObject(name);
    out.writeObject(abbreviation);
    out.writeObject(urlString);
    out.writeObject(country);
    out.writeObject(countryString);
  }

  public void internalizeFromStream(InputEDStream in)
  {
    name = (String) in.readObject();
    abbreviation = (String) in.readObject();
    urlString = (String) in.readObject();
    country = (Country) in.readObject();
    countryString = (String) in.readObject();
    activate();
  }

  /**
   * See <a href="COM.ibm.jaws.mofw.Lifecycle#release">Lifecycle.release</a>
   */
  public void release() {}

  /**
   * See <a href="COM.ibm.jaws.mofw.Lifecycle#remove">Lifecycle.remove</a>
   */
  public void remove() {}

} // end of class: StateImpl
