package COM.ibm.jaws.models.trs;


import COM.ibm.jaws.mofw.*;
import COM.ibm.jaws.util.*;
import COM.ibm.jaws.services.sroot.SimpleRootBC;


public class Test
{
    public static void
    main(String args[])
    {
	Debug d = new Debug(null, true);


	if (args.length != 1) {
	    System.err.println("Usage: Populate baseDirectory");
	    System.exit(1);
	}


	String baseDirectory = args[0];


	BaseCollection srootBC =
	    SimpleRootBC.getRoot(baseDirectory + "/trsApplicationSpace");
	
	Session session =
	    (Session) srootBC.resolve("session");

	BaseCollection applicationRoot =
	    (BaseCollection) srootBC.resolve("trsApplicationRoot");

	BaseCollection userBC =
	    (BaseCollection) applicationRoot.resolve("userBC");

	BaseCollection airlineCompanyBC =
	    (BaseCollection) applicationRoot.resolve("airlineCompanyBC");

	BaseCollection airportBC =
	    (BaseCollection) applicationRoot.resolve("airportBC");

	BaseCollection flightReservationBC =
	    (BaseCollection) applicationRoot.resolve("flightReservationBC");

	BaseCollection carReservationBC =
	    (BaseCollection) applicationRoot.resolve("carReservationBC");

	BaseCollection cityBC =
	    (BaseCollection) applicationRoot.resolve("cityBC");

	BaseCollection contactBC =
	    (BaseCollection) applicationRoot.resolve("contactBC");

	BaseCollection creditCardBC =
	    (BaseCollection) applicationRoot.resolve("creditCardBC");

	BaseCollection flightBC =
	    (BaseCollection) applicationRoot.resolve("flightBC");

	BaseCollection flightPlanBC =
	    (BaseCollection) applicationRoot.resolve("flightPlanBC");

	BaseCollection hotelReservationBC =
	    (BaseCollection) applicationRoot.resolve("hotelReservationBC");

	BaseCollection planeBC =
	    (BaseCollection) applicationRoot.resolve("planeBC");

	BaseCollection travelProfileBC =
	    (BaseCollection) applicationRoot.resolve("travelProfileBC");

	BaseCollection tripBC =
	    (BaseCollection) applicationRoot.resolve("tripBC");

	BaseCollection roomGroupBC =
	    (BaseCollection) applicationRoot.resolve("roomGroupBC");

	BaseCollection carFleetBC =
	    (BaseCollection) applicationRoot.resolve("carFleetBC");


	Iterator cities = session.getCities();
	if (cities != null) {
	    City city = null;
	    while ((city = (City) cities.getNext()) != null) {
		d.outln(city.getName() + ", " +
			city.getState().getAbbreviation() + ", " +
			city.getState().getCountry().getAbbreviation());
	    }
	}

	Iterator i = userBC.evaluate(null, "MOFW::objects");
	if (i != null) {
	    User user = null;
	    while ((user = (User) i.getNext()) != null) {
		d.outln("-----------------------------");
		d.outln("User");
		d.outln("" + user);
		d.outln("Home contact:");
		d.outln("" + user.getHomeContact());
		d.outln("Employer contact:");
		d.outln("" + user.getEmployerContact());
		
		TravelProfile travelProfile = user.getTravelProfile();
		if (travelProfile != null) {
		    d.outln("Preferred credit card: ");
		    d.outln("" + travelProfile.getPreferredCreditCard());
		    Iterator j = travelProfile.getCreditCards();
		    if (j != null) {
			CreditCard creditCard = null;
			while ((creditCard = (CreditCard) j.getNext()) != null) {
			    d.outln("" + creditCard);
			}
		    }
		}


		Iterator trips = null;
		if ((trips = user.getTrips("Pending")) == null) {
		    continue;
		}
		Trip trip = null;
		while ((trip = (Trip) trips.getNext()) != null) {

		    d.outln("" + trip);


		    Flight flight;
		    Iterator flights;
		    FlightReservation flightReservation = null;
		    if ((flightReservation =
			 trip.getDepartureFlightReservation()) != null) {

			d.outln("Departure flight reservation:");
			d.outln("" + flightReservation.getFlight().
				getFlightPlan().getFlightNumber());
			d.outln("" + flightReservation.getFlight().
				getDepartureDateTime());
			d.outln("" + flightReservation);
		    }
		    else {
			if ((flights =
			     trip.getDepartureFlights("first class")) == null) {
			    continue;
			}
		    
			d.outln("Departure flights matching criteria:");
			while ((flight = (Flight) flights.getNext()) != null) {
			    d.outln("" + flight);
			}
		    }

		
		    flightReservation = null;
		    if ((flightReservation =
			 trip.getReturnFlightReservation()) != null) {
			
			d.outln("Return flight reservation:");
			d.outln("" + flightReservation.getFlight().
				getFlightPlan().getFlightNumber());
			d.outln("" + flightReservation.getFlight().
				getDepartureDateTime());
			d.outln("" + flightReservation);
			d.outln("" + flightReservation.getConfirmationNumber());
		    }
		    else {
			if ((flights =
			     trip.getReturnFlights("first class")) == null) {
			    continue;
			}
			
			d.outln("Return flights matching criteria:");
			while ((flight = (Flight) flights.getNext()) != null) {
			    d.outln("" + flight);
			}
		    }
		    
		    
		    d.outln("getHotelReservation(): " +
			    trip.getHotelReservation());
		    HotelReservation hotelReservation = null;
		    if ((hotelReservation = trip.getHotelReservation()) != null) {
			d.outln("Hotel reservation:");
			d.outln("" + hotelReservation.getRoomGroup().
				getHotelCompany().getName());
			d.outln("" + hotelReservation.getRoomGroup().getName());
			d.outln("" + hotelReservation.getConfirmationNumber());
		    }
		    else {
			Iterator roomGroups = trip.getRoomGroups(200);
			if (roomGroups != null) {
			    RoomGroup roomGroup = null;
			    d.outln("Room groups matching criteria:");
			    while ((roomGroup =
				    (RoomGroup) roomGroups.getNext()) != null) {
				d.outln("-----------------------------");
				d.outln("RoomGroup:");
				d.outln("" + roomGroup.getHotelCompany().
					getName());
				d.outln("" +
					roomGroup.getCity().getName());
				d.outln("" + roomGroup);
			    }
			}
		    }


		    d.outln("getCarReservation(): " + trip.getCarReservation());
		    CarReservation carReservation = null;
		    if ((carReservation = trip.getCarReservation()) != null) {
			d.outln("Car reservation:");
			d.outln("" + carReservation.getCarFleet().
				getCarRentalCompany().getName());
			d.outln("" + carReservation.getCarFleet().getName());
			d.outln("" + carReservation.getConfirmationNumber());
		    }
		    else {
			Iterator carFleets = trip.getCarFleets("Economy");
			if (carFleets != null) {
			    CarFleet carFleet = null;
			    d.outln("Car fleets matching criteria:");
			    while ((carFleet =
				    (CarFleet) carFleets.getNext()) != null) {
				d.outln("-----------------------------");
				d.outln("CarFleet:");
				d.outln("" + carFleet.getCarRentalCompany().
					getName());
				d.outln("" +
					carFleet.getAirport().getCity().getName());
				d.outln("" + carFleet);
			    }
			}
		    }
		}
	    }
	}


	// 	//---------------------------------------------------------------------
	// 	// Airline companies
	// 	//
	// 	i = airlineCompanyBC.evaluate(null, "MOFW::objects");
	// 	AirlineCompany airlineCompany = null;
	// 	while ((airlineCompany = (AirlineCompany) i.getNext()) != null) {
	// 	    d.outln("-----------------------------");
	// 	    d.outln("AirlineCompany\n" + airlineCompany);
	// 	    d.outln("Contact:\n" + airlineCompany.getContact());

	// 	    Iterator planes = airlineCompany.getPlanes();
	// 	    Plane plane = null;
	// 	    while ((plane = (Plane) planes.getNext()) != null) {
	// 		d.outln("Plane:\n" + plane);
	// 	    }

	// 	    Iterator flightPlans = airlineCompany.getFlightPlans();
	// 	    FlightPlan flightPlan = null;
	// 	    while ((flightPlan = (FlightPlan) flightPlans.getNext()) != null) {
	// 		d.outln("FlightPlan:\n" + flightPlan);
	// 		d.outln(flightPlan.getDepartureAirport());
	// 		d.outln(flightPlan.getDestinationAirport());

	// 		Iterator flights = flightPlan.getFlights();
	// 		if (flights == null) {
	// 		    break;
	// 		}
	// 		Flight flight = null;
	// 		while ((flight = (Flight) flights.getNext()) != null) {
	// 		    d.outln("Flight:\n" + flight);
	// 		    d.outln(flight.getPlane());
	// 		}
	// 	    }
	// 	}


	// 	i = airlineCompanyBC.evaluate(null, "MOFW::objects");
	// 	AirlineCompany airlineCompany2 = null;
	// 	while ((airlineCompany2 = (AirlineCompany) i.getNext()) != null) {
	// 	    d.outln("-----------------------------");
	// 	    d.outln("AirlineCompany: " + airlineCompany2);
	// 	}


	// 	i = airportBC.evaluate(null, "MOFW::objects");
	// 	Airport airport = null;
	// 	while ((airport = (Airport) i.getNext()) != null) {
	// 	    d.outln("-----------------------------");
	// 	    d.outln("Airport");
	// 	    d.outln(airport);
	// 	}


	// 	i = cityBC.evaluate(null, "MOFW::objects");
	// 	city = null;
	// 	while ((city = (City) i.getNext()) != null) {
	// 	    d.outln("-----------------------------");
	// 	    d.outln("City");
	// 	    d.outln(city);
	// 	} 


	// 	i = contactBC.evaluate(null, "MOFW::objects");
	// 	Contact contact = null;
	// 	while ((contact = (Contact) i.getNext()) != null) {
	// 	    d.outln("-----------------------------");
	// 	    d.outln("Contact");
	// 	    d.outln(contact);
	// 	}


	// 	i = creditCardBC.evaluate(null, "MOFW::objects");
	// 	CreditCard creditCard = null;
	// 	while ((creditCard = (CreditCard) i.getNext()) != null) {
	// 	    d.outln("-----------------------------");
	// 	    d.outln("CreditCard");
	// 	    d.outln(creditCard);
	// 	}


	// 	i = flightBC.evaluate(null, "MOFW::objects");
	// 	Flight flight = null;
	// 	while ((flight = (Flight) i.getNext()) != null) {
	// 	    d.outln("-----------------------------");
	// 	    d.outln("Flight");
	// // 	    d.outln(flight);
	// 	    d.outln(flight.getNumberSeatsReserved());
	// 	}


	// 	i = flightPlanBC.evaluate(null, "MOFW::objects");
	// 	FlightPlan flightPlan = null;
	// 	while ((flightPlan = (FlightPlan) i.getNext()) != null) {
	// 	    d.outln("-----------------------------");
	// 	    d.outln("FlightPlan");
	// 	    d.outln(flightPlan);
	// 	}


	// 	i = planeBC.evaluate(null, "MOFW::objects");
	// 	Plane plane = null;
	// 	while ((plane = (Plane) i.getNext()) != null) {
	// 	    d.outln("-----------------------------");
	// 	    d.outln("Plane");
	// 	    d.outln(plane);
	// 	}


	// 	i = travelProfileBC.evaluate(null, "MOFW::objects");
	// 	TravelProfile travelProfile = null;
	// 	while ((travelProfile = (TravelProfile) i.getNext()) != null) {
	// 	    d.outln("-----------------------------");
	// 	    d.outln("TravelProfile: " + travelProfile);
	// 	}


	// 	Iterator roomGroups = roomGroupBC.evaluate(null, "MOFW::objects");
	// 	RoomGroup roomGroup = null;
	// 	while ((roomGroup = (RoomGroup) roomGroups.getNext()) != null) {
	// 	    d.outln("-----------------------------");
	// 	    d.outln("RoomGroup:");
	// 	    d.outln("" + roomGroup.getHotelCompany().getName());
	// 	    d.outln("" + roomGroup.getHotelCompany().getContact().getCity().getName());
	// 	    d.outln("" + roomGroup);
	// 	}

	// 	d.outln("Getting carFleets.");
	// 	Iterator carFleets = carFleetBC.evaluate(null, "MOFW::objects");
	// 	if (carFleets == null) {
	// 	    d.outln("No car fleets exist.");
	// 	}
	// 	else {
	// 	    CarFleet carFleet = null;
	// 	    while ((carFleet = (CarFleet) carFleets.getNext()) != null) {
	// 		d.outln("-----------------------------");
	// 		d.outln("CarFleet:");
	// 		d.outln("" + carFleet.getCarRentalCompany().
	// 			getName());
	// 		d.outln("" + carFleet.getAirport().getCity().getName());
	// 		d.outln("" + carFleet);
	// 	    }
	// 	}
    }
}
