package COM.ibm.jaws.models.trs;


import COM.ibm.jaws.mofw.*;
import java.util.*;


abstract public class TravelProfileBase extends CommonBase
{
    protected Object user = null;
    protected ReferenceCollection creditCardRC = null;
    protected CreditCard preferredCreditCard = null;


    public
    TravelProfileBase()
    {
    }


    public
    TravelProfileBase(Object user)
    {
	this.user = user;
    }


    public CreditCard
    addCreditCard(String type,
		  String number,
		  Date expirationDate)
    {
	// Implement the lazy create for the local trip reference collection
	// if this is the first trip added for this user.
	if (creditCardRC == null) {
	    creditCardRC = (ReferenceCollection)
		travelProfileCreditCardRCBC().createFromCopy(null, null, null);
	}

	// New up the manageable trip object.
	CreditCard creditCard = new CreditCardImpl(self,
						   type,
						   number,
						   expirationDate);

	// Resolve the application's credit card base collection, and add the
	// credit card to the BC, managing it.
	CreditCard creditCardManaged =
	    (CreditCard) creditCardBC().createFromCopy(null, creditCard, null);
	

	// Insert the managed trip into the local reference collection.
	creditCardRC.insertElement(creditCardManaged);

	return creditCardManaged;
    }


    public Iterator
    getCreditCards()
    {
	if (creditCardRC == null) {
	    return null;
	}
	
	return creditCardRC.evaluate(null, "MOFW::objects");
    }


    public void
    setPreferredCreditCard(CreditCard creditCard)
    {
	preferredCreditCard = creditCard;
    }


    public CreditCard
    getPreferredCreditCard()
    {
	return preferredCreditCard;
    }


    public String
    toString()
    {
	return super.toString();
    }
}
