package COM.ibm.jaws.models.trs;


import COM.ibm.jaws.mofw.*;
import java.util.*;


public interface Trip extends Common
{
    public String
    toString();

    public CarReservation
    reserveCar(CarFleet carFleet,
	       int numberTraveling);

    public FlightReservation
    reserveDepartureFlight(Flight flight,
			   int numberTraveling,
			   String seat);

    public HotelReservation
    reserveHotel(RoomGroup roomGroup,
		 int numberTraveling);

    public FlightReservation
    reserveReturnFlight(Flight flight,
			int numberTraveling,
			String seat);

    public void
    cancel();

    //@BC begin
    public void
    cancelDepartureFlightReservation();

    public void
    cancelReturnFlightReservation();

    public void
    cancelCarReservation();

    public void
    cancelHotelReservation();
    //@BC end

    public void
    changeDepartureCity(String city);

    public void
    changeDepartureDate(Date date);

    public void
    changeDestinationCity(String city);

    public void
    changeName(String newName);

    public void
    changeReturnDate(Date date);

    public void
    confirm(CreditCard creditCard);

    public Iterator
    getCarFleets(String fleetName);

    public CarReservation
    getCarReservation();

    public City
    getDepartureCity();

    public City
    getDestinationCity();

    public Date
    getDepartureDate();

    public FlightReservation
    getDepartureFlightReservation();

    public Iterator
    getDepartureFlights(String classOfService);

    public HotelReservation
    getHotelReservation();

    public String
    getName();

    public FlightReservation
    getReturnFlightReservation();

    public Date
    getReturnDate();

    public Iterator
    getReturnFlights(String classOfService);

    public Iterator
    getRoomGroups(int maxRate);

    public String
    getStatus();

    public void
    setStatus(String s);

    public void
    remove();

    public void
    taken();
}
