/*
 *  This file was automatically generated from the class file:
 *        COM.ibm.jaws.models.trs.Trip
 */

package COM.ibm.jaws.models.trs;
import COM.ibm.jaws.mofw.*;
import COM.ibm.jaws.services.bcfw.*;  
import COM.ibm.jaws.services.lrucmgr.*;  
import COM.ibm.jaws.services.filepobc.*; 
// Class specific imports
import java.util.Date;
import COM.ibm.jaws.mofw.Iterator;
import java.lang.String;
import java.lang.Object;

/**
 * The emitted ManagedDel class derived from:
 *         COM.ibm.jaws.models.trs.Trip
 * @see COM.ibm.jaws.models.trs.Trip
 */
public class TripFilepoManaged
          implements Trip, 
                     FilepoManaged,
                     Syncable
{
  private FilepoBC   baseCollection; 
  private String     key; 
  private TripFilepoCached cached;  // null ==> not attached

  /**
   * Ensure we have a default constructor method - if there is
   * another constructor, Java does not provide a default one. 
   */
  public TripFilepoManaged() {};

   /** 
    * Implementation of the ManagedDel interface methods.
    */
   public void setManagedDelBase(BaseCollection bc) { 
      baseCollection = (FilepoBC)bc; 
   } 

   public BaseCollection getManagedDelBase() { 
      return baseCollection; 
   }  

   public void setManagedDelKey(String yourKey) { 
      key = yourKey; 
   } 

   public String getManagedDelKey() { 
      return key; 
   }   

   public void setManagedDelCacheEntry(CacheEntry ce) { 
      cached = (TripFilepoCached) ce; 
   } 

   public CacheEntry getManagedDelCacheEntry() { 
      return cached;  
   } 

   /**
    * Implementation of the Managed Lifecycle.remove() interface. 
    * The Managed Lifecycle.release() is never used in the Java
    * bindings for Corba. 
    */ 
   public void remove() { 
      try { 
         // If this Managed object exists, deletes the file and 
         // uncaches object. 
         baseCollection.kill(key); 
      } 
      catch (InvalidReferenceException e) { 
         throw new InvalidReferenceException();  
      } 
   } 
   public void release() {} 

   /** 
    * Implementation of the Managed.getIdentifier() method.
    */ 
   public String getIdentifier(BaseCollection relativeTo) { 
      // my BC is never null. 
      if ( baseCollection instanceof Managed ) { 
         if ( !(relativeTo instanceof Managed) ) { // my BC is not the relativeTo
            return new String( ((Managed)baseCollection).getIdentifier(relativeTo)
                               + "/" + key ); 
         }
         else { // both are Managed
            if ( !( ((Managed)baseCollection).isIdentical((Identifiable)relativeTo) ) ) 
               // my BC is not the relativeTo
               return new String( ((Managed)baseCollection).getIdentifier(relativeTo) 
                               + "/" + key ); 
            return key; // my BC is the relativeTo
         } 
      }
      return key; // my BC is a root BC
   }  

/* 
   // Implementation of the getInterfaceName() method. 
   public String getInterfaceName() { 
     String managedSuffix = baseCollection.getManagedSuffix(); 
     Class managedClass = this.getClass(); 
     String managedClassName = managedClass.getName();
     int suffixIndex = managedClassName.indexOf(managedSuffix); // 1st char of suffix
     return managedClassName.substring(0, suffixIndex); 
   } 
*/

   /**
    * Implementation of the Managed's Identifiable methods.   
    * Does not activate the objects unnecessarily.
    */ 
   public boolean isIdentical(Identifiable other) {  
      if (other instanceof Managed) 
         return getIdentifier(null).equals(
                         ((Managed) other).getIdentifier(null)); 
      else 
         return false;
   }  

   public int getConstantRandomId() { 
      String identifier = this.getIdentifier(null); 
      // Use the java.lang.String.hashCode() for this EVERYWHERE! 
      return identifier.hashCode(); 
   } 

   /** 
    * Implementation of the Syncable.sync() method.
    */ 
   public void sync() {  
      // Handle case where target has been remove()ed.
      if (cached == null) {
         if ( !baseCollection.exists(key) )  {
            throw new InvalidReferenceException(); 
         }
      } // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      baseCollection.syncManaged(key); 
      cached.unholdCacheEntry(); 
   } 

  public CarReservation reserveCar(CarFleet parm1,
                                   int parm2)
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      CarReservation value = 
           cached.reserveCar(parm1,
                             parm2);
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public FlightReservation reserveDepartureFlight(Flight parm1,
                                                  int parm2,
                                                  String parm3)
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      FlightReservation value = 
           cached.reserveDepartureFlight(parm1,
                                         parm2,
                                         parm3);
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public HotelReservation reserveHotel(RoomGroup parm1,
                                       int parm2)
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      HotelReservation value = 
           cached.reserveHotel(parm1,
                               parm2);
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public FlightReservation reserveReturnFlight(Flight parm1,
                                               int parm2,
                                               String parm3)
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      FlightReservation value = 
           cached.reserveReturnFlight(parm1,
                                      parm2,
                                      parm3);
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public void cancel()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
           cached.cancel();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
  }
  public void cancelDepartureFlightReservation()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
           cached.cancelDepartureFlightReservation();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
  }
  public void cancelReturnFlightReservation()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
           cached.cancelReturnFlightReservation();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
  }
  public void cancelCarReservation()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
           cached.cancelCarReservation();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
  }
  public void cancelHotelReservation()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
           cached.cancelHotelReservation();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
  }
  public void changeDepartureCity(String parm1)
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
           cached.changeDepartureCity(parm1);
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
  }
  public void changeDepartureDate(java.util.Date parm1)
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
           cached.changeDepartureDate(parm1);
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
  }
  public void changeDestinationCity(String parm1)
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
           cached.changeDestinationCity(parm1);
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
  }
  public void changeName(String parm1)
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
           cached.changeName(parm1);
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
  }
  public void changeReturnDate(java.util.Date parm1)
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
           cached.changeReturnDate(parm1);
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
  }
  public void confirm(CreditCard parm1)
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
           cached.confirm(parm1);
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
  }
  public COM.ibm.jaws.mofw.Iterator getCarFleets(String parm1)
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.Iterator value = 
           cached.getCarFleets(parm1);
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public CarReservation getCarReservation()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      CarReservation value = 
           cached.getCarReservation();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public City getDepartureCity()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      City value = 
           cached.getDepartureCity();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public City getDestinationCity()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      City value = 
           cached.getDestinationCity();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public java.util.Date getDepartureDate()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      java.util.Date value = 
           cached.getDepartureDate();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public FlightReservation getDepartureFlightReservation()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      FlightReservation value = 
           cached.getDepartureFlightReservation();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.Iterator getDepartureFlights(String parm1)
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.Iterator value = 
           cached.getDepartureFlights(parm1);
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public HotelReservation getHotelReservation()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      HotelReservation value = 
           cached.getHotelReservation();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public String getName()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      String value = 
           cached.getName();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public FlightReservation getReturnFlightReservation()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      FlightReservation value = 
           cached.getReturnFlightReservation();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public java.util.Date getReturnDate()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      java.util.Date value = 
           cached.getReturnDate();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.Iterator getReturnFlights(String parm1)
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.Iterator value = 
           cached.getReturnFlights(parm1);
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.Iterator getRoomGroups(int parm1)
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.Iterator value = 
           cached.getRoomGroups(parm1);
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public String getStatus()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      String value = 
           cached.getStatus();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public void setStatus(String parm1)
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
           cached.setStatus(parm1);
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
  }
  public void taken()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
           cached.taken();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
  }
  public String toString()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      String value = 
           cached.toString();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection airlinePlaneRCBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.airlinePlaneRCBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection roomGroupBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.roomGroupBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public void internalizeFromStream(COM.ibm.jaws.mofw.InputEDStream parm1)
        throws COM.ibm.jaws.mofw.EDStreamFormatError
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
           cached.internalizeFromStream(parm1);
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
  }
  public COM.ibm.jaws.mofw.BaseCollection carBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.carBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection flightPlanFlightRCBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.flightPlanFlightRCBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection carFleetBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.carFleetBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public void setDependentContext(COM.ibm.jaws.mofw.KeyedCollection parm1)
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
           cached.setDependentContext(parm1);
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
  }
  public COM.ibm.jaws.mofw.BaseCollection hotelCompanyBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.hotelCompanyBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection confirmationBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.confirmationBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public void setSelf(Object parm1)
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
           cached.setSelf(parm1);
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
  }
  public COM.ibm.jaws.mofw.BaseCollection carReservationBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.carReservationBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection planeBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.planeBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection countryBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.countryBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection airlineFlightPlanRCBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.airlineFlightPlanRCBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection cityBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.cityBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection carFleetCarFleetAvailabilityRCBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.carFleetCarFleetAvailabilityRCBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection tripReservationRCBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.tripReservationRCBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection carFleetAvailabilityBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.carFleetAvailabilityBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection hotelReservationBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.hotelReservationBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection flightPlanBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.flightPlanBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection contactBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.contactBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection travelProfileCreditCardRCBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.travelProfileCreditCardRCBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection hotelRoomRCBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.hotelRoomRCBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection airlineCompanyBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.airlineCompanyBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection userTripRCBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.userTripRCBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection applicationRootBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.applicationRootBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public void externalizeToStream(COM.ibm.jaws.mofw.OutputEDStream parm1)
        throws COM.ibm.jaws.mofw.EDStreamFormatError
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
           cached.externalizeToStream(parm1);
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
  }
  public COM.ibm.jaws.mofw.BaseCollection tripBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.tripBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection travelProfileBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.travelProfileBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection roomGroupAvailabilityBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.roomGroupAvailabilityBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection roomGroupRoomGroupAvailabilityRCBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.roomGroupRoomGroupAvailabilityRCBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection userBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.userBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection stateBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.stateBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection carRentalCarFleetRCBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.carRentalCarFleetRCBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection carFleetCarRCBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.carFleetCarRCBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection carRentalCompanyBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.carRentalCompanyBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection creditCardBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.creditCardBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection airportBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.airportBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection flightBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.flightBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection carRentalCarRCBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.carRentalCarRCBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public COM.ibm.jaws.mofw.BaseCollection flightReservationBC()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (TripFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      COM.ibm.jaws.mofw.BaseCollection value = 
           cached.flightReservationBC();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
} // end of class TripFilepoManaged
