/*
 *  Source file: TripBase.java
 *  Class file:  COM.ibm.jaws.models.trs.TripBase
 */

package COM.ibm.jaws.models.trs;

import COM.ibm.jaws.mofw.*;
import java.lang.StringBuffer;
import java.util.Date;
import COM.ibm.jaws.mofw.Iterator;
import java.lang.String;
import COM.ibm.jaws.util.Debug;
import COM.ibm.jaws.mofw.QueryableCollection;
import COM.ibm.jaws.mofw.BaseCollection;
import java.util.StringTokenizer;
import java.lang.Integer;
import java.lang.Object;
import java.util.Vector;

/**
 * This is the implementation class for the interface Trip.
 * @see COM.ibm.jaws.models.trs.TripBase
 * @see COM.ibm.jaws.models.trs.Trip
 */
public class TripImpl
	extends TripBase
        implements Trip,
	           COM.ibm.jaws.motk.Activation {

  public  TripImpl()
  {
    super();
  }

  public  TripImpl(Object parm1,
                   String parm2,
                   String parm3,
                   String parm4,
                   java.util.Date parm5,
                   java.util.Date parm6)
  {
    super(parm1, parm2, parm3, parm4, parm5, parm6);
  }

  public void externalizeToStream(OutputEDStream out)
  {
    prepareForExternalization();
    out.writeObject(backPointer);
    out.writeObject(name);
    out.writeObject(status);
    out.writeObject(departureCity);
    out.writeObject(departureCityString);
    out.writeObject(destinationCity);
    out.writeObject(destinationCityString);
    out.writeObject(departureDateString);
    out.writeObject(returnDateString);
    out.writeObject(carReservation);
    out.writeObject(hotelReservation);
    out.writeObject(departureFlightReservation);
    out.writeObject(returnFlightReservation);
  }

  public void internalizeFromStream(InputEDStream in)
  {
    backPointer = (Object) in.readObject();
    name = (String) in.readObject();
    status = (String) in.readObject();
    departureCity = (City) in.readObject();
    departureCityString = (String) in.readObject();
    destinationCity = (City) in.readObject();
    destinationCityString = (String) in.readObject();
    departureDateString = (String) in.readObject();
    returnDateString = (String) in.readObject();
    carReservation = (CarReservation) in.readObject();
    hotelReservation = (HotelReservation) in.readObject();
    departureFlightReservation = (FlightReservation) in.readObject();
    returnFlightReservation = (FlightReservation) in.readObject();
    activate();
  }

  /**
   * See <a href="COM.ibm.jaws.mofw.Lifecycle#release">Lifecycle.release</a>
   */
  public void release() {}

} // end of class: TripImpl
