/*
 *  Source file: UserBase.java
 *  Class file:  COM.ibm.jaws.models.trs.UserBase
 */

package COM.ibm.jaws.models.trs;

import COM.ibm.jaws.mofw.*;
import java.lang.StringBuffer;
import java.util.Date;
import COM.ibm.jaws.mofw.Iterator;
import java.lang.String;
import COM.ibm.jaws.mofw.ReferenceCollection;
import COM.ibm.jaws.util.Debug;
import COM.ibm.jaws.mofw.QueryableCollection;
import COM.ibm.jaws.mofw.BaseCollection;
import java.util.StringTokenizer;
import java.lang.Integer;
import java.util.Vector;

/**
 * This is the implementation class for the interface User.
 * @see COM.ibm.jaws.models.trs.UserBase
 * @see COM.ibm.jaws.models.trs.User
 */
public class UserImpl
	extends UserBase
        implements User,
	           COM.ibm.jaws.motk.Activation {

  public  UserImpl()
  {
    super();
  }

  public  UserImpl(String parm1,
                   String parm2,
                   String parm3,
                   String parm4,
                   String parm5,
                   String parm6,
                   String parm7,
                   java.util.Date parm8,
                   String parm9,
                   String parm10)
  {
    super(parm1, parm2, parm3, parm4, parm5, parm6, parm7, parm8, parm9, parm10);
  }

  public void externalizeToStream(OutputEDStream out)
  {
    prepareForExternalization();
    out.writeObject(lastName);
    out.writeObject(firstName);
    out.writeObject(middleName);
    out.writeObject(prefix);
    out.writeObject(userId);
    out.writeObject(password);
    out.writeObject(socialSecurityNumber);
    out.writeObject(birthdateString);
    out.writeObject(driversLicenseNumber);
    out.writeObject(driversLicenseState);
    out.writeObject(homeContact);
    out.writeObject(employer);
    out.writeObject(employerContact);
    out.writeObject(travelProfile);
    out.writeObject(tripRC);
  }

  public void internalizeFromStream(InputEDStream in)
  {
    lastName = (String) in.readObject();
    firstName = (String) in.readObject();
    middleName = (String) in.readObject();
    prefix = (String) in.readObject();
    userId = (String) in.readObject();
    password = (String) in.readObject();
    socialSecurityNumber = (String) in.readObject();
    birthdateString = (String) in.readObject();
    driversLicenseNumber = (String) in.readObject();
    driversLicenseState = (String) in.readObject();
    homeContact = (Contact) in.readObject();
    employer = (String) in.readObject();
    employerContact = (Contact) in.readObject();
    travelProfile = (TravelProfile) in.readObject();
    tripRC = (ReferenceCollection) in.readObject();
    activate();
  }

  /**
   * See <a href="COM.ibm.jaws.mofw.Lifecycle#release">Lifecycle.release</a>
   */
  public void release() {}

  /**
   * See <a href="COM.ibm.jaws.mofw.Lifecycle#remove">Lifecycle.remove</a>
   */
  public void remove() {}

} // end of class: UserImpl
