/*
 *  This file was automatically generated from the class file:
 *        COM.ibm.jaws.tutorial1.Account
 */

package COM.ibm.jaws.tutorial1;
import COM.ibm.jaws.mofw.*;
import COM.ibm.jaws.services.bcfw.*;  
import COM.ibm.jaws.services.lrucmgr.*;  
import COM.ibm.jaws.services.filepobc.*; 
// Class specific imports
import COM.ibm.jaws.mofw.Manageable;
import java.lang.Object;

/**
 * The emitted ManagedDel class derived from:
 *         COM.ibm.jaws.tutorial1.Account
 * @see COM.ibm.jaws.tutorial1.Account
 */
public class AccountFilepoManaged
          implements Account, 
                     FilepoManaged,
                     Syncable
{
  private FilepoBC   baseCollection; 
  private String     key; 
  private AccountFilepoCached cached;  // null ==> not attached

  /**
   * Ensure we have a default constructor method - if there is
   * another constructor, Java does not provide a default one. 
   */
  public AccountFilepoManaged() {};

   /** 
    * Implementation of the ManagedDel interface methods.
    */
   public void setManagedDelBase(BaseCollection bc) { 
      baseCollection = (FilepoBC)bc; 
   } 

   public BaseCollection getManagedDelBase() { 
      return baseCollection; 
   }  

   public void setManagedDelKey(String yourKey) { 
      key = yourKey; 
   } 

   public String getManagedDelKey() { 
      return key; 
   }   

   public void setManagedDelCacheEntry(CacheEntry ce) { 
      cached = (AccountFilepoCached) ce; 
   } 

   public CacheEntry getManagedDelCacheEntry() { 
      return cached;  
   } 

   /**
    * Implementation of the Managed Lifecycle.remove() interface. 
    * The Managed Lifecycle.release() is never used in the Java
    * bindings for Corba. 
    */ 
   public void remove() { 
      try { 
         // If this Managed object exists, deletes the file and 
         // uncaches object. 
         baseCollection.kill(key); 
      } 
      catch (InvalidReferenceException e) { 
         throw new InvalidReferenceException();  
      } 
   } 
   public void release() {} 

   /** 
    * Implementation of the Managed.getIdentifier() method.
    */ 
   public String getIdentifier(BaseCollection relativeTo) { 
      // my BC is never null. 
      if ( baseCollection instanceof Managed ) { 
         if ( !(relativeTo instanceof Managed) ) { // my BC is not the relativeTo
            return new String( ((Managed)baseCollection).getIdentifier(relativeTo)
                               + "/" + key ); 
         }
         else { // both are Managed
            if ( !( ((Managed)baseCollection).isIdentical((Identifiable)relativeTo) ) ) 
               // my BC is not the relativeTo
               return new String( ((Managed)baseCollection).getIdentifier(relativeTo) 
                               + "/" + key ); 
            return key; // my BC is the relativeTo
         } 
      }
      return key; // my BC is a root BC
   }  

/* 
   // Implementation of the getInterfaceName() method. 
   public String getInterfaceName() { 
     String managedSuffix = baseCollection.getManagedSuffix(); 
     Class managedClass = this.getClass(); 
     String managedClassName = managedClass.getName();
     int suffixIndex = managedClassName.indexOf(managedSuffix); // 1st char of suffix
     return managedClassName.substring(0, suffixIndex); 
   } 
*/

   /**
    * Implementation of the Managed's Identifiable methods.   
    * Does not activate the objects unnecessarily.
    */ 
   public boolean isIdentical(Identifiable other) {  
      if (other instanceof Managed) 
         return getIdentifier(null).equals(
                         ((Managed) other).getIdentifier(null)); 
      else 
         return false;
   }  

   public int getConstantRandomId() { 
      String identifier = this.getIdentifier(null); 
      // Use the java.lang.String.hashCode() for this EVERYWHERE! 
      return identifier.hashCode(); 
   } 

   /** 
    * Implementation of the Syncable.sync() method.
    */ 
   public void sync() {  
      // Handle case where target has been remove()ed.
      if (cached == null) {
         if ( !baseCollection.exists(key) )  {
            throw new InvalidReferenceException(); 
         }
      } // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      baseCollection.syncManaged(key); 
      cached.unholdCacheEntry(); 
   } 

  public void deposit(float parm1)
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (AccountFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
           cached.deposit(parm1);
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
  }
  public void withdrawal(float parm1)
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (AccountFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
           cached.withdrawal(parm1);
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
  }
  public float getBalance()
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (AccountFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
      float value = 
           cached.getBalance();
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
      return value; 
  }
  public void externalizeToStream(COM.ibm.jaws.mofw.OutputEDStream parm1)
        throws COM.ibm.jaws.mofw.EDStreamFormatError
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (AccountFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
           cached.externalizeToStream(parm1);
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
  }
  public void internalizeFromStream(COM.ibm.jaws.mofw.InputEDStream parm1)
        throws COM.ibm.jaws.mofw.EDStreamFormatError
  {
      if (cached == null) {     // detached from CacheEntry
         try { 
            cached = (AccountFilepoCached) baseCollection.reattachManagedDel(this, key); 
         } 
         catch (InvalidReferenceException e) {
	   e.printStackTrace();
           throw new InvalidReferenceException(); 
         } 
      }   // at this point in code, cached is not null
      cached.holdCacheEntry(); 
           cached.internalizeFromStream(parm1);
      // For usedCacheEntry parameter, 
      // used true if method updates EssentialData and false otherwise.
      // Emitter needs to add this info (whether it updates) to methods. 
      cached.usedCacheEntry(true);  
      cached.unholdCacheEntry(); 
  }
} // end of class AccountFilepoManaged
